//点击怪物
let clickMonster = false;
$('.body').on('click','.monster',function(){
    if(clickMonster){
        return;
    }
    clickMonster = true;
    setTimeout(() => {
        clickMonster = false;
    },50)
    startBattle($(this).attr('data-name'), true);
    //存档
    save();
})

//开始战斗
function startBattle(name, playerAtkMonster, needDistorted, mustAtk, id){
    if(inBattle()){
        battleEnd();
        return;
    }
    $('.alert-win').hide();
    $('.time-shuttle').hide();
    data.safeRun = false;

    if(data.race.name.startsWith('操脑蛛') && !data.control && !id){
        if(!data.inDungeon && data.level >= monsterCfgs[name].level && !monsterCfgs[name].type){
            if(confirm(`你是否要操纵${name}？`)){
                data.control = createBattleMonster(name, true);
                data.race.control();
                data.level -= data.control.level;
                if(data.level < 1){
                    data.level = 1;
                }
                initAttr();
                if(data.preBag && getBagItemById(data.preBag)){
                    equipBag(getBagItemById(data.preBag))
                }
                if(data.preMount && getBagItemById(data.preMount)){
                    equipMount(getBagItemById(data.preMount))
                }
                winMsg(`你操控了${data.control.showName || data.control.name}`)
                timeLapses(5)
            }
        }else{
            winMsg('你不能操纵这只怪物', false , false)
        }
        return;
    }

    if(name === '生命之神'){
        $('.alert-win').show().find('.alert-win-title').html('警告：打死生命之神后所有怪都会变成神罚状态，其他几个神几乎不可能打赢了，而要通关必须打其他几个神，请确定好是现在否要和生命之神战斗')
    }

    //记录原本的属性
    recordPlayerAttr();

    //初始化痴念增加的减伤
    data.cnReduceHart = 0;

    //初始化护盾
    data.shield = 0;

    //清空日志
    $('.battle-logs').html('');
    //创建战斗怪物
    if(id){
        data.battleMonster = createBattleNpc(id, playerAtkMonster);
    }else{
        data.battleMonster = createBattleMonster(name);
    }

    //触发战斗开始时触发的怪物技能
    useStartMonsterSkill();
    if(!data.battleMonster){
        return null;
    }

    //初始化怪物物品DLC的技能
    checkUseSkill()
    //是否固定扭曲，只修改属性，不增加前缀
    if(needDistorted){
        getDistortedMonster(needDistorted)
    }

    //弑魂叔战斗处理
    if(data.race.name.startsWith('弑魂叔')){
        const {hour} = getTime(data.date.getTime() - data.sleepTime);
        if(hour >= 15){
            data.atk = parseInt(data.atk * 0.5);
            data.def = parseInt(data.def * 0.2);
            addBattleLog(`你的腰痛让你甚至无法正常站立，每几十秒一次的心脏早搏让你感觉自己随时会猝死。攻击力降低50%，防御力降低80%`);
            addStatus(data, getStatus('崩溃'))
        }else if(hour >= 8){
            data.atk = parseInt(data.atk * 0.7);
            data.def = parseInt(data.def * 0.5);
            addBattleLog(`你的腰痛让你感到煎熬，攻击力降低30%，防御力降低50%`);
            addStatus(data, getStatus('煎熬'))
        }else if(hour >= 3){
            data.atk = parseInt(data.atk * 0.9);
            data.def = parseInt(data.def * 0.8);
            addBattleLog(`你感到腰痛，攻击力降低10%，防御力降低20%`);
            addStatus(data, getStatus('腰痛'))
        }
    }

    //狩猎神裔-陷阱大师处理
    if(data.race.name === '狩猎神裔-陷阱大师'){
        data.battleMonster.hp = parseInt(data.battleMonster.maxHp * 0.5)
        data.battleMonster.def = parseInt(data.battleMonster.def * 0.5)
        addStatus(data.battleMonster, getStatus('陷阱', {num : 3}))
    }

    //哥布林减伤处理
    if(data.race.name.startsWith('哥布林')){
        data.otherReduceHart = 0.3;
    }else{
        data.otherReduceHart = 0;
    }

    //装备进入战斗监听处理
    if(data.weapon && elementCfgs[data.weapon.name].onStartBattle){
        elementCfgs[data.weapon.name].onStartBattle();
    }
    if(data.armor && elementCfgs[data.armor.name].onStartBattle){
        elementCfgs[data.armor.name].onStartBattle();
    }
    if(data.mount && elementCfgs[data.mount.name].onStartBattle){
        elementCfgs[data.mount.name].onStartBattle();
    }

    //影魔属性处理
    if(data.race.name.startsWith('影魔')){
        if(getDayOrNight() === '日'){
            data.atk = parseInt(data.atk * 0.8);
            data.def = parseInt(data.def * 0.8);
        }else{
            data.atk = parseInt(data.atk * 1.2);
            data.def = parseInt(data.def * 1.2);
            addStatus(data.battleMonster, getStatus('难以观察', {num : 1, keep : true, reduceHitRate :20}))
        }
    }

    //如果是玩家主动攻击，且装备了灵魂威慑，则判断是否可以扫荡，但是不吃秒杀技能的怪不能扫荡
    if(playerAtkMonster && data.weapon && data.weapon.name === '灵魂威慑' && !mustAtk && !data.battleMonster.noOneKill && data.world.worldBoss !== data.battleMonster.name){
        //怪物不破防，且玩家能破防，则进一步判断
        if(parseInt(data.battleMonster.atk * 1.2) <= data.def && parseInt((data.atk + data.weapon.atk) * 1.2) > data.battleMonster.def){
            //如果装备了护甲，则进行模拟战斗，否则直接胜利
            if(data.armor){
                //如果护甲是永不磨损，则直接胜利
                if(data.armor.noWear){
                    battleWin(false, battleWinMin, false);
                    //减少武器耐久
                    reduceWeaponEndurance(data.weapon.id);
                    return;
                }

                //模拟战斗
                let endurance = data.armor.endurance;
                let hp = data.battleMonster.hp;
                while (endurance > 0 && hp > 0){
                    const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
                    const min = parseInt((data.atk + data.weapon.atk) * (1 - atkFloat - dlcAddFloat));
                    const max = parseInt((data.atk + data.weapon.atk) * (1 + atkFloat + dlcAddFloat));
                    const harm = randomNum(getStatuNum(data, '飞龙在天') ? max : min, max) - data.battleMonster.def;
                    if(harm > 0){
                        hp -= harm;
                    }
                    if(hp > 0 && !data.armor.noWear){
                        endurance--;
                    }
                }

                //如果模拟战斗后，怪物死亡，则获得战利品
                if(hp <= 0){
                    battleWin(false, battleWinMin, false);
                    //减少武器耐久
                    reduceWeaponEndurance(data.weapon.id);
                    data.armor.endurance = endurance;
                    data.bag.filter(e => e.id === data.armor.id)[0].endurance = endurance;
                    return;
                }else if(endurance <= 0){//如果护甲清空了，则毁掉护甲，直接进入战斗
                    /*data.bag = data.bag.filter(e => e.id !== data.armor.id);
                    data.weight -= data.armor.weight;*/

                    data.armor.endurance = 0;
                    addBattleLog(`${data.armor.showName ||data.armor.name}损坏了`)
                    msg(`${data.armor.showName ||data.armor.name}损坏了`)
                    equip(data.armor);
                }
            }else{
                battleWin(false, battleWinMin, false);
                //减少武器耐久
                reduceWeaponEndurance(data.weapon.id);
                return;
            }
        }
    }

    //巨龙特性
    if(playerAtkMonster && data.race.name.startsWith('巨龙') && !mustAtk && !data.battleMonster.type && parseInt(data.battleMonster.atk * 0.8) <= data.def && parseInt(data.atk * 1.5) > data.battleMonster.def){
        battleWin(false, battleWinMin, false);
        return;
    }

    if(!playerAtkMonster && hasAmulet('牙齿项链') && randomNum(1,100) <= 30){
        addBattleLog('你的项链传来一阵炙热感，你顿时提高警惕，发现了朝你偷袭的怪物')
        playerAtkMonster = true;
    }

    //记录原始攻防
    data.battleMonster.oldAttrs = {
        atk : data.battleMonster.atk,
        def : data.battleMonster.def
    }

    //渲染战斗页面
    renderBattlePage();
    $('.battle').show();
    $('.stop-auto-battle').hide();

    if(!playerAtkMonster && !data.race.name.startsWith('蜥蜴人')) monsterAtk();
}

//记录玩家原始属性
function recordPlayerAttr(){
    data.selfAttrs = {
        maxHunger : data.maxHunger,
        maxHp : data.maxHp,
        atk : data.atk,
        def : data.def,
        reduceHart : data.reduceHart || 0,
        atkSpd : data.atkSpd || 0,
        suck : data.suck || 0,
        spd : data.spd
    };
}

//点击使用武器
$('.weapons').on('click','.weapon',function(){
    //获取武器ID
    const id = $(this).attr('data-id');
    battleClickWeapon(id)
});

//用于自动战斗
let autoBattle = null;
//战斗中点击武器
function battleClickWeapon(id){
    if(id === 'run'){//逃跑
        if(conf.runConfirm && data.battleMonster && data.battleMonster.seePlayer && !data.battleMonster.confirmRun && !confirm('是否确定要逃跑？确定后本次战斗不再弹出该提示')){
            return;
        }

        data.battleMonster.confirmRun = true;
        //计算逃跑概率
        const runRate = runSuccessRate;
        const num = randomNum(100,100);

        //判断逃跑结果
        if(data.race.name.startsWith('星灵') || !data.battleMonster.seePlayer || runRate >= 0){
            msg('逃跑成功');
            battleEnd();
            timeLapses(battleRunMin);
        }else{
            if(!data.battleMonster.runFail){
                data.battleMonster.runFail = 0;
            }
            data.battleMonster.runFail++;
            addBattleLog(`逃跑失败。`);
            //怪物攻击
            monsterAtk();
        }
    }else if(id === 'dodge'){//闪避
        addBattleLog(`你试图闪避`);
        addStatus(data.battleMonster, getStatus('闪避' , {num : 1}))
        //怪物攻击
        monsterAtk();
    }else if(id === 'auto'){//自动攻击
        $('.stop-auto-battle').show();
        autoBattle = setInterval(function(){
            if(!data.battleMonster || data.battleMonster.hp <= 0){
                $('.stop-auto-battle').hide();
                clearInterval(autoBattle);
                clearInterval(autoBattleId);
            }else if(data.hp <= data.maxHp * 0.2){
                addBattleLog('少于20%血量停止自动攻击')
                $('.stop-auto-battle').hide();
                clearInterval(autoBattle);
                clearInterval(autoBattleId);
            }else{
                battleClickWeapon(data.weapon && data.weapon.id ? data.weapon.id : 'hand')
            }
        },50);

    }else if(id === 'hand'){//空手攻击
        //玩家攻击
        playerAtk('空手', data.atk);
    }else{//武器攻击
        //获取武器
        const weapon = getBagItemById(id);
        useWeaponAtk(weapon);
    }
}

//使用武器攻击
function useWeaponAtk(weapon){
    //获取伤害
    const weaponAtk = weapon.getAtk(weapon) + (weapon.name.startsWith('技能石') ? 0 : data.atk);

    //判定是否满足攻击条件
    if(elementCfgs[weapon.name].preFunc && !elementCfgs[weapon.name].preFunc(weapon)){
        return;
    }

    //减少武器耐久
    reduceWeaponEndurance(weapon.id);

    //使用技能时，也消耗装备武器的耐久
    if(!weapon.isArrow && weapon.name.startsWith('技能石') && data.weapon && data.weapon.id !== weapon.id){
        reduceWeaponEndurance(data.weapon.id);
    }

    //玩家攻击
    playerAtk(weapon.showName ||weapon.name, weaponAtk, weapon);
}

//护盾抵扣伤害
function reduceShield(obj, harm, mountReduceHarm = true){
    //可代替承受伤害的坐骑代替承伤
    if(mountReduceHarm && obj.mount && obj.mount.tdi){
        let mount = getBagItemById(obj.mount.id);
        if(harm >= mount.endurance){
            equipMount(mount);
            reduceItemById(mount.id);
            elementCfgs[mount.name].selfDes && elementCfgs[mount.name].selfDes.call(mount);
            harm -= mount.endurance;
        }else{
            mount.endurance -= harm;
            obj.mount = mount;
            harm = 0;
        }

        if(harm <= 0){
            return 0;
        }
    }

    if(obj.shield > 0){
        if(obj.shield >= harm){
            obj.shield -= harm;
            return 0;
        }else{
            harm -= obj.shield;
            obj.shield = 0;
            return harm
        }
    }
    return harm;
}

//战斗中恢复血量
function battleAddHp(obj, num){
    //获取减治疗量
    let reduceRecover = 0;
    obj.status.forEach(e => {
        if(e.reduceRecover > reduceRecover){
            reduceRecover = e.reduceRecover;
        }
    })

    const recover = parseInt(num * (1 - reduceRecover));

    obj.hp += recover;
    if(obj.hp > obj.maxHp){
        obj.hp = obj.maxHp;
    }

    return recover;
}

//点击使用药剂
$('.weapons').on('click','.drug',function(){
    const id = $(this).attr('data-id');
    battleUseItem(id);
});

//战斗中使用物品
function battleUseItem(id){
    const item = data.bag.filter(e => e.id === id)[0];
    //获得效果
    if(elementCfgs[item.name].func){
        const result = elementCfgs[item.name].func.call(item);
        if(result === 'win'){
            reduceItemById(id);
            battleWin();
            if(!data.battleMonster){
                return
            }
        }else if(!result){
            return;
        }
    }else{
        let text = `使用了[${item.name}]`
        if(item.getHp()){
            text += `，HP恢复${battleAddHp(data, item.getHp())}`
        }
        if(item.hunger){
            addObjHunger(data, item.hunger)
            text += `，饥饿恢复${item.hunger}`
        }
        if(item.water){
            addObjWater(data, item.water)
            text += `，水分恢复${item.water}`
        }
        addBattleLog(text)
    }
    reduceItemById(id);
    //怪物攻击
    monsterAtk();
}

//点击使用投掷品
$('.weapons').on('click','.throw',function(){
    const id = $(this).attr('data-id');
    throwAtk(id)
});

//投掷物品攻击
function throwAtk(id, monsterCanAtk = true){
    const item = data.bag.filter(e => e.id === id)[0];

    if(!data.battleMonster){
        reduceItem(item.name);
        return;
    }

    if(data.race.name.startsWith('哥布林') && !data.battleMonster.seeGoblin){
        data.otherReduceHart = 0;
        data.battleMonster.seeGoblin = true;
    }

    let atk = item.getAtk(item);
    const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
    const min = parseInt(atk * (1 - atkFloat - dlcAddFloat));
    const max = parseInt(atk * (1 + atkFloat + dlcAddFloat));
    let harm = randomNum(getStatuNum(data, '飞龙在天') ? max : min, max) - data.battleMonster.def;
    reduceItem(item.name);

    if(elementCfgs[item.name].throwFunc){
        elementCfgs[item.name].throwFunc.call(item);
    }

    if(harm > 0){
        addBattleLog(`你使用[${item.showName ||item.name}]进行攻击，对${data.battleMonster.showName || data.battleMonster.name}造成${harm}点伤害。`);
        data.battleMonster.hp -= reduceShield(data.battleMonster,harm);
        if(data.battleMonster.hp > data.battleMonster.maxHp){
            data.battleMonster.hp = data.battleMonster.maxHp;
        }

        renderBattlePage();

        //怪物死亡，获得战利品
        if(data.battleMonster.hp <= 0){
            preDie(data.battleMonster);
        }
        if(data.battleMonster.hp <= 0){
            battleWin();
            if(!data.battleMonster){
                return
            }
        }
    }else{
        addBattleLog(`你使用[${item.showName ||item.name}]进行攻击，无法击破${data.battleMonster.showName || data.battleMonster.name}的防御。`);
    }

    if(typeof elementCfgs[item.name].func === 'function'){
        elementCfgs[item.name].func.call(item, monsterCanAtk);
    }

    //怪物攻击
    if(monsterCanAtk){
        monsterAtk();
    }
}

//玩家攻击
function playerAtk(name, atk, weapon){
    if(data.race.getAtkSpd() > data.battleMonster.atkSpd){
        addStatus(data, getStatus('攻速积累', {num : data.race.getAtkSpd() - data.battleMonster.atkSpd}))
    }

    atk = getSanAtk(atk);
    let success = true;

    if(data.race.name.startsWith('哥布林') && !data.battleMonster.seeGoblin){
        data.otherReduceHart = 0;
        data.battleMonster.seeGoblin = true;
    }

    //判断状态
    for(let i = 0 ; i < data.status.length ; i++){
        const sta = data.status[i];
        if(sta.reduceHitRate){
            if(randomNum(1, 100) < sta.reduceHitRate){
                addBattleLog(`你没有击中${data.battleMonster.showName || data.battleMonster.name}。`)
                success = false;
                break;
            }
        }
    }

    if(success){
        //获取吸血比例
        let suck = (weapon && weapon.suck ? weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0);
        //使用技能时，额外计算已装备的武器吸血
        if(weapon && weapon.name.startsWith('技能石') && data.weapon){
            suck += data.weapon.suck || 0;
        }

        //无法触发吸血效果
        if(weapon && weapon.noSuck){
            suck = 0;
        }

        let harm = 0;

        //攻击次数
        const atkNum = weapon ? elementCfgs[weapon.name].getAtkNum.call(weapon) : 1;

        for(let i = 0 ; i < atkNum ; i++){
            const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
            if(data.race.name.startsWith('狩猎神裔')){
                if(data.battleMonster.type === '神话'){
                    harm = parseInt(atk * (1.5 + dlcAddFloat)) - data.battleMonster.def;
                }else{
                    harm = randomNum(parseInt(atk * (getStatuNum(data, '飞龙在天') ? 1.5 + dlcAddFloat : 1.2 - dlcAddFloat)),parseInt(atk * (1.5 + dlcAddFloat))) - data.battleMonster.def
                }
            }else if(data.race.name.startsWith('星灵')){
                harm = randomNum(parseInt(atk * (getStatuNum(data, '飞龙在天') ? 0.8 + dlcAddFloat : 0.7 - dlcAddFloat)),parseInt(atk * (0.8 + dlcAddFloat))) - data.battleMonster.def
            }else{
                const min = parseInt(atk * (1 - atkFloat - dlcAddFloat));
                const max = parseInt(atk * (1 + atkFloat + dlcAddFloat));
                harm = randomNum(getStatuNum(data, '飞龙在天') ? max : min, max) - data.battleMonster.def;
            }
            if(harm > 0){
                let suckMsg = '';
                if(suck > 0){
                    const addHp = parseInt(harm * (suck / 100))
                    let suckHp = addHp;
                    if(!data.race.name.startsWith('吸血鬼')){
                        const blankHp = data.maxHp - data.hp;
                        suckHp = blankHp < addHp ? blankHp : addHp;
                        data.maxHp -= Math.ceil(suckHp / 20);
                    }
                    suckMsg = `你吸取了${battleAddHp(data, suckHp)}HP。`;

                    if(suck >= 200){
                        if(!conf.races){
                            conf.races = [];
                        }
                        if(conf.races.indexOf('吸血鬼') === -1){
                            conf.races.push('吸血鬼');
                            save(confSavedName, conf);
                            winMsg(`恭喜你解锁了吸血鬼！`);
                        }
                    }
                }
                addBattleLog(`你使用[${name}]进行攻击，对${data.battleMonster.showName || data.battleMonster.name}造成${harm}点伤害。${suckMsg}`);
                data.battleMonster.hp -= reduceShield(data.battleMonster,harm);
                if(data.battleMonster.hp > data.battleMonster.maxHp){
                    data.battleMonster.hp = data.battleMonster.maxHp;
                }
            }else{
                addBattleLog(`你使用[${name}]进行攻击，无法击破${data.battleMonster.showName || data.battleMonster.name}的防御。`);
            }
        }

        //攻击后置事件
        if(weapon && weapon.name && elementCfgs[weapon.name].atkAfter){
            elementCfgs[weapon.name].atkAfter.call(weapon);
            renderBattlePage();
        }

        renderBattlePage();

        //怪物死亡，获得战利品
        if(data.battleMonster.hp <= 0){
            preDie(data.battleMonster);
        }
        if(data.battleMonster.hp <= 0){
            battleWin();
            if(!data.battleMonster){
                return
            }
        }
    }

    //判断状态
    if(data.battleMonster){
        for(let i = 0 ; i < data.battleMonster.status.length ; i++){
            const sta = data.battleMonster.status[i];
            if(sta.returnHarm){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}的${sta.name}状态让你受到${sta.returnHarm}点伤害。`)
                data.hp -= sta.returnHarm;
                //玩家死亡
                const name = `${data.battleMonster.showName || data.battleMonster.name}`;
                const noWrite = dungeons[data.world.name] && dungeons[data.world.name].type === 2;
                if(data.hp <= 0){
                    preDie(data);
                }
                if(data.hp <= 0 && !die(data)){
                    addDieLog(`${name}杀死了你`,noWrite);
                    isDie && $('.battle').show();
                    return
                }
            }
        }
    }

    if(data.hp > data.maxHp){
        data.hp = data.maxHp;
    }

    //怪物攻击
    monsterAtk();
}

//怪物攻击
function monsterAtk(noAddAtkSpd){
    if(!data.battleMonster){
        return;
    }

    //判断是否继续由玩家行动
    let statuNum = getStatuNum(data, '攻速积累');
    if(statuNum >= 10){
        addBattleLog('攻速积累达到10层，可以再次行动')

        if(statuNum === 10){
            removeStatus(data, '攻速积累')
        }else{
            data.status.filter(e => e.name === '攻速积累')[0].num = statuNum - 10;
        }

        //渲染战斗页面
        renderBattlePage();
        //本回合结束，存档记录
        save();
        return;
    }

    if(!noAddAtkSpd && data.battleMonster.atkSpd > data.race.getAtkSpd()){
        addStatus(data.battleMonster, getStatus('攻速积累', {num : data.battleMonster.atkSpd - data.race.getAtkSpd()}))
    }

    let startAtkFloat = 1 - atkFloat;
    let endAtkFloat = 1 + atkFloat;

    if(data.race.name.startsWith('魅魔')){
        startAtkFloat = 0.8;
        endAtkFloat = 1;
    }

    if(hasAmulet('草编戒指') && randomNum(1,100) <= 10){
        addBattleLog('怪物突然愣了一下，你乘机追击')

        //渲染战斗页面
        renderBattlePage();
        //本回合结束，存档记录
        save();
        return;
    }

    data.battleMonster.seePlayer = true;

    let success = true;

    let log = '';
    //判断状态
    for(let i = 0 ; i < data.battleMonster.status.length ; i++){
        const sta = data.battleMonster.status[i];
        if(sta.harm){
            log += `${data.battleMonster.showName || data.battleMonster.name}正处于${sta.name}状态，受到${sta.harm}点伤害。`
            data.battleMonster.hp -= sta.harm;
            if(data.battleMonster.hp > data.battleMonster.maxHp){
                data.battleMonster.hp = data.battleMonster.maxHp;
            }
            //怪物死亡，获得战利品
            if(data.battleMonster.hp <= 0){
                preDie(data.battleMonster);
            }
            if(data.battleMonster.hp <= 0){
                addBattleLog(log)
                battleWin();
                if(!data.battleMonster){
                    return
                }
            }
        }
        if(success && sta.sleep){
            removeStatus(data.battleMonster, '攻速积累')
            log += `${data.battleMonster.showName || data.battleMonster.name}正处于${sta.name}状态，无法行动。`
            success = false;
        }else if(success && sta.reduceHitRate && randomNum(1, 100) < sta.reduceHitRate){
            log += `${data.battleMonster.showName || data.battleMonster.name}没有击中你。`
            success = false;
        }
    }
    addBattleLog(log)

    if(success){
        //判断怪物是否使用技能
        let skill = checkUseSkill(true);

        //使用恢复技能
        if(skill && skill.type === 'recover'){
            //判定技能是否有命中率，有则进行命中判定
            if(skill.atr && randomNum() > skill.atr){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用${skill.name}失败了`)
            }else{
                let addHp = skill.num;
                if(addHp + data.battleMonster.hp > data.battleMonster.maxHp){
                    addHp = data.battleMonster.maxHp - data.battleMonster.hp;
                }

                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${skill.name}，恢复${battleAddHp(data.battleMonster, addHp)}点HP。`);
            }

            //判断附加状态
            if(skill.getStatus){
                const sta = skill.getStatus();
                if(sta){
                    addBattleLog(`你被附加了${sta.name}状态。`)
                    addStatus(data,sta);
                }
            }
        }else if(skill && skill.type === 'berserk'){//使用变身技能
            //判定技能是否有命中率，有则进行命中判定
            if(skill.atr && randomNum() > skill.atr){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用${skill.name}失败了`)
            }else{
                skill.use();
                const noWrite = dungeons[data.world.name] && dungeons[data.world.name].type === 2;
                if(data.hp <= 0){
                    preDie(data);
                }
                if(data.hp <= 0 && !die()){
                    addDieLog(`${name}杀死了你`, noWrite);
                    isDie && $('.battle').show();
                    return;
                }
            }

            //判断附加状态
            if(skill.getStatus){
                const sta = skill.getStatus();
                if(sta){
                    addBattleLog(`你被附加了${sta.name}状态。`)
                    addStatus(data,sta);
                }
            }
        }else{
            let monsterDps = null;
            //使用攻击技能
            if(skill){
                //判定技能是否有命中率，有则进行命中判定
                if(skill.atr && randomNum() > skill.atr){
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${skill.name}，但是打偏了`)
                }else{
                    //计算伤害
                    const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
                    monsterDps = randomNum(parseInt(skill.num * (startAtkFloat - dlcAddFloat)),parseInt(skill.num * (endAtkFloat + dlcAddFloat)));
                    if(data.reduceHart || data.otherReduceHart){
                        monsterDps = parseInt(monsterDps * (1 - (data.reduceHart || 0) - (data.otherReduceHart || 0)));
                    }
                    let harm = monsterDps - data.def;

                    if(harm > 0){
                        let suckMsg = '';
                        if(data.battleMonster.suck){
                            const suck = parseInt(harm * data.battleMonster.suck / 100)
                            if(suck > 0){
                                suckMsg = `，并吸取了${battleAddHp(data.battleMonster, suck)}点HP`;
                            }
                        }
                        addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}对你使用了${skill.name}，造成${harm}点伤害${suckMsg}。`);
                        harm = reduceShield(data,harm);
                        data.hp -= harm;
                    }else{
                        addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}对你使用了${skill.name}，无法击破你的防御。`);
                    }
                }

                //判断附加状态
                if(skill.getStatus){
                    const sta = skill.getStatus();
                    if(sta){
                        addBattleLog(`你被附加了${sta.name}状态。`)
                        addStatus(data,sta);
                    }
                }
            }else{
                //计算伤害
                const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
                monsterDps = randomNum(parseInt(data.battleMonster.atk * (startAtkFloat - dlcAddFloat)),parseInt(data.battleMonster.atk * (endAtkFloat + dlcAddFloat)));
                if(data.reduceHart || data.otherReduceHart){
                    monsterDps = parseInt(monsterDps * (1 - (data.reduceHart || 0) - (data.otherReduceHart || 0)));
                }
                let harm = monsterDps - data.def;

                if(harm > 0){
                    let suckMsg = '';
                    if(data.battleMonster.suck){
                        const suck = parseInt(harm * data.battleMonster.suck / 100)
                        if(suck > 0){
                            suckMsg = `，并吸取了${battleAddHp(data.battleMonster, suck)}点HP`;
                        }
                    }
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}对你发起了攻击，造成${harm}点伤害${suckMsg}。`);
                    harm = reduceShield(data,harm);
                    data.hp -= harm;
                }else{
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}对你发起了攻击，无法击破你的防御。`);
                }
            }

            //玩家死亡
            const name = `${data.battleMonster.showName || data.battleMonster.name}`;
            const noWrite = dungeons[data.world.name] && dungeons[data.world.name].type === 2;
            if(data.hp <= 0){
                preDie(data);
            }
            if(data.hp <= 0 && !die()){
                addDieLog(`${name}杀死了你`,noWrite);
                isDie && $('.battle').show();
                return;
            }else{
                //护甲减少耐久
                if(data.armor && (monsterDps * 2) > data.armor.def){
                    //减少护甲耐久
                    reduceArmorEndurance(data.armor.id);
                }
            }
        }
    }

    log = '';
    //判断反伤状态
    for(let i = 0 ; i < data.status.length ; i++){
        const sta = data.status[i];
        if(sta.returnHarm){
            log += `你的${sta.name}状态让${data.battleMonster.showName || data.battleMonster.name}受到${sta.returnHarm}点伤害。`
            data.battleMonster.hp -= sta.returnHarm;
            if(data.battleMonster.hp > data.battleMonster.maxHp){
                data.battleMonster.hp = data.battleMonster.maxHp;
            }
            //如果怪物死亡
            if(data.battleMonster.hp <= 0){
                preDie(data.battleMonster);
            }
            if(data.battleMonster.hp <= 0){
                addBattleLog(log)
                battleWin();
                if(!data.battleMonster){
                    return
                }
            }
        }
    }

    //判断是否继续由怪物行动
    statuNum = getStatuNum(data.battleMonster, '攻速积累');
    if(statuNum >= 10){
        addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}攻速积累达到10层，可以再次行动`)

        if(statuNum === 10){
            removeStatus(data.battleMonster, '攻速积累')
        }else{
            data.battleMonster.status.filter(e => e.name === '攻速积累')[0].num = statuNum - 10;
        }

        monsterAtk();
        return;
    }

    //判断状态
    for(let i = 0 ; i < data.status.length ; i++){
        const sta = data.status[i];
        if(sta.addHp){
            log += `你正处于${sta.name}状态，恢复${battleAddHp(data, sta.addHp)}点HP。`;
        }
        if(sta.harm){
            log += `你正处于${sta.name}状态，受到${sta.harm}点伤害。`
            data.hp -= sta.harm;
            //玩家死亡
            const name = `${data.battleMonster.showName || data.battleMonster.name}`;
            const noWrite = dungeons[data.world.name] && dungeons[data.world.name].type === 2;
            if(data.hp <= 0){
                preDie(data);
            }
            if(data.hp <= 0 && !die()){
                addDieLog(`${name}杀死了你`,noWrite);
                addBattleLog(log)
                isDie && $('.battle').show();
                return
            }
        }
        if(sta.sleep){
            removeStatus(data, '攻速积累')
            log += `你正处于${sta.name}状态，无法行动。`
            endOfTurn();
            addBattleLog(log)
            monsterAtk();
            return;
        }
    }

    //判断状态
    for(let i = 0 ; data.battleMonster && i < data.battleMonster.status.length ; i++){
        const sta = data.battleMonster.status[i];
        if(sta.addHp){
            log += `${data.battleMonster.showName || data.battleMonster.name}正处于${sta.name}状态，恢复${battleAddHp(data.battleMonster, sta.addHp)}点HP。`;
        }
    }

    addBattleLog(log)
    endOfTurn();
}

//回合结束
function endOfTurn(){
    data.status.forEach(sta => {
        reduceStatusNum(data, sta.name);
    })
    if(data.battleMonster){
        data.battleMonster.status.forEach(sta => {
            reduceStatusNum(data.battleMonster, sta.name);
        })
    }
    reduceStatusNum(data.battleMonster, '闪避');

    //水晶徽章判断
    if(hasAmulet('水晶徽章') && !data.battleMonster.xlsh && data.hp <= parseInt(data.maxHp * 0.3)){
        data.battleMonster.xlsh = true;
        addStatus(data, getStatus('心灵守护', {addHp : data.battleMonster.atk * 2}))
    }

    //根据理智判断是否增加疯狂状态
    if(!hasStatus(data, '冷静') && !data.race.name.startsWith("污染者") && data.san < 100 && !verification(true, data.san)){
        addBattleLog('你陷入了疯狂之中，无法行动')
        if(data.race.name === "断肠人"){
            data.race.changeSoul();
        }
        //渲染战斗页面
        renderBattlePage();
        monsterAtk();
        return;
    }

    //渲染战斗页面
    renderBattlePage();
    //本回合结束，存档记录
    save();
}

//战斗胜利
function battleWin(noSoul,passTime = battleWinMin, distorted = true){
    if(!data.battleMonster){
        battleEnd()
        setTimeout(() => {
            timeLapses(passTime);
        }, 10)
    }
    if(data.battleMonster.name === '创世神'){
        if(!conf.races){
            conf.races = [];
        }
        if(conf.races.indexOf('星灵') === -1){
            conf.races.push('星灵');
            save(confSavedName, conf);
            winMsg(`恭喜你解锁了星灵！`);
        }

        data.battleMonster.hp = data.battleMonster.maxHp = data.battleMonster.startAttrs.maxHp;
        addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}在一瞬间恢复了所有生命值`)
        if(!data.battleMonster.reLife){
            data.battleMonster.reLife = true;
            says([
                `我即是世界`,
                `我是世界的支柱`,
                `你只是我创造的世界中的一缕尘埃`,
                `我是不死不灭的存在`,
                `愚蠢的凡人，你以为你在做什么？`,
                `你还活着是因为我的仁慈`,
                `但我的仁慈总有耗尽的时候`,
            ]);
        }
        return;
    }

    //扭曲判断
    if((!data.weapon || data.weapon.name !== '旧印') &&  !isWorldBoss()){
        if(distorted && data.order > 1 && !data.battleMonster.distorted && data.battleMonster.level + 10 >= data.level && !data.battleMonster.cthulhuMonster){
            if(randomNum(1,100) < data.order){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}扭曲为不可描述的状态`)
                $('.stop-auto-battle').hide();
                clearInterval(autoBattle);
                clearInterval(autoBattleId);
                stopAutoKillMonster = true;
                getDistortedMonster();
                return;
            }
        }
    }

    if((data.race.name.startsWith('亡灵族') || data.race.name.startsWith('巫妖')) && !noSoul && ((data.level - data.battleMonster.level <= 10) || data.race.name.startsWith('巫妖-魂师') || data.race.name.startsWith('巫妖-灵魂主宰'))){
        if(data.soul == null){
            data.soul = 0;
        }
        data.soul++;
        if(data.race.name.startsWith('巫妖-魂师') || data.race.name.startsWith('巫妖-灵魂主宰')){
            data.soul += 2;
        }
    }
    if((data.race.name.startsWith('神性史莱姆-亵渎') || data.race.name.startsWith('神性史莱姆-狩神者')) && !data.inDungeon && data.battleMonster.type === '神话'){
        data.divinity += parseInt(data.battleMonster.level / 3);
    }
    if(data.race.name.startsWith('地球人-佛门') || data.race.name.startsWith('地球人-活佛')){
        if(data.battleMonster.maxHp > 0){
            data.merit--;
        }
    }

    //记录击杀数量
    if(!data.killedMonster[data.battleMonster.name]){
        data.killedMonster[data.battleMonster.name] = 0;
    }
    data.killedMonster[data.battleMonster.name]++;

    //获取战利品
    const getItems = [];
    let getList = getBattleWinItems();
    if(data.battleMonster.npcId && data.world.npcs){
        const filter = data.world.npcs.filter(e => e.id === data.battleMonster.npcId);
        if(filter.length > 0){
            const npc = filter[0];
            getList = [
                ...getList,
                {
                    name : '神恩口袋',
                    minNum : 1,
                    maxNum :1,
                    attr : {
                        hasGold : npc.gold,
                        hasItems : npc.items
                    }
                }
            ]

            //如果这个NPC有刺杀任务
            if(npc.task && npc.task.target && npc.task.target.id && data.world.npcs){
                data.world.npcs.filter(e => e.id === npc.task.target.id).forEach(e => {
                    e.isKillTarget = false;
                });
            }

            //如果这个NPC是刺杀任务的目标
            if(npc.isKillTarget && data.world.npcs){
                data.world.npcs.filter(e => e.task && e.task.target && e.task.target.id === data.battleMonster.npcId).forEach(e => {
                    e.task.now = 1;
                });
            }

            if(npc.evil && npc.evil < 0){
                addEvil(npc.evil * -2);
                msg(`你从${npc.name}处获得了${-npc.evil}点善良值，现在你杀死了他，获得了双倍的邪恶值`)
            }
        }

        //如果不是玩家主动攻击NPC，则战斗胜利后增加罪恶值
        if(!data.battleMonster.playerAtkMonster){
            addEvil(data.worldIndex + 1);
        }
    }
    //扭曲怪物掉落物
    if(data.battleMonster.distorted){
        getList = [...getList, ...getDistortedItems()];
    }
    if(!data.inDungeon && data.battleMonster.hasItems){
        getList = [...getList, ...data.battleMonster.hasItems.filter(e => !data.battleMonster[e]).map(e => ({name : e, minNum : 1, maxNum : 1}))];
    }

    //获取怪物掉落物
    addKillMonsterItems(getList, getItems)

    msg(`你战胜了${data.battleMonster.showName || data.battleMonster.name}，EXP+${addExp(data.battleMonster.exp, data.battleMonster.level)}${getItems.length > 0 ? `，获得：${ getItems.join()}` : ''}`);
    //判断升级
    level();

    //亡灵族恢复生命值
    if(data.race.name.startsWith('亡灵族') || data.race.name.startsWith('巫妖')){
        const addHp = parseInt(data.battleMonster.maxHp * 0.2);
        data.hp += addHp;
        if(data.hp > data.maxHp){
            data.hp = data.maxHp
        }
        msg(`你吸取了${data.battleMonster.showName || data.battleMonster.name}的灵魂，恢复了${addHp}HP`)
    }

    //如果是神战，则清空神眷和信仰
    if(Object.keys(deitys).indexOf(data.battleMonster.name) !== -1){
        data.deitys[data.battleMonster.name].godFavor = 0;
        data.deitys[data.battleMonster.name].belief = 0;
        msg(`你完成了一次弑神，${data.battleMonster.name}失去了记忆，忘记了你做过的一切，你可以重新进入其神殿了。`);
    }

    //如果是神殿任务，则增加击杀数量
    if(!data.temples){
        data.temples = {};
    }
    if(!data.temples[data.worldIndex]){
        data.temples[data.worldIndex] = {};
    }
    Object.keys(data.temples).forEach(index => {
        Object.keys(data.temples[index]).forEach(e => {
            const temple = data.temples[index][e];
            if(temple && temple.task.monster === data.battleMonster.name){
                temple.task.killed++;
                if(temple.task.killed === temple.task.num){
                    winMsg(`完成任务：${temple.task.name}`)
                }
            }
        })
    })

    //如果是NPC任务怪，则记录
    if(data.world.npcs){
        const taskNpcs = data.world.npcs.filter(e => e.task && e.task.geted && !e.task.over && e.task.target === data.battleMonster.name);
        taskNpcs.forEach(e => {
            if(!e.task.now){
                e.task.now = 0;
            }
            e.task.now++;
        })
    }

    //如果是守关BOSS，则通关
    if(data.world.worldBoss === data.battleMonster.name && data.nextPoint && data.nextPoint.join() === data.location.join()){
        if(!data.world.pass){
            $(`.plot-${data.worldIndex}`).show()
            data.world.pass = true;
        }
    }

    //击杀最终BOSS
    if(data.battleMonster.name === data.maps[data.worldIndex].endBoss){
        $(`.plot-${data.worldIndex}`).show()
        data.map[data.location[1]][data.location[0]] = '破碎';
        data.world.map[data.location[1]][data.location[0]] = '破碎';
        data.passAll = true;
    }

    //如果是副本内，则记录已经击杀
    if(data.inDungeon){
        if(!data.dungeonKilled){
            data.dungeonKilled = [];
        }
        if(data.dungeonKilled.indexOf(data.battleMonster.name) === -1){
            data.dungeonKilled.push(data.battleMonster.name);
        }

        if(dungeons[data.world.name] && dungeons[data.world.name].type === 2){
            if(data.dungeonLevel == null){
                data.dungeonLevel = 1;
            }
            data.dungeonLevel++;
        }
    }else{
        //如果是神话怪，则记录死亡时间
        const myths = data.world.mythMonster.filter(e => e.name === data.battleMonster.name);
        if(myths.length > 0){
            myths[0].deathTime = new Date(data.date).getTime();
        }

        if(data.battleMonster.type === '神话'){
            //判断是否首次击杀神话怪
            if(data.killedMyth.indexOf(data.battleMonster.name) === -1){
                data.killedMyth.push(data.battleMonster.name);
                if(diff !== '硬核难度' && diff !== '扩展难度' && !data.race.challenge){
                    addItem('神话诅咒')
                    msg(`你首次击杀了${data.battleMonster.name}，获得1个神话诅咒`)
                }
            }
        }
    }

    //如果是世界BOSS，则清空战斗中的世界BOSS属性
    let finalBoss = null;
    const map = data.maps.filter(e => e.name === data.world.name);
    if(map.length > 0){
        finalBoss = map[0].finalBoss;
    }
    if(data.battleMonster && data.battleMonster.name === finalBoss){
        data.world.finalBossObj = null;
    }

    battleEnd()
    setTimeout(() => {
        timeLapses(passTime);
    }, 10)
}

//战斗结束
let newBattleLog = '';
function battleEnd(needReload){
    if(!data.battleMonster){
        data.selfAttrs = null;
        return;
    }
    if(data.battleMonster && data.battleMonster.npcId && data.world.npcs){
        data.world.npcs = data.world.npcs.filter(e => e.id !== data.battleMonster.npcId);
        $(`.npc[data-id=${data.battleMonster.npcId}]`).remove();
    }
    data.battleMonster = null;
    $('.stop-auto-battle').hide();
    clearInterval(autoBattle);
    clearInterval(autoBattleId);
    if(data.selfAttrs){
        const addHp = data.selfAttrs.maxHp - data.maxHp;
        data.maxHp = data.selfAttrs.maxHp;
        addObjHp(data, addHp > 0 ? addHp : 0)
        if(data.selfAttrs.maxHunger){
            data.maxHunger = data.selfAttrs.maxHunger;
        }
        if(data.hunger > data.maxHunger){
            data.hunger = data.maxHunger;
        }
        data.atk = data.selfAttrs.atk;
        data.atkSpd = data.selfAttrs.atkSpd || 0;
        data.def = data.selfAttrs.def;
        data.reduceHart = data.selfAttrs.reduceHart
        data.suck = data.selfAttrs.suck
        data.spd = data.selfAttrs.spd || 0;
    }
    data.status = [];
    data.selfAttrs = null;
    $('.battle').hide();
    renderBag();
    newBattleLog = $('.battle-logs').html();

    if(data.weapon && data.weapon.level > data.level){
        says(['你的装备因为你的等级不足，被强制脱下了'])
        equip(data.weapon);
    }
    if(data.armor && data.armor.level > data.level){
        says(['你的装备因为你的等级不足，被强制脱下了'])
        equip(data.armor);
    }
}

//是否在战斗中
function inBattle(){
    return !!data.selfAttrs && data.battleMonster;
}

//添加战斗日志
function addBattleLog(text){
    $('.battle-logs').prepend(`<p>${text}</p>`);

    while ($('.battle-logs p').length > 200){
        $('.battle-logs p').last().remove();
    }
}

//切换战斗武器显示类型
$('.weapon-types div').click(function(){
    $('.weapon-types div').removeClass('active');
    $(this).addClass('active');
    renderBattlePage();
});
