//古神入侵专属物品
const cthulhuItems = {
    '古神血液' : new Element({
        canUse : true,
        voidDust : 0,
        draw : 300,
        func : function(){
            if(conf.races.indexOf('污染者') !== -1){
                winMsg('你已经解锁污染者种族！', false, false);
                return false;
            }
            if(getNumByBag('古神血液') >= 100){
                reduceItem('古神血液', 99);
                if(!conf.races){
                    conf.races = [];
                }
                conf.races.push('污染者');
                save(confSavedName, conf);
                winMsg('恭喜你解锁了污染者种族！');
                return true;
            }else{
                winMsg('古神血液不足', false, false)
                return false;
            }
        },
        text : '凑齐100个使用，将解锁污染者种族'
    }),
    '奇怪的液体' : new Element({
        canUse : true,
        voidDust : 0,
        draw : 5,
        func : function(){
            data.hp -= 1000;
            if(verification(true, getCthulhuScholarship(), 5, parseInt((100 - data.san) / 10))){
                addItem('古神血液')
                winMsg('你辨认出了这是什么，获得1个古神血液')
            }else{
                data.attrPoint -= 1;
                if(!data.consumePoint){
                    data.consumePoint = 0;
                }
                data.consumePoint += 1;
                winMsg('你不知道这是什么，你觉得自己受到了无法挽回的伤害')
            }
            return true;
        },
        text : '红黑色的浓稠液体，里面有大量红色的丝线，仿佛长虫搬扭曲蠕动，你可以品尝一下，也可以暂且留着。如果选择品尝（即使用该物品），你将减少1000生命值，并将进行一次极难难度的克苏鲁学识检定，检定通过的话将获得1个古神血液，检定不通过将永远减少1属性点。本次检定每当你的理智比100少10点，则获得1个奖励骰（例如你的理智为15点，则获得8个奖励骰）'
    }),
    '干枯的触手' : new Element({
        voidDust : 2000,
        gold : 10000,
        draw : 50,
        text : '一小段干枯的触手，看起来像章鱼须，但是一直盯着看会让你觉得恶心头疼。'
    }),

    //怪物掉落
    '妖鬼的心脏' : new Element({voidDust : 50, gold : 250, draw : 1}),
    '妖鬼的脑干' : new Element({voidDust : 50, gold : 250, draw : 1}),
    '深潜者的鳞片' : new Element({voidDust : 100, gold : 500, draw : 2}),
    '猩红的鳃' : new Element({voidDust : 100, gold : 500, draw : 2}),
    '深潜者的眼球' : new Element({voidDust : 100, gold : 500, draw : 2}),
    '蛇人之牙' : new Element({voidDust : 150, gold : 750, draw : 3}),
    '断掉的蛇尾' : new Element({voidDust : 150, gold : 750, draw : 3}),
    '巨大虫螯' : new Element({voidDust : 200, gold : 1000, draw : 5}),
    '破碎甲壳' : new Element({voidDust : 100, gold : 500, draw : 2}),
    '魔虫胃袋' : new Element({voidDust : 300, gold : 1500, draw : 5}),
    '魔虫胃袋' : new Element({voidDust : 300, gold : 1500, draw : 5}),
    '魔虫胃袋' : new Element({voidDust : 300, gold : 1500, draw : 5}),
    '巨噬虫卵' : new Element({voidDust : 400, gold : 2000, draw : 6}),
    '锋利虫牙' : new Element({voidDust : 400, gold : 2000, draw : 6}),
    '断开的口器' : new Element({voidDust : 400, gold : 2000, draw : 6}),
    '月兽触手' : new Element({voidDust : 450, gold : 2250, draw : 8}),
    '月兽的皮' : new Element({voidDust : 450, gold : 2250, draw : 8}),
    '灵魂物质' : new Element({voidDust : 450, gold : 2250, draw : 8}),
    '米戈的孢子' : new Element({voidDust : 500, gold : 2500, draw : 10}),
    '米戈的翅膀' : new Element({voidDust : 500, gold : 2500, draw : 10}),
    '古革的复爪' : new Element({voidDust : 600, gold : 3000, draw : 12}),
    '古革的硬皮' : new Element({voidDust : 600, gold : 3000, draw : 12}),
    '伊斯的螯' : new Element({voidDust : 700, gold : 3500, draw : 15}),
    '伊斯根茎' : new Element({voidDust : 700, gold : 3500, draw : 15}),
    '伊斯之花' : new Element({voidDust : 700, gold : 3500, draw : 15}),
    '古老者之眼' : new Element({voidDust : 800, gold : 4000, draw : 18}),
    '古老者之斧足' : new Element({voidDust : 800, gold : 4000, draw : 18}),
    '廷达罗斯之牙' : new Element({voidDust : 900, gold : 4500, draw : 20}),
    '廷达罗斯之爪' : new Element({voidDust : 900, gold : 4500, draw : 20}),
    '蠕动的胡须' : new Element({voidDust : 1000, gold : 5000, draw : 22}),
    '扭曲的心脏' : new Element({voidDust : 1000, gold : 5000, draw : 25}),
    '脑瘤' : new Element({voidDust : 1100, gold : 5500, draw : 28}),
    '星光之核' : new Element({voidDust : 1200, gold : 6000, draw : 30}),
    '彩色云雾' : new Element({voidDust : 1200, gold : 6000, draw : 30}),

    //装备
    '旧印' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 1,
        endurance : 1,
        voidDust : 10000,
        gold : 50000,
        draw : -1000,
        quality : 4,
        text : '只要手上拿着旧印（即装备上），怪物就不会触发扭曲形态。当你手持旧印时，如果在灵感触动中触发战斗，则视为你先手。当你和旧日、外神和古神战斗时，只有装备了旧印，才允许逃跑和使用短程传送卷轴'
    }),

    //特殊
    '旧日笔记' : new Element({canUse : true, voidDust : 100, gold : 500, quality : 2, func : function(){
            data.maxSan -= ndx(1,4);
            addObjSan(data, 0);
            return true;
        }, text : '使用后，获得1d4点克苏鲁学识'}),
    '心灵净化卷轴' : new Element({canUse : true, voidDust : 0, gold : 0,weight : 0, quality : 2, func : function(){
            let num = getNumByBag('神性结晶');
            if(num < 1){
                winMsg('神性结晶不足', false, false)
                return false;
            }

            const blankSan = data.maxSan - data.san;
            if(blankSan <= 0){
                winMsg('你不需要恢复理智', false, false)
                return false;
            }

            const add = blankSan % 5 === 0 ? 0 : 1;
            let need = parseInt(blankSan / 5) + add;

            if(num < need){
                need = num;
            }
            reduceItem('神性结晶', need)
            addObjSan(data, need * 5);
            winMsg(`你消耗了${need}个神性结晶，恢复了${need * 5}点理智`)
            renderBag();
            return false;
        }, text : '神殿独家出售，消耗背包中的神性结晶，每消耗1个神性结晶恢复5点理智，直到神性结晶消耗完或者理智补满'}),
    '心灵洗涤泉水' : new Element({canUse : true, voidDust : 0, gold : 0,weight : 0, quality : 2, func : function(){
            addObjSan(data, 50);
            winMsg('你恢复了50点理智')
            return true;
        }, text : '神殿独家出售，恢复50点理智'}),
};

//克苏鲁怪物
const cthulhuMonsters = {
    '妖鬼' : {
        tags : ['克系生物','人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 10,
        hp : 300,
        atk : 20,
        def : 10,
        exp : 100,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '妖鬼的心脏',minNum : 1, maxNum : 3},{name : '妖鬼的脑干',minNum : 0, maxNum : 2},{name : '旧日笔记',minNum : 100, maxNum : 1}],
    },
    '深潜者' : {
        tags : ['克系生物','人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 10,
        hp : 950,
        atk : 30,
        def : 20,
        exp : 150,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '深潜者的鳞片',minNum : 1, maxNum : 3},{name : '猩红的鳃',minNum : 0, maxNum : 2},{name : '深潜者的眼球',minNum : 0, maxNum : 2},{name : '旧日笔记',minNum : 100, maxNum : 1}],
    },
    '蛇人' : {
        tags : ['克系生物','人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 2000,
        atk : 50,
        def : 20,
        exp : 500,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '蛇人之牙',minNum : 1, maxNum : 2},{name : '断掉的蛇尾',minNum : 1, maxNum : 1},{name : '旧日笔记',minNum : 100, maxNum : 1}],
    },
    '地穴魔虫' : {
        tags : ['克系生物','魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 5000,
        atk : 80,
        def : 30,
        exp : 1500,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '巨大虫螯',minNum : 1, maxNum : 2},{name : '破碎甲壳',minNum : 2, maxNum : 5},{name : '魔虫胃袋',minNum : 1, maxNum : 1},{name : '旧日笔记',minNum : 100, maxNum : 1}],
    },
    '巨噬蠕虫' : {
        tags : ['克系生物','魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 5000,
        atk : 140,
        def : 50,
        exp : 3000,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '巨噬虫卵',minNum : 1, maxNum : 3},{name : '锋利虫牙',minNum : 1, maxNum : 3}, {name : '断开的口器',minNum : 1, maxNum : 1}],
    },
    '月兽' : {
        tags : ['克系生物','魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 12000,
        atk : 180,
        def : 30,
        exp : 5000,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '月兽触手',minNum : 1, maxNum : 2},{name : '月兽的皮',minNum : 1, maxNum : 2}, {name : '灵魂物质',minNum : 1, maxNum : 1}],
    },
    '米戈' : {
        tags : ['克系生物','人型生物','巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 10000,
        atk : 0,
        def : 1000,
        exp : 6000,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '米戈的孢子',minNum : 1, maxNum : 2},{name : '米戈的翅膀',minNum : 1, maxNum : 2}],
    },
    '古革巨人' : {
        tags : ['克系生物','人型生物','巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 20000,
        atk : 250,
        def : 100,
        exp : 10000,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '古革的复爪',minNum : 1, maxNum : 2},{name : '古革的硬皮',minNum : 1, maxNum : 3}],
    },
    '伊斯' : {
        tags : ['克系生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 30000,
        atk : 350,
        def : 50,
        exp : 10000,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '伊斯的螯',minNum : 1, maxNum : 2},{name : '伊斯根茎',minNum : 1, maxNum : 3},{name : '伊斯之花',minNum : 1, maxNum : 1}],
    },
    '古老者' : {
        tags : ['克系生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 45000,
        atk : 400,
        def : 20,
        exp : 14000,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '古老者之眼',minNum : 1, maxNum : 2},{name : '古老者之斧足',minNum : 1, maxNum : 2}],
    },
    '廷达罗斯猎犬' : {
        tags : ['克系生物','魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 60000,
        atk : 600,
        def : 200,
        exp : 15000,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '廷达罗斯之牙',minNum : 1, maxNum : 3},{name : '廷达罗斯之爪',minNum : 1, maxNum : 3}],
    },
    '星之眷族' : {
        tags : ['克系生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 100000,
        atk : 700,
        def : 100,
        exp : 25000,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '蠕动的胡须',minNum : 1, maxNum : 3},{name : '扭曲的心脏',minNum : 1, maxNum : 1}],
    },
    '深渊之民' : {
        tags : ['克系生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 70,
        hp : 100000,
        atk : 800,
        def : 300,
        exp : 30000,
        atkSpd : 3,
        type : '精英',
        cthulhuMonster : true,
        items : [{name : '脑瘤',minNum : 1, maxNum : 1}],
    },
    '星之彩' : {
        tags : ['克系生物','幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 70,
        hp : 120000,
        atk : 1000,
        def : 0,
        exp : 40000,
        atkSpd : 3,
        type : '传说',
        cthulhuMonster : true,
        items : [{name : '星光之核',minNum : 1, maxNum : 1},{name : '彩色云雾',minNum : 1, maxNum : 1}],
    },
};
monsterCfgs = {
    ...monsterCfgs,
    ...cthulhuMonsters,
}

//怪物技能
monsterSkills = {
    ...monsterSkills,
    '利爪': {
        ...monsterSkills['撕咬'],
        name: '利爪',
    },
    '痊愈' : {
        name : '痊愈',
        type : 'recover',
        text : '基于当前攻击力进行1次检定，检定通过则再基于你的克苏鲁学识进行一次检定，检定不通过则使用该技能。恢复攻击力*10的血量。',
        check : function(){
            if(verification(false, data.battleMonster.atk) && !verification(false)){
                return true;
            }
            return false;
        },
        getNum : function(){return data.battleMonster.atk * 10},
    },
    '祈祷之语' : {
        name : '祈祷之语',
        type : 'berserk',
        text : '血量低于50%时使用，进行一次基于攻击力的检定，鉴定通过则获得邪恶赐福状态，每回合恢复30%生命值，持续3回合，并且攻击力翻倍，玩家损失3d6理智。检定不通过攻击力提高50%。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.5) && !data.battleMonster.berserk},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.berserk = true;
            if(verification(false, data.battleMonster.atk)){
                addStatus(data.battleMonster, getStatus('邪恶赐福', {num : 3, addHp : parseInt(data.battleMonster.maxHp * 0.3)}))
                data.battleMonster.atk *= 2;
                const reduceSan = ndx(3);
                reduceObjSan(data, reduceSan);
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了祈祷之语，获得了未知存在的回应，攻击翻倍，并获得邪恶赐福。你听见了未知的低语，理智减少${reduceSan}`);
            }else{
                data.battleMonster.atk = parseInt(data.battleMonster.atk * 0.5);
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了祈祷之语，虽然没有获得回应，但是依旧陷入了亢奋中，攻击提高50%。`);
            }
        },
    },
    '水行强袭' : {
        name : '水行强袭',
        type : 'atk',
        text : '在有水源的地形（该地形可以生成水源即算，不需要可采集资源中有水源存在）战斗时代替普通攻击使用，造成2倍伤害，并有10%概率给玩家附加“反应不及”状态，无法行动1回合。',//技能说明
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('反应不及')
            }
            return null
        },
        check : function(){
            let terrainElement = terrainElements[data.world.map[data.location[1]][data.location[0]]];
            if(!terrainElement){
                return false;
            }
            return Object.keys(terrainElement.elements).indexOf('水源') != -1;
        },
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '毒爆' : {
        name : '毒爆',
        type : 'atk',
        text : '玩家身上有蛇毒状态时使用，造成2倍伤害',
        check : function(){
            return hasStatus(data, '蛇毒');
        },
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '噬咬' : {
        name : '噬咬',
        type : 'atk',
        text : '该技能代替普通攻击使用，有30%几率给玩家附加蛇毒状态，每回合造成怪物当前攻击力的伤害，持续3回合',//技能说明
        getStatus : function(){
            if(randomNum(1,100) <= 30){
                return getStatus('蛇毒', {harm : data.battleMonster.atk})
            }
            return null
        },
        check : function(){return true;},
        getNum : function(){return data.battleMonster.atk},
    },
    '喷吐' : {
        name : '喷吐',
        type : 'atk',
        text : '20%概率使用，使玩家中毒，每回合造成相当于怪物攻击力50%的伤害，持续10回合，并降低玩家相当于怪物攻击力20%的防御力',
        getStatus : function(){
            data.def -= parseInt(data.battleMonster.atk * 0.2);
            return getStatus('中毒', {harm : parseInt(data.battleMonster.atk * 0.5), num : 10})
        },
        check : function(){return randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk},
    },
    '疯狂撕咬' : {
        name : '疯狂撕咬',
        type : 'atk',
        text : '血量低于30%时，代替普通攻击使用，造成2倍伤害，并有20%几率使玩家陷入僵直状态，无法行动，持续1回合',
        getStatus : function(){
            if(randomNum(1,100) <= 20){
                return getStatus('僵直')
            }
            return null
        },
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.3)},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '钻地突袭' : {
        name : '钻地突袭',
        type : 'atk',
        text : '代替普通攻击使用，造成1倍伤害，并有10%几率使玩家陷入反应不及状态，无法行动，持续1回合。100%给玩家附带寄生虫状态，每回合造成相当于怪物攻击力30%的伤害，该状态不会自动消失，也无法被清除负面状态的效果清除。每次使用钻地突袭时，玩家每有1层寄生虫状态，生命上限基于当前的生命上限临时降低1%',
        getStatus : function(){
            addStatus(data, getStatus('寄生虫', {harm : parseInt(data.battleMonster.atk * 0.3)}))

            let num = getStatuNum(data, '寄生虫') * 0.01
            if(num > 1){
                num = 1;
            }
            data.maxHp = parseInt(data.maxHp * (1 - num));
            addObjHp(data, 0)

            if(randomNum(1,100) <= 10){
                return getStatus('反应不及')
            }
            return null
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '适应' : {
        name : '适应',
        type : 'berserk',
        text : '10%几率使用，每损失1%生命值，增加1点防御',
        check : function(){return randomNum(1,100) <= 10},//用于判断使用条件是否满足
        getNum : function(){return 0},
        use : function(){
            const addNum = parseInt(parseInt(data.battleMonster.hp / data.battleMonster.maxHp * 100));
            data.battleMonster.def += addNum;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了适应，防御力增加了${addNum}`);
        },
    },
    '灵魂攻击' : {
        name : '灵魂攻击',
        type : 'atk',
        text : '代替普通攻击使用，造成1倍伤害，无视防御',
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
    },
    '制造旧日' : {
        name : '制造旧日',
        type : 'berserk',
        text : '米戈不喜欢战斗，但是既然你挑衅了它，那么它决定造一个旧日出来对付你。本技能代替攻击使用，给自己附加一层制造旧日状态，该状态不会自动消失，也无法使用清除BUFF的效果清除。当制造旧日状态达到10层，将清空制造旧日状态，并减少你1d100的理智，并造成减少的理智*100的伤害，该伤害无视防御，无视护盾，无视减伤，不会波动。如果你的理智小于等于0，将陷入永恒的疯狂',
        check : function(){return true},//用于判断使用条件是否满足
        getNum : function(){return 0},
        use : function(){
            addStatus(data.battleMonster, getStatus('制造旧日'))

            if(getStatuNum(data.battleMonster, '制造旧日') >= 10){
                removeStatus(data.battleMonster, '制造旧日')
                const num = ndx(1,100);
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}制造出了无法描述的生物，你的理智减少了${num}，该生物对你造成了${num * 100}伤害`);
                data.hp -= num * 100;
                reduceObjSan(data, num);
            }
        },
    },
    '践踏' : {
        name : '践踏',
        type : 'atk',
        text : '20%概率使用，造成3倍伤害，并有10%几率使玩家陷入反应眩晕状态，无法行动，持续1回合',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '双重利爪' : {
        name : '双重利爪',
        type : 'atk',
        text : '代替普通攻击使用，造成随机100%~200%的伤害，并有20%概率给玩家附加流血',
        check : function(){return true},
        getNum : function(){return randomNum(data.battleMonster.atk, data.battleMonster.atk * 2)},
    },
    '替换身体' : {
        name : '替换身体',
        type : 'berserk',
        text : '1%概率使用，使用时进行一次极难的理智检定，每有10点克苏鲁学识，检定时获得1个奖励骰。检定通过则安然无恙，不通过则被伊斯占据身体，直接死亡。该技能一场战斗只会触发一次',
        check : function(){return !data.battleMonster.thst && randomNum(1, 100) <= 1},//用于判断使用条件是否满足
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.thst = true;
            if(verification(false, data.san, 5, parseInt(getCthulhuScholarship() / 10))){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}试图和你互换身体，但是你强大的意志使你免疫了本次控制`);
            }else{
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}和你互换了身体，你死亡了`);
                die();
            }
        },
    },
    '缠绕' : {
        name : '缠绕',
        type : 'atk',
        text : '20%几率使用(玩家拥有束缚状态时不会使用)，造成1倍伤害，并有使玩家陷入束缚状态，无法行动，持续随机1~3回合',
        getStatus : function(){
            return getStatus('束缚', {num : randomNum(1, 3)})
        },
        check : function(){return getStatuNum(data, '束缚') <= 0 && randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk},
    },
    '撕扯' : {
        name : '撕扯',
        type : 'atk',
        text : '代替普通攻击使用，造成1倍伤害，并有使玩家陷入放血状态，所有治疗效果降低75%，持续随机3回合',
        getStatus : function(){
            return getStatus('放血')
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '纠缠' : {
        name : '纠缠',
        type : 'atk',
        text : '代替普通攻击使用，造成1倍伤害，并有30%几率给玩家附加一层纠缠状态，最多5层，该状态不会自动消失。玩家每有1层纠缠状态，纠缠状态便会给玩家造成古老者攻击力50%的伤害',
        getStatus : function(){
            if(getStatuNum(data, '纠缠') < 5 && randomNum(1, 100) <= 30){
                return addStatus(data, getStatus('纠缠', {harm : parseInt(data.battleMonster.atk * 0.5 * (getStatuNum(data, '纠缠') + 1))}))
            }
            return null
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '粘液之爪' : {
        name : '粘液之爪',
        type : 'atk',
        text : '代替普通攻击使用，造成1倍伤害，并给玩家附加腐蚀状态，每回合造成攻击力*50%的伤害，持续3回合',
        getStatus : function(){
            return getStatus('腐蚀', {harm : parseInt(data.battleMonster.atk * 0.5)})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '舌笞' : {
        name : '舌笞',
        type : 'atk',
        text : '15%概率使用，造成1倍伤害，吸收玩家5d6的攻击力',
        getStatus : function(){
            const num = ndx(5,6);
            data.atk -= num;
            data.battleMonster.atk += num;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}吸收了你${num}点攻击力`);
            return null
        },
        check : function(){return randomNum(1, 100) <= 15},
        getNum : function(){return data.battleMonster.atk},
    },
    '群星闪耀' : {
        name : '群星闪耀',
        type : 'atk',
        text : '10%概率使用，造成随机2~3倍伤害',
        check : function(){return randomNum(1, 100) <= 10},
        getNum : function(){return randomNum(data.battleMonster.atk * 2, data.battleMonster.atk * 3)},
    },
    '血肉融合' : {
        name : '血肉融合',
        type : 'berserk',
        text : '5%概率使用，减少你2d6*100的生命上限，并恢复减少的生命上限*3d6的生命值',
        check : function(){return randomNum(1, 100) <= 50},
        getNum : function(){return 0},
        use : function(){
            const num = ndx(2,6) * 100;
            data.maxHp -= num;
            addObjHp(data, 0);
            const addHp = num * ndx(3, 6);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了血肉融合，恢复了${battleAddHp(data.battleMonster, addHp)}生命值，你的生命上限减少${num}`);
        },
    },
    '星空低语' : {
        name : '星空低语',
        type : 'atk',
        text : '代替普通攻击使用，造成1.5倍伤害，并附加对你进行一次理智检定，检定不通过则减少1d6点理智，你每有10点克苏鲁学识，检定时获得一个奖励骰',
        getStatus : function(){
            if(!verification(false, data.san, 1, parseInt(getCthulhuScholarship() / 10))){
                const num = ndx(1, 6);
                reduceObjSan(data, num);
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}的低语让你无法承受，你的理智减少了${num}`);
            }
            return null
        },
        check : function(){return true},
        getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
    },
    '触须之口' : {
        name : '触须之口',
        type : 'atk',
        text : '代替普通攻击使用，造成随机1~3倍伤害',
        check : function(){return true},
        getNum : function(){return randomNum(1, data.battleMonster.atk * 3)},
    },
    '闪烁' : {
        name : '闪烁',
        type : 'berserk',
        text : '自身没有闪烁状态时有20%概率使用，给自身增加闪烁状态，每回合恢复10%生命值',
        check : function(){return getStatuNum(data.battleMonster, '闪烁') <= 0 && randomNum(1, 100) <= 20},
        getNum : function(){return 0},
        use : function(){
            addStatus(data.battleMonster, getStatus('闪烁', {addHp : parseInt(data.battleMonster.maxHp * 0.1)}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了闪烁`);
        },
    },
    '星光' : {
        name : '星光',
        type : 'atk',
        text : '20%概率使用，造成2倍伤害，并给玩家附加目盲状态，降低30%命中率，持续3回合',
        getStatus : function(){
            return getStatus('目盲')
        },
        check : function(){return randomNum(1, 100) <= 20},
        getNum : function(){return data.battleMonster.atk * 2},
    },
}

monsterSkillMapping = {
    ...monsterSkillMapping,
    '妖鬼' : ['利爪','痊愈'],
    '深潜者' : ['祈祷之语','水行强袭'],
    '蛇人' : ['毒爆', '噬咬'],
    '地穴魔虫' : ['喷吐','疯狂撕咬'],
    '巨噬蠕虫' : ['钻地突袭'],
    '月兽' : ['适应','灵魂攻击'],
    '米戈' : ['制造旧日'],
    '古革巨人' : ['践踏','双重利爪'],
    '伊斯' : ['替换身体','缠绕','撕扯'],
    '古老者' : ['纠缠'],
    '廷达罗斯猎犬' : ['舌笞','粘液之爪'],
    '星之眷族' : ['血肉融合','群星闪耀','星空低语'],
    '深渊之民' : ['触须之口'],
    '星之彩' : ['闪烁','星光'],
}

//怪物掉落的物品都可以在灵感触动直接获得
let cthulhuMonsterItems = [];
Object.keys(cthulhuMonsters).forEach(e => {
    cthulhuMonsterItems = [...cthulhuMonsterItems,...cthulhuMonsters[e].items.filter(i => i.name !== '旧日笔记').map(i => ({name : i.name, inspiration : 1, reduceSan : 0}))];
})
//灵感触动列表
const inspirationStruckList = {
    //获取物品
    get : [{
        name : '干枯的触手',
        inspiration : 0,//克苏鲁学识要求
        reduceSan : 10,//获得时降低理智
    },{
        name : '奇怪的液体',
        inspiration : 0,
        reduceSan : 30,
    },{
        name : '旧日笔记',
        inspiration : 0,
        reduceSan : 0,
    },{
        name : '旧印',
        inspiration : 50,
        reduceSan : 20,
    },...cthulhuMonsterItems],
    //触发战斗
    battle : ['妖鬼', '深潜者','蛇人','地穴魔虫','巨噬蠕虫','月兽','米戈','古革巨人','伊斯','古老者','廷达罗斯猎犬','星之眷族','深渊之民','星之彩'],
}

//灵感触动
function inspirationStruck(){
    if(randomNum(1,100) <= 50){//获得物品
        const items = inspirationStruckList.get;
        const random = items.filter(e => e.inspiration <= getCthulhuScholarship()).getRandom();

        let text = `你的灵感让你发现了1个${random.name}`;
        if(random.reduceSan){
            reduceObjSan(data, random.reduceSan);
            text += `，但是这扭曲的物品让你的理智降低了${random.reduceSan}`;
        }
        addItem(random.name)
        msg(text);
        renderBag();
        save();

    }else{//触发战斗
        const monster = inspirationStruckList.battle.filter(e => {
            return cthulhuMonsters[e].level <= data.world.level[1];
        }).getRandom();
        msg('你遭遇了' + monster)
        startBattle(monster, data.weapon && data.weapon.name === '旧印')
    }
    renderMapElements();
}

//投骰子
function ndx(n = 1,x = 6){
    let count = 0;
    for(let i = 0 ; i < n ; i++){
        count += randomNum(1, x);
    }

    return count;
}

/**
 * 1d100的检定，可接受奖励骰或惩罚骰
 * @param attr 要检定的属性值，默认检定克苏鲁学识
 * @param diff 难度，默认为1，2为困难检定，5为极难检定
 * @param num 奖励或惩罚骰的数量，默认0
 * @param reward 是否是奖励骰，默认是
 * @return 检定成功返回true,否则返回false
 */
function verification(printLog = true, attr = getCthulhuScholarship(), diff = 1, num = 0, reward = true){
    function getVal(a,b){
        if(a === 0 && b === 0){
            return 100;
        }
        return a * 10 + b;
    }

    const tens = randomNum(0,9);//十位数
    const ones = randomNum(0,9);//个位数
    //最终值
    let val = getVal(tens, ones);

    //奖励或者惩罚骰
    if(num > 0){
        for(let i = 0 ; i < num ; i++){
            const newVal = getVal(randomNum(0,9), ones);
            if(reward){
                if(newVal < val){
                    val = newVal;
                }
            }else{
                if(newVal > val){
                    val = newVal;
                }
            }
        }
    }

    if(diff === 5){
        attr = parseInt(attr / 5);
    }else if(diff === 2){
        attr = parseInt(attr / 2);
    }

    if(printLog && conf.showVerification){
        const text = `${diff === 5 ? '极难' : diff === 2 ? '困难' : '普通'}检定${num > 0 ? `${num}个${reward ? '奖励' : '惩罚'}骰` : ''}：${val}/${attr}，检定${val <= attr ? '成功' : '失败'}`;
        inBattle() ? addBattleLog(text) : msg(text);
    }

    return val <= attr;
}

//获取克苏鲁学识
function getCthulhuScholarship(){
    return (data.race.name.startsWith('断肠人') ? 99 : 100) - data.maxSan;
}

//获取理智加成的攻击力
function getSanAtk(atk = 0){
    const addAtk = data && getCthulhuScholarship() > 0 ? getCthulhuScholarship() : 0;

    let add = parseInt(atk * (0.01 * addAtk))
    if(add < addAtk){
        add = addAtk;
    }

    return atk + add;
}

//渲染古神祭坛
function renderCthulhuAltar(){
    $('.cthulhu-altar').show();
    $('.cthulhu-altar .buy').html('');
    $('.cthulhu-altar .draw-num').html(`吸引值：${data.drawNum || conf.drawNum}`);
    data.bag.filter(e => e.draw > 0).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name">${e.name}*${e.quantity}</div></div>`;
        html += `<div><div class="price">吸引值：${e.draw}*${e.quantity}=${e.draw*e.quantity}</div><div class="buy-btns">`;
        html += `<button class="sell-draw" data-name="${e.name}">献祭</button>`;
        html += `</div></div>`;
        $('.cthulhu-altar .buy').append(html);
    })
}
//献祭
$('.cthulhu-altar .buy').on('click', '.sell-draw', function(){
    const name = $(this).attr('data-name');
    let item = getBagItemByName(name);
    if(data.race.challenge){
        data.drawNum += item.draw * item.quantity;
    }else{
        conf.drawNum += item.draw * item.quantity;
    }
    reduceItem(name, item.quantity);
    renderCthulhuAltar()
    save();
    save(confSavedName, conf);
})

//渲染扭曲熔炉
function renderWarpSmelter(){
    $('.warp-smelter-equips').html('');
    $('.warp-smelter-equip-info').attr('data-id','').html('');
    $('.warp-smelter-need span').html(`0/${data.drawNum || conf.drawNum}`);
    data.bag.forEach(e => {
        if(e.name.startsWith('技能石：')){
            return;
        }
        if(elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor){
            $('.warp-smelter-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
    $('.warp-smelter').show();
}
//选中装备时
$('.warp-smelter-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = getBagItemById(id);
    const text = getItemInfo(item, true)
    const level = parseInt(item.level / 10 + 1);
    const quality = item.quality + 1;
    let needNum = level * level * level * 3 * quality;
    $('.warp-smelter-need span').html(`${needNum}/${data.drawNum || conf.drawNum}`);

    //渲染窗口文本
    $('.warp-smelter-equip-info').attr('data-id',id).html(text);
});
//确认
$('.warp-smelter-start .start').click(function(){
    //获取装备信息
    const id = $('.warp-smelter-equip-info').attr('data-id');
    const item = getBagItemById(id);
    const level = parseInt(item.level / 10 + 1);
    const quality = item.quality + 1;
    const needNum = level * level * level * 3 * quality;
    const orderX = data.order - 1;

    if(!id){
        winMsg('请选择要扭曲的装备',false, false);
        return;
    }
    if(data.race.challenge ? data.drawNum < needNum : conf.drawNum < needNum){
        winMsg('吸引值不足',false, false);
        return;
    }

    //开始扭曲
    let isEquiped = false;
    if((data.weapon && data.weapon.id === id) || (data.armor && data.armor.id === id)){
        isEquiped = true;
        equip(item);
    }

    if(item.warpSmelter){
        item.warpSmelter.forEach(e => {
            item[e.attr] -= e.num;
            if(e.attr === 'endurance'){
                item.maxEndurance -= e.num;
            }
        })
    }
    item.warpSmelter = [];
    //循环创建词条
    const attrs = {
        atk : () => ndx(level, 6) * orderX,
        def : () => ndx(level, 6) * orderX,
        suck : () => ndx(level, 4),
        defProp : () => parseFloat(((parseInt(level / 2) + 1) / 100).toFixed(2)),
        endurance : () => ndx(level, 20) * orderX * 3,
        hp : () => ndx(level, 20) * orderX * 3,
    };
    const keys = Object.keys(attrs);
    for(let i = 0 ; i < quality ; i++){
        const attr = keys.getRandom();
        const num = attrs[attr]();
        item.warpSmelter.push({attr, num})
        item[attr] += num;
        if(attr === 'endurance'){
            item.maxEndurance += num;
        }
        if(attr === 'defProp'){
            item.defProp = parseFloat(parseFloat(item.defProp).toFixed(2))
        }
    }

    //减少吸引值
    if(data.race.challenge){
        data.drawNum -= needNum;
    }else{
        conf.drawNum -= needNum;
    }

    item.defProp = parseFloat(item.defProp.toFixed(2))
    winMsg(`扭曲成功`);

    if(isEquiped){
        equip(item);
    }

    renderWarpSmelter()
    save();
    save(confSavedName, conf);
});
