//每个地图的可交易商品配置
const goods = {
    '孤岛' : {
        '资源' : ['纤维','草药','铁矿','铜矿','木材','树枝','燧石','石头','魔晶石','芦苇','贝壳'],
        '食物' : ['浆果','仙人掌肉','水','鱼','螃蟹','肉'],
        '素材' : ['粘液','软皮','碎布片','铁片','尖牙','利爪','兽皮','蜘蛛丝','毒囊','蛇胆','甲壳','羽毛','布','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '料理' : ['烤肉','烤鱼','鱼汤','蟹肉大餐'],
        '药品' : ['草药膏'],
        '稀有物品' : ['技能石：重击','哥布林之心','哥布林魔晶','灵魂威慑','闪耀的皮','神性结晶','神性液体'],
    },
    '地底' : {
        '资源' : ['纤维','木材','树枝','燧石','石头','红水晶','纯净水晶','黑曜石', '魔晶石'],
        '食物' : ['鱼','蘑菇','肉','水'],
        '素材' : ['布','铁锭','铜锭','金锭','铁片','尖牙','骨头','魔核','矮人胡环','硬皮','硬壳','兽骨','火结晶','火焰灰烬','灵魂残片','血肉精华','荧光粉','虚空粉尘','变异核心'],
        '料理' : ['烤肉','烤鱼','鱼汤','蘑菇煲'],
        '药品' : ['微光蘑菇','蘑菇药膏'],
        '稀有物品' : ['技能石：重击','哥布林之心','哥布林魔晶','灵魂石','残破的剑','遗忘之魂','灵魂威慑','地穴领主之爪','地穴领主的壳','神性结晶','神性魂石','远古精魄'],
    },
    '海脊' : {
        '资源' : ['珊瑚','珍珠','蓝水晶','纯净水晶'],
        '食物' : ['鱼','肉','水','贝肉','藤壶', '蟹肉'],
        '素材' : ['鱼人鳞片', '鱼人牙齿', '鱼人眼球', '螃蟹壳', '巨大蟹钳', '蓝鳞蛇皮', '蛇胆', '海龟壳', '海胆毒刺', '海胆皮', '元素水', '水之核'],
        '料理' : ['烤肉','烤鱼','鱼汤','蟹肉大餐','烤干贝'],
        '稀有物品' : ['技能石：重击','哥布林之心','哥布林魔晶','遗忘之魂','神性结晶','灵魂威慑', '潮汐之眼', '海浪之鳞', '潮汐之心', '海象角', '海象皮', '海象牙', '蓝光鳞片', '光辉鱼眼', '冰凉鱼油'],
    },
    '半岛' : {
        '资源' : ['纤维','草药','铁矿','铜矿','木材','树枝','燧石','石头','魔晶石','贝壳','羊毛','紫晶','魔力水晶'],
        '食物' : ['浆果','羊肉','魔兽肉','水','鱼','螃蟹','血肉花蕊'],
        '素材' : ['粘液','铁锭','铜锭','金锭','史莱姆精华','史莱姆核心','坚韧软皮','哥布林手爪','哥布林残刃','破口袋','魔兽骨','魔兽皮','魔兽爪','暗影血肉','虎皮','角蛇的角','疾风鹰羽','柔韧根茎','雷角','蝎尾狮的尾巴','兽人之牙','兽人之心','灵魂晶粉','虚空粉尘','变异核心'],
        '料理' : ['烤鱼','鱼汤'],
        '药品' : ['草药膏','特效草药膏','血肉药膏','食人花汁'],
        '稀有物品' : ['紫晶之核','魔力之源','疯狂之血','疯狂的心','神性结晶','神性紫晶','神性枢纽','地穴领主之爪','地穴领主的壳'],
    },
    '大陆' : {
        '资源' : ['纤维','草药','铁矿','铜矿','木材','树枝','燧石','石头','魔晶石','羊毛'],
        '食物' : ['浆果','仙人掌肉','羊肉','魔兽肉','水','鱼'],
        '素材' : ['强酸粘液','酸性软皮','战刀残片','重甲零件','狼鞍','骨头杖','骨头项链','骨刺','毒牙','幽灵蛛丝','幽灵毒囊','剧毒尾刺','重壳','巨爪','巨牙','重皮','荒芜之核','亚龙鳞','亚龙肉','青牙','青牙兽皮','黄酮鳞','黄酮胆','大地之牙','大地之皮','氏族旗帜','兽人獠牙','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '料理' : ['烤鱼','鱼汤','亚龙肉排'],
        '药品' : ['草药膏','特效草药膏'],
        '稀有物品' : ['神性结晶','疯狂之血','疯狂的心','五彩蛟麟','魔蛟精血','魔蛟骨髓','不死印记','不灭灵魂','骑士颅骨','残破徽章','魔餍魂核','荒芜核心','荒芜麟爪','幼龙鳞','幼龙皮'],
    },
    '死地' : {
        '资源' : ['纤维','血肉树心','异化血肉','异化骨头','异化血液','异化大骨','灵魂结晶'],
        '食物' : ['血肉果实'],
        '素材' : ['骸骨', '亡灵骨刀', '亡灵骨杖', '尸水', '尸核', '幽魂碎片', '幽魂核心', '尸毒牙', '尸毒蛇皮', '灵魂血肉', '血肉核心', '染血屠刀', '尸巫法杖', '亡灵法核', '吸血鬼牙', '血族翅膀', '亡灵碎石', '血肉石翼', '骷髅马鞍', '骷髅骑枪', '血魔之心', '血魔残骸', '怨恨之魂', '诅咒核心','虚空粉尘','变异核心'],
        '药品' : ['灵魂草'],
        '稀有物品' : ['不死印记','不灭灵魂','死灵之书','灵魂护符','精铁断剑','大剑士徽章','龙鳞','龙皮','龙血','诅咒魂晶','神性结晶'],
    },
    '战场' : {
        '资源' : ['纤维','草药','木材','树枝','燧石','石头','芦苇'],
        '食物' : ['浆果','水','鱼','鱼汤'],
        '素材' : ['精密骨骼','骨质大剑','战士徽章','赐福铠甲','巨魔骨矛','巨魔颅骨','魔法宝石','法师帽','精密断弓','附魔箭矢','灰白的皮','枯朽粘液','赐福长枪','骑士徽章','鲜血图腾','鲜血骨爪','元素印记','女巫徽章','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '药品' : ['草药膏'],
        '稀有物品' : ['精铁断剑','大剑士徽章','冠军凭证','龙魂','巨龙之殇','神性结晶'],
    },
    '帝国' : {
        '资源' : ['纤维','草药','木材','树枝','燧石','石头','铁矿','铜矿','魔晶石'],
        '食物' : ['浆果','仙人掌肉','水','鱼','水果','鱼汤'],
        '素材' : ['负重锁链','染血锁环','狂信徽章','信仰雕像','卫士之盾','卫士徽章','制式战弓','制式箭矢','猎人陷阱','鲜血毛皮','淬毒匕首','精铁钩爪','浸水皮','战兽爪','白鳞','白皮','女妖手爪','女妖翅膀','女妖心脏','飓风魔核','飓风魔皮','龙兽肝脏','荣耀长枪','荣耀马鞍','神圣连枷','神圣长袍','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '药品' : ['强效治疗药剂'],
        '稀有物品' : ['水晶空瓶','战争号角','沙尘印记','暴风龙眼','神性结晶'],
    },
    '龙谷' : {
        '资源' : ['纤维', '草药', '木材', '树枝', '燧石', '石头', '铁矿', '铜矿', '魔晶石', '芦苇'],
        '食物' : ['浆果','水','鱼','鱼汤','亚龙肉排'],
        '素材' : ['烈焰亚龙牙', '亚龙鳞', '冰霜亚龙牙', '剧毒亚龙牙', '黑暗亚龙牙','亚龙肉','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '稀有物品' : ['龙鳞', '龙皮', '龙血', '红龙魂', '蓝龙魂', '绿龙魂', '黑龙魂','神性结晶'],
    },
    '神界' : {
        '资源' : ['纤维', '草药', '木材', '树枝', '燧石', '石头', '铁矿', '铜矿', '魔晶石','铁锭','铜锭','金锭','虚空粉尘','变异核心'],
        '食物' : ['浆果','水','鱼','鱼汤'],
        '稀有物品' : ['神性结晶'],
    },
    ...newMapElements.shop,
};

//商人有购买需要的概率
const merchantBuyRate = 100;
//商人出售物品总价值的范围
const merchantSellValue = [10,500000000];
//商人持有金币的范围
const merchantGold = [131413140, 913141314];
//售价比例
const sellGold = 0.2;

//商人列表
const merchants = ['弑魂叔','starfall','蓝鳞羽','dudu','Yan_ice','王气终','聪明的地蛋','煎商小柒','vader','影月','芒果','門音','hillditi','_Freezing_','黑商','卡戎','尚大智','魔行',"陆肆捌","五行缺钱","传说之歌","潇天陌","无","东玄","映星与晓月"];

//刷新交易所
function reloadExchange(){
    //兼容存档
    if(!data.world.exchange){
        data.world.exchange = {
            buyList : []
        };
    }
    if(!data.world.exchange.buyList){
        data.world.exchange.buyList = [];
    }

    //标注是否允许刷新交易所
    let flag = false;
    if(data.world.exchange.day !== new Date(data.date).format('yyyyMMdd')){
        data.world.exchange.day = new Date(data.date).format('yyyyMMdd');
        flag = true;
    }

    //刷新交易所
    if(flag){
        //可购买的物品列表
        data.world.exchange.buyList = [];

        //可能出售或者购买的物品种类
        const types = Object.keys(goods[data.world.name]);

        let merchantList = [...merchants];
        if(checkMonthName('行商之月')){
            merchantList = [...merchantList, ...merchantList.getRandom(parseInt(merchantList.length / 2))]
        }if(checkMonthName('缺货之月')){
            merchantList =  merchantList.getRandom(parseInt(merchantList.length / 2))
        }

        //循环所有商人
        merchantList.forEach(name => {
            //获取商人出售物品的类型
            const type = types.getRandom();
            //获取商人要出售的物品列表
            const goodList = goods[data.world.name][type];
            //随机获取一个商品
            const good = goodList.getRandom();
            //获取商人的出售价值
            const value = randomNum(merchantSellValue[0] * (data.worldIndex + 1) * (data.worldIndex + 1),merchantSellValue[1] * (data.worldIndex + 1) * (data.worldIndex + 1));
            //获取可以出售的个数
            let num = parseInt(value / elementCfgs[good].gold);
            //如至少出售1个
            if(num <= 0){
                num = 1;
            }
            data.world.exchange.buyList.push({
                name : good,//商品名
                num,//出售个数
                merchant : name,//商人
                gold : elementCfgs[good].gold,//单价
            });
        })
        save();
    }
}

//渲染交易所
function renderExchange(){
    //兼容存档
    if(data.gold == null){
        data.gold = 0;
    }

    //渲染金币数量
    $('.exchange .gold').html(`持有：${data.gold}金币`);

    //渲染可购买列表
    $('.exchange .buy').html('');
    const exchangeSearchArr = exchangeSearch ? exchangeSearch.split(/,|，/) : [];
    data.world.exchange.buyList.filter(e => exchangeSearchArr.length > 0 ? exchangeSearchArr.filter(n => e.name.indexOf(n) != -1).length > 0 : true).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name">${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span> * ${e.num}</div><div class="merchant">卖家：${e.merchant}</div></div>`;
        html += `<div><div class="price">单价：${e.gold * (data.race.name.startsWith('地精') ? 10 : 1)}金币</div></div><div class="buy-btns">`;
        html += `<button class="buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="1">买1个</button>`;
        html += `<button class="buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="10">买10个</button>`;
        html += `<button class="buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="100">买100个</button>`;
        html += `<button class="buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="${e.num}">全买</button>`;
        html += `</div>`;
        $('.exchange .buy').append(html);
    })

    //渲染可出售列表
    $('.exchange .sell').html('');
    let html = '';
    data.bag.forEach(e => {
        if(data.armor && data.armor.id === e.id){
            return;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return
        }
        if(data.weapon && data.weapon.id === e.id){
            return;
        }
        if(data.mount && data.mount.id === e.id){
            return;
        }
        if(e.isLock){
            return;
        }

        //售价为价值的五分之一
        const sellPrice = parseInt(sellGold * elementCfgs[e.name].gold);
        if(sellPrice <= 0){
            return;
        }

        html += `<div class="sell-item">`;
        html += `<div class="sell-item-name">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' :''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}(=${sellPrice})*${e.quantity}</div>`;
        html += `<button class="sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="9999999">所有</button>`;
        html += `<button class="sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="10">10个</button>`;
        html += `<button class="sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="1">1个</button>`;
        html += `</div>`;
    })
    $('.exchange .sell').append(html);
}

function getAllGoods(){
    const allGoodKeys = goods[data.world.name];
    let allGoods = [];
    Object.keys(allGoodKeys).forEach(key => {
        allGoods = [...allGoods,...allGoodKeys[key]]
    });
    return [...new Set(allGoods)].map(e => ({
        name : e,//商品名
        num : 100000,//出售个数
        merchant : '某开拓者',//商人
        gold : elementCfgs[e].gold,//单价
    }))
}

//渲染哥布林商人专属交易所
function renderGoblinExchange(){
    //兼容存档
    if(data.gold == null){
        data.gold = 0;
    }

    //渲染金币数量
    $('.exchange .gold').html(`持有：${data.gold}金币`);

    //渲染可购买列表
    $('.exchange .buy').html('');

    const exchangeSearchArr = exchangeSearch ? exchangeSearch.split(/,|，/) : [];
    getAllGoods().filter(e => exchangeSearchArr.length > 0 ? exchangeSearchArr.filter(n => e.name.indexOf(n) != -1).length > 0 : true).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name">${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span> * ${e.num}</div><div class="merchant">卖家：${e.merchant}</div></div>`;
        html += `<div><div class="price">单价：${e.gold}金币</div></div><div class="buy-btns">`;
        html += `<button class="goblin-buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="1">买1个</button>`;
        html += `<button class="goblin-buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="10">买10个</button>`;
        html += `<button class="goblin-buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="100">买100个</button>`;
        html += `<button class="goblin-buy-good-btn" data-merchant="${e.merchant}" data-name="${e.name}" data-num="${e.num}">全买</button>`;
        html += `</div>`;
        $('.exchange .buy').append(html);
    })

    //渲染可出售列表
    $('.exchange .sell').html('');
    let html = '';
    data.bag.forEach(e => {
        if(data.armor && data.armor.id === e.id){
            return;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return
        }
        if(data.weapon && data.weapon.id === e.id){
            return;
        }
        if(data.mount && data.mount.id === e.id){
            return;
        }
        if(e.isLock){
            return;
        }

        //售价为价值的一半
        const sellPrice = parseInt(0.5 * elementCfgs[e.name].gold);
        if(sellPrice <= 0){
            return;
        }

        html += `<div class="sell-item">`;
        html += `<div class="sell-item-name">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' :''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}(=${sellPrice})*${e.quantity}</div>`;
        html += `<button class="goblin-sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="9999999">所有</button>`;
        html += `<button class="goblin-sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="10">10个</button>`;
        html += `<button class="goblin-sell-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="1">1个</button>`;
        html += `</div>`;
    })
    $('.exchange .sell').append(html);
}

//切换交易所买卖
$('.exchange-menu').click(function(){
    $('.exchange-menu').removeClass('active');
    $(this).addClass('active');

    $('.exchange .sell,.exchange .buy').hide();
    $(`.${$(this).attr('data-type')}`).show();
});

//点击购买
$('.exchange .buy').on('click','.buy-good-btn',function(){
    //获取名称、数量和商人
    const name = $(this).attr('data-name');
    let num = parseInt($(this).attr('data-num'));
    const merchant = $(this).attr('data-merchant');
    //获取商品
    let good = data.world.exchange.buyList.filter(e => e.merchant === merchant && e.name === name)[0];
    if(num > good.num){
        num = good.num;
    }
    //获取价格
    let gold = elementCfgs[name].gold * num * (data.race.name.startsWith('地精') ? 10 : 1);
    if(gold > data.gold){
        num = parseInt(data.gold / (elementCfgs[name].gold  * (data.race.name.startsWith('地精') ? 10 : 1)));
        gold = elementCfgs[name].gold * num * (data.race.name.startsWith('地精') ? 10 : 1);
    }

    if(gold === 0){
        winMsg('金币不足');
    }else{
        //购物
        data.gold += gold;
        data.gold = parseFloat2Fiexd(data.gold);
        addItem(name,num);
        good.num -= num;
        if(good.num <= 0){
            data.world.exchange.buyList = data.world.exchange.buyList.filter(e => !(e.merchant === merchant && e.name === name));
        }

        winMsg(`购买${num}个${name}`);
        renderExchange();
        save();
    }
});

//点击卖出
$('.exchange .sell').on('click','.sell-item-btn',function(){
    //获取物品ID
    const id = $(this).attr('data-id');
    //获取物品名
    const name = $(this).attr('data-name');
    //获取出售数量
    let num = parseInt($(this).attr('data-num'));
    //获取背包中的物品数量
    const bagNum = getNumById(id);
    //保证出售数量不超过背包数量
    if(num > bagNum){
        num = bagNum;
    }

    //获取金币，售价为价值的五分之一
    const sellPrice = parseInt(sellGold * elementCfgs[getBagItemById(id).name].gold);
    const getNum = sellPrice * num;
    data.gold += getNum;
    data.gold = parseFloat2Fiexd(data.gold);

    //减少物品
    reduceItemById(id,num);
    winMsg(`出售[${name}]*${num}，获得${getNum}金币`)
    renderExchange();
    save();
});

//哥布林商人点击购买
$('.exchange .buy').on('click','.goblin-buy-good-btn',function(){
    //获取名称、数量和商人
    const name = $(this).attr('data-name');
    let num = parseInt($(this).attr('data-num'));
    const merchant = $(this).attr('data-merchant');
    //获取商品
    let good = getAllGoods().filter(e => e.name === name)[0];
    if(num > good.num){
        num = good.num;
    }
    //获取价格
    let gold = elementCfgs[name].gold * num;
    if(gold > data.gold){
        num = parseInt(data.gold / elementCfgs[name].gold);
        gold = elementCfgs[name].gold * num;
    }

    if(gold === 0){
        winMsg('金币不足');
    }else{
        //购物
        data.gold += gold;
        data.gold = parseFloat2Fiexd(data.gold);
        addItem(name,num);

        winMsg(`购买${num}个${name}`);
        renderGoblinExchange();
        save();
    }
});

//哥布林商人点击卖出
$('.exchange .sell').on('click','.goblin-sell-item-btn',function(){
    //获取物品ID
    const id = $(this).attr('data-id');
    //获取物品名
    const name = $(this).attr('data-name');
    //获取出售数量
    let num = parseInt($(this).attr('data-num'));
    //获取背包中的物品数量
    const bagNum = getNumById(id);
    //保证出售数量不超过背包数量
    if(num > bagNum){
        num = bagNum;
    }

    //获取金币，售价为价值的五分之一
    const sellPrice = parseInt(0.5 * elementCfgs[getBagItemById(id).name].gold);
    const getNum = sellPrice * num;
    data.gold += getNum;
    data.gold = parseFloat2Fiexd(data.gold);

    //减少物品
    reduceItemById(id,num);
    winMsg(`出售[${name}]*${num}，获得${getNum}金币`)
    renderGoblinExchange();
    save();
});
