//端午节怪物配置
const duanWuJieMonstrts = {
    '角木蛟' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '角宿木',minNum : 8, maxNum : 1}],
    },
    '亢金龙' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '亢宿金',minNum : 8, maxNum : 1}],
    },
    '氐土貉' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '氐宿土',minNum : 8, maxNum : 1}],
    },
    '房日兔' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '房宿日',minNum : 8, maxNum : 1}],
    },
    '心月狐' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '心宿月',minNum : 8, maxNum : 1}],
    },
    '尾火虎' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '尾宿火',minNum : 8, maxNum : 1}],
    },
    '箕水豹' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '端午节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '箕宿水',minNum : 8, maxNum : 1}],
    },
};
//中元节怪物配置
const zhongYuanJieMonstrts = {
    '兴风厉鬼' : {
        tags : ['幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 1,
        hp : 100000,
        atk : 800,
        def : 0,
        exp : 0,
        atkSpd : 6,
        type : '神话',
        isFestival : true,
        noOneKill : true,
        text : '中元节专属怪物，秒杀技能对该怪物无效',
        items : [{name : '厉鬼魂魄',minNum : 8, maxNum : 1}],
    },
};

//节日列表
const festivals = [
    {
        //节日名
        name : '双蛋活动',
        //节日日期文本
        dateText : '12月23日~1月3日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '1225',
            text : '圣诞节快乐！',
            dateText : '12月25日',
            gifts : {
                圣诞礼炮 : 20
            }
        },{
            dateType : '1',
            date : '0101',
            text : '元旦快乐！',
            dateText : '1月1日',
            gifts : {
                汤圆 : 20
            }
        }],
        //节日日期
        date : ['1223','1224','1225','1226','1227','1228','1229','1230','1230','1231','0101','0102','0103'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {
            '面粉' : createRecipesCfg({'小麦' : 2}, 1, '厨房'),
            '汤圆' : createRecipesCfg({'面粉' : 3,'水' : 2, '芝麻' : 1}, 1, '厨房'),
        },
        //节日元素
        elements : {
            '小麦丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '小麦',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '芝麻丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '芝麻',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '圣诞树' : new Element({canGather :true, time : 20, num : 10, day : 5, canHand : true, needItem : ['木斧','石斧','铁斧','光荣斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3},{name : '圣诞彩灯',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '芝麻' : new Element({text : '节日活动专属物品'}),
            '小麦' : new Element({text : '节日活动专属物品'}),
            '面粉' : new Element({text : '节日活动专属物品'}),
            '汤圆' : new Element({canUse : true, battleUse : true, hunger : 50, water : 10, hp : 50, voidDust : 10, gold : 50, text : '节日活动专属物品'}),
            '圣诞彩灯' : new Element({weight : 0, text : '节日活动专属物品，用于节日商店购买物品'}),
            '圣诞礼物' : new Element({canUse : true, weight : 0,func(){
                    const num = getNumByBag('圣诞礼物');
                    if(num > 1){
                        addItem('圣诞彩灯', randomNum(3 * num, 5 * num))
                        reduceItem('圣诞礼物', num - 1);
                    }else{
                        addItem('圣诞彩灯', randomNum(3, 5))
                    }
                    return true;
                }, text : '节日活动专属物品，用于节日商店购买物品，直接使用可以获得3-5个圣诞彩灯,使用时会直接用掉背包中所有的圣诞礼物'}),
            '圣诞礼炮' : new Element({isThrow : true, endurance : 1, voidDust : 20, gold : 100, throwFunc(){
                    addStatus(data.battleMonster, getStatus('圣诞快乐'))
                },
                myAtk : function(){
                    return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * (1 + (data.battleMonster ? getStatuNum(data.battleMonster, '圣诞快乐') * 0.2 : 0)))
                },
                text : '节日活动专属物品，投掷伤害等于玩家的攻击力+装备武器的攻击力，并给怪物附加圣诞快乐状态，该状态不会自动消失。怪物每有一层圣诞快乐状态，投掷伤害增加20%'}),
        },
        //节日怪物
        monsters : {
            '圣诞麋鹿' : {
                tags : ['魔兽'],
                items : [{name : '圣诞礼物',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '雪橇漂移',
                    type : 'atk',
                    text : '10%概率使用，使用装礼物的雪橇进行攻击，造成1.5倍伤害，但是车上的礼物被甩了下来，玩家可以获得1~3个圣诞彩灯，玩家通过这种方式获得的圣诞彩灯不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,3);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('圣诞彩灯', addNum)
                            addBattleLog(`雪橇上的礼物掉下来了，你获得了${addNum}个圣诞彩灯`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '圣诞礼炮' : {
                '圣诞彩灯' : 10,
                '圣诞礼物' : 1,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '草原' : {
                elements : {
                    ...terrainElement('小麦丛', [1,3], 5),
                    ...terrainElement('芝麻丛', [1,3], 5),
                }
            },
            '丘陵' : {
                elements : {
                    ...terrainElement('小麦丛', [1,3], 5),
                    ...terrainElement('芝麻丛', [1,3], 5),
                }
            },
            '森林' : {
                elements : {
                    ...terrainElement('圣诞树', [1,3], 5),
                }
            },
        },
    },
    {
        //节日名
        name : '春节活动',
        //节日日期文本
        dateText : '农历腊月廿八~正月初八',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '2',
            date : '0101',
            text : '新年快乐！',
            dateText : '正月初一',
            gifts : {
                大红包 : 100
            }
        }],
        //节日日期
        date : ['1228','1229','1230','0101','0102','0103','0104','0105','0106','0107','0108'],
        //日期类型，1=公历，2=农历
        dateType : '2',
        //节日配方
        recipes : {
            '面粉' : createRecipesCfg({'小麦' : 2}, 1, '厨房'),
            '饺子皮' : createRecipesCfg({'面粉' : 10,'水' : 3}, 1, '厨房', 5),
            '冬笋馅' : createRecipesCfg({'冬笋' : 5,'肉' : 10}, 1, '厨房', 5),
            '野菜馅' : createRecipesCfg({'野菜' : 10,'肉' : 10}, 1, '厨房', 5),
            '蘑菇馅' : createRecipesCfg({'蘑菇' : 10,'肉' : 10}, 1, '厨房', 5),
            '冬笋饺子' : createRecipesCfg({'冬笋馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
            '野菜饺子' : createRecipesCfg({'野菜馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
            '蘑菇饺子' : createRecipesCfg({'蘑菇馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
        },
        //节日元素
        elements : {
            '小麦丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '小麦',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '竹林' : new Element({canGather :true, mopUp : true, time : 10, num : 10, day : 5, getItem : [{name : '冬笋',minNum : 0, maxNum : 2}], text : '节日活动专属资源'}),
            '野菜丛' : new Element({canGather :true, mopUp : true, time : 5, num : 1, day : 3, getItem : [{name : '野菜',minNum : 1, maxNum : 1}], text : '节日活动专属资源'}),
            '小麦' : new Element({text : '节日活动专属物品'}),
            '面粉' : new Element({text : '节日活动专属物品'}),
            '饺子皮' : new Element({text : '节日活动专属物品'}),
            '冬笋' : new Element({text : '节日活动专属物品'}),
            '野菜' : new Element({text : '节日活动专属物品'}),
            '冬笋馅' : new Element({text : '节日活动专属物品'}),
            '野菜馅' : new Element({text : '节日活动专属物品'}),
            '蘑菇馅' : new Element({text : '节日活动专属物品'}),
            '冬笋饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个冬笋饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        let number = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.2);
                        data.atk += number;
                        text += '，攻击力提高' + number
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%攻击力(人物攻击+武器攻击总和的20%)，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '野菜饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个野菜饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        let number = parseInt(data.def * 0.2);
                        data.def += number;
                        text += '，防御力提高' + number
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%防御力，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '蘑菇饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个蘑菇饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        data.suck += 20;
                        text += '，吸血提高20%'
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%吸血，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '福到万家' : new Element({battleUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    if(data.battleMonster && !data.battleMonster.fdwj){
                        const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                        let text = `你使用了福到万家，恢复${battleAddHp(data, addHp)}HP`;
                        data.battleMonster.fdwj = true;
                        let addAtk = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.5);
                        let addDef = parseInt(data.def * 0.5);
                        if(addAtk > 200){
                            addAtk = 200;
                        }
                        if(addDef > 200){
                            addDef = 200;
                        }
                        data.atk += addAtk;
                        data.def += addDef;
                        text += `，攻击力提高${addAtk}，防御力提高${addDef}`;
                        addBattleLog(text)
                        return true;
                    }else{
                        winMsg('你已经使用过福到万家了', false, false)
                        return false;
                    }
                },
                myHp : function(){
                    return data.maxHp;
                },
                text : '节日活动专属物品，回复100%生命值，且攻击力(人物攻击+武器攻击总)和防御力提高50%(最多200点)，每场战斗只能使用一次'
            }),
            '大红包' : new Element({canUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    const num = getNumByBag('大红包');
                    if(num > 1){
                        const items = {};
                        const arr = '门迎百福人财旺户纳千祥阖家欢'.split('');
                        for(let i = 0 ; i < num ; i++){
                            const random = arr.getRandom();
                            if(!items[random]) {
                                items[random] = 0;
                            }
                            items[random]++;
                        }

                        Object.keys(items).forEach(e => {
                            addItem(e, items[e]);
                        })
                        reduceItem('大红包', num - 1);
                    }else{
                        addItem('门迎百福人财旺户纳千祥阖家欢'.split('').getRandom())
                    }
                    return true;
                },
                text : '节日活动专属物品，使用时一次打开背包中所有大红包。打开大红包可以获得“门迎百福人财旺”“户纳千祥阖家欢”这14个字中的随机1个字，也可以用于在节日商店直接购买指定的字'
            }),
            ...getBatchItem('门迎百福人财旺户纳千祥阖家欢'.split(''), new Element({canUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    let min = 99999999999999;
                    let flag = true;
                    '门迎百福人财旺户纳千祥阖家欢'.split('').forEach(e => {
                        const num = getNumByBag(e, data.location.join() === data.world.home.location.join())
                        if(num > 0){
                            if(num < min){
                                min = num;
                            }
                        }else{
                            flag = false;
                        }
                    })
                    if(flag){
                        '门迎百福人财旺户纳千祥阖家欢'.split('').forEach(e => {
                            reduceItemByAll(e, min)
                        })
                        addItem('福到万家', min)
                        winMsg(`你凑齐了${min}组对联，获得${min}个福到万家`)
                        return true;
                    }else{
                        winMsg('你还没有凑齐对联', false, false)
                        return false;
                    }
                },
                text : '当背包和仓库中凑齐了“门迎百福人财旺”“户纳千祥阖家欢”这14个字时，则组成一组对联。使用任意一个字，将消耗掉这一组对联，并获得1个[福到万家]。如果凑齐了多组对联，使用时会全部兑换为[福到万家]'
            }))
        },
        //节日怪物
        monsters : {
            '年兽' : {
                tags : ['魔兽'],
                items : [{name : '大红包',minNum : 3, maxNum : 3}],
                skills : [{
                    name : '恭喜发财',
                    type : 'atk',
                    text : '10%概率使用，造成1.5倍伤害，使用时玩家可以获得1个大红包，玩家通过这种方式获得的大红包不能超过怪物等级/10*3个',
                    getStatus : function(){
                        let addNum = 1;
                        const max = parseInt(data.battleMonster.level / 10 * 3);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('大红包', addNum)
                            addBattleLog(`你获得了${addNum}个大红包`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '门' : {
                '大红包' : 20,
            },
            '迎' : {
                '大红包' : 20,
            },
            '百' : {
                '大红包' : 20,
            },
            '福' : {
                '大红包' : 20,
            },
            '人' : {
                '大红包' : 20,
            },
            '财' : {
                '大红包' : 20,
            },
            '旺' : {
                '大红包' : 20,
            },
            '户' : {
                '大红包' : 20,
            },
            '纳' : {
                '大红包' : 20,
            },
            '千' : {
                '大红包' : 20,
            },
            '祥' : {
                '大红包' : 20,
            },
            '阖' : {
                '大红包' : 20,
            },
            '家' : {
                '大红包' : 20,
            },
            '欢' : {
                '大红包' : 20,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '草原' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                    ...terrainElement('小麦丛', [1,3], 5),
                }
            },
            '丘陵' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                    ...terrainElement('小麦丛', [1,3], 5),
                }
            },
            '河滩' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                }
            },
            '森林' : {
                elements : {
                    ...terrainElement('竹林', [1,3], 5),
                }
            },
            '山脉' : {
                elements : {
                    ...terrainElement('竹林', [1,3], 5),
                }
            },
        },
    },
    {
        //节日名
        name : '情人节活动',
        //节日日期文本
        dateText : '2月12日~2月16日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0214',
            text : '祝有情人终成眷属！',
            dateText : '2月14日',
            gifts : {
                爱神羽翼 : 100
            }
        }],
        //节日日期
        date : ['0212','0213','0214','0215','0216'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {
            '秘银锭' : createRecipesCfg({'秘银' : 20}, 1, '熔炉'),
            '巧克力' : createRecipesCfg({'可可豆' : 50}, 1, '厨房'),
            '戒托' : createRecipesCfg({'秘银锭' : 10}, 1),
            '灵魂晶核' : createRecipesCfg({'灵魂结晶' : 1000}, 1),
            '白水晶戒指' : createRecipesCfg({'戒托' : 1, '神性结晶' : 1}, 1),
            '紫水晶戒指' : createRecipesCfg({'戒托' : 1, '魔力之源' : 1}, 1),
            '灵晶戒指' : createRecipesCfg({'戒托' : 1, '灵魂晶核' : 1}, 1),
        },
        //节日元素
        elements : {
            '可可树' : new Element({canGather :true, time : 20, num : 10, day : 5, canHand : true, needItem : ['木斧','石斧','铁斧','光荣斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3},{name : '可可豆',minNum : 3, maxNum : 5}], text : '节日活动专属资源'}),
            '可可豆' : new Element({text : '节日活动专属物品'}),
            '爱神羽翼' : new Element({weight : 0, text : '节日活动专属物品，用于节日商店兑换物品'}),
            '秘银' : new Element({text : '节日活动专属物品'}),
            '秘银锭' : new Element({text : '节日活动专属物品'}),
            '灵魂晶核' : new Element({text : '节日活动专属物品'}),
            '巧克力' : new Element({canUse : true, hunger : 10, voidDust : 5, gold : 25, text : '节日活动专属物品，送给好感达到亲密的养成人物，如果是该养成人物第一次收到，则增加1000好感度。需要注意，只有好感达到亲密后送巧克力才会增加好感度，没达到亲密送了也白送，而且以后再送也不会加好感度了'}),
            '戒托' : new Element({text : '节日活动专属物品'}),
            '白水晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '白水晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    if(hasStatus(data.battleMonster, '封印')){
                        winMsg('对方已经被封印', false, false);
                        return false;
                    }
                    addStatus(data.battleMonster, getStatus('封印', {num : 5}))
                    addBattleLog(`你使用了${name}，${data.battleMonster.showName || data.battleMonster.name}获得了封印状态`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。给怪物增加封印状态，持续5回合'}),
            '紫水晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '紫水晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    let num = parseInt(data.battleMonster.def * 0.2)
                    if(num < 0){
                        num = 0;
                    }
                    data.battleMonster.def -= num;
                    data.def += num;
                    addBattleLog(`你使用了${name}，${data.battleMonster.showName || data.battleMonster.name}的防御力减少了${num}，你的防御力增加了${num}`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。减少对方20%的防御力，减少的数值加在你的防御力上'}),
            '灵晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '灵晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    addStatus(data, getStatus('灵魂守护'))
                    addBattleLog(`你使用了${name}，获得了灵魂守护状态`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。获得灵魂守护状态，本场战斗中死亡时复活，并恢复50%血量，如果理智小于等于0，则恢复为1点理智'}),
        },
        //节日怪物
        monsters : {
            '丘比特' : {
                tags : ['人型生物'],
                items : [{name : '爱神羽翼',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '羽毛攻击',
                    type : 'atk',
                    text : '10%概率使用，飞射出羽毛进行攻击，造成1.5倍伤害，玩家可以获得1~3个爱神羽翼，玩家通过这种方式获得的爱神羽翼不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,3);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('爱神羽翼', addNum)
                            addBattleLog(`你获得了${addNum}个爱神羽翼`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '秘银' : {
                '爱神羽翼' : 10,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '森林' : {
                elements : {
                    ...terrainElement('可可树', [1,3], 5),
                }
            },
        },
    },
    {
        //节日名
        name : '愚人节活动',
        //节日日期文本
        dateText : '3月30日~4月3日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0401',
            text : '愚人节快乐！',
            dateText : '4月1日',
            gifts : {
                欺诈宝石 : 10
            }
        }],
        //节日日期
        date : ['0330','0331','0401','0402','0403'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {},
        //节日怪物
        monsters : {},
        //节日商定专属商品
        shop : {
            '欺诈宝石' : {
                '欺诈宝石' : 1,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {},
        //怪物额外掉落
        monsterItems : [{
            name :  '欺诈宝石',
            minNum : 98,
            maxNum : 1,
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '恒星冷却炮',
            attr : {
                showName : '恒星冷却炮'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '大陆架粉碎器',
            attr : {
                showName : '大陆架粉碎器'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '二向箔',
            attr : {
                showName : '二向箔'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '反物质湮灭炮',
            attr : {
                showName : '反物质湮灭炮'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '黑洞生成器',
            attr : {
                showName : '黑洞生成器'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '宇宙坍塌枪',
            attr : {
                showName : '宇宙坍塌枪'
            }
        },{
            name :  '石矛',
            minNum : 98,
            maxNum : 1,
            showName : '星球分解炮',
            attr : {
                showName : '星球分解炮'
            }
        },{
            name :  '草甲',
            minNum : 98,
            maxNum : 1,
            showName : '钛合金护甲',
            attr : {
                showName : '钛合金护甲'
            }
        },{
            name :  '草甲',
            minNum : 98,
            maxNum : 1,
            showName : '暗物质防护衣',
            attr : {
                showName : '暗物质防护衣'
            }
        },{
            name :  '草甲',
            minNum : 98,
            maxNum : 1,
            showName : '反黑洞护甲',
            attr : {
                showName : '反黑洞护甲'
            }
        },{
            name :  '草甲',
            minNum : 98,
            maxNum : 1,
            showName : '神力隔绝服',
            attr : {
                showName : '神力隔绝服'
            }
        }]
    },
    {
        //节日名
        name : '清明节活动',
        //节日日期文本
        dateText : '4月3日~4月7日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [],
        //节日日期
        date : ['0403','0404','0405','0406','0407'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {
            '古墓' : new Element({canGather :true, time : 120, num : 1, needItem : ['铁镐','光荣镐'], getItem : [{name : '重生十字章',minNum : 1, maxNum : 1}]}),
        },
        //节日怪物
        monsters : {},
        //节日商定专属商品
        shop : {},
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '山脉' : {
                elements : {
                    ...terrainElement('古墓', [-48,1], 1),
                }
            },
        },
    },
    {
        //节日名
        name : '劳动节活动',
        //节日日期文本
        dateText : '4月29日~5月3日',
        //说明文本
        text : '采集任何资源都有几率获得劳动奖章，几率为千分之采集时间，即采集一个需要30分钟的资源，几率为千30。采集一个需要5分钟的资源，几率为千分之5。劳动奖章可以在节日商店兑换永不磨损的斧头和镐',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0501',
            text : '劳动节快乐！',
            dateText : '5月1日',
            gifts : {
                劳动奖章 : 10
            }
        }],
        //节日日期
        date : ['0429','0430','0501','0502','0503'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {
            '劳动奖章' : new Element({text : '节日活动专属物品'}),
            '光荣斧' : new Element({onlyOne :true, noWear : true, weight : 10, endurance : 1000, voidDust : 0, gold : 0, text : '节日活动专属物品'}),
            '光荣镐' : new Element({onlyOne :true, noWear : true, weight : 10, endurance : 1000, voidDust : 0, gold : 0, text : '节日活动专属物品'}),
        },
        //节日怪物
        monsters : {},
        //节日商定专属商品
        shop : {
            '光荣斧' : {
                '劳动奖章' : 100,
            },
            '光荣镐' : {
                '劳动奖章' : 100,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {},
    },
    {
        //节日名
        name : '儿童节活动',
        //节日日期文本
        dateText : '5月30日~6月3日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0601',
            text : '儿童节快乐！',
            dateText : '6月1日',
            gifts : {
                神话梦境卡 : 10
            }
        }],
        //节日日期
        date : ['0530','0531','0601','0602','0603'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {
            '儿时的梦' : new Element({canUse : true, weight : 0, func(){
                let numByBag = getNumByBag('儿时的梦');
                let count = 0;

                for(let i = 0 ; i < numByBag ; i++){
                    if(randomNum() <= 5){
                        count++;
                    }
                }
                if(count > 0){
                    addItem('普通梦境卡', count);
                    reduceItem('儿时的梦', numByBag - 1);
                    winMsg(`你想起了儿时的梦，获得${count}张普通梦境卡`)
                }else{
                    winMsg('你似乎做过一个很长的梦，但你不记得梦的内容了')
                }
                return true;
            },text : '节日活动专属物品，使用时会消耗背包中所有儿时的梦，消耗的每一个儿时的梦都有5%几率获得1张随机普通梦境卡'}),
            '普通梦境卡' : new Element({canUse : true, quality : 1, weight : 0, func(){
                    //获取可以获得的怪物
                    let filter = Object.keys(monsterCfgs).map(e => ({...monsterCfgs[e],name : e})).filter(e => !e.isNpc && !e.cthulhuMonster && e.level <= data.level && !e.type);
                    if(filter.length === 0){
                        winMsg('没有可以获得的怪物卡', false, false)
                        return false;
                    }

                    let numByBag = getNumByBag('普通梦境卡');
                    //记录获取更高级卡片的数量
                    let count = 0;
                    //记录获取怪物卡片的数量
                    const cards = {};

                    for(let i = 0 ; i < numByBag ; i++){
                        if(randomNum() <= 10){
                            count++;
                        }else{
                            //随机怪物
                            let random = filter.getRandom();
                            if(!cards[random.name]){
                                cards[random.name] = 0;
                            }
                            cards[random.name]++;
                            addItem('怪物梦境卡', 1, {
                                quality : 1,
                                showName : random.name + '卡',
                                monster : random.name
                            });
                        }
                    }

                    const logs = [];

                    if(count > 0){
                        logs.push(`你获得了${count}张精英梦境卡`)
                        addItem('精英梦境卡', count);
                    }
                    if(Object.keys(cards).length){
                        logs.push(`你获得了以下怪物卡：${Object.keys(cards).map(e => `${e}*${cards[e]}`).join('、')}`)
                    }

                    reduceItem('普通梦境卡', numByBag - 1);
                    winMsg(logs.join('，'))
                    return true;
                },text : '节日活动专属物品，使用时会消耗背包中所有普通梦境卡。消耗的每一张卡都有10%几率获得1张精英梦境卡，90%概率获得1张随机的等级不高于你当前等级的普通怪物梦境卡'}),
            '精英梦境卡' : new Element({canUse : true, quality : 2, weight : 0, func(){
                    //获取可以获得的怪物
                    let filter = Object.keys(monsterCfgs).map(e => ({...monsterCfgs[e],name : e})).filter(e => !e.isNpc && !e.cthulhuMonster && e.level <= data.level && e.type === '精英');
                    if(filter.length === 0){
                        winMsg('没有可以获得的怪物卡', false, false)
                        return false;
                    }

                    let numByBag = getNumByBag('精英梦境卡');
                    //记录获取更高级卡片的数量
                    let count = 0;
                    //记录获取怪物卡片的数量
                    const cards = {};

                    for(let i = 0 ; i < numByBag ; i++){
                        if(randomNum() <= 10){
                            count++;
                        }else{
                            //随机怪物
                            let random = filter.getRandom();
                            if(!cards[random.name]){
                                cards[random.name] = 0;
                            }
                            cards[random.name]++;
                            addItem('怪物梦境卡', 1, {
                                quality : 2,
                                showName : random.name + '卡',
                                monster : random.name
                            });
                        }
                    }

                    const logs = [];

                    if(count > 0){
                        logs.push(`你获得了${count}张传说梦境卡`)
                        addItem('传说梦境卡', count);
                    }
                    if(Object.keys(cards).length){
                        logs.push(`你获得了以下怪物卡：${Object.keys(cards).map(e => `${e}*${cards[e]}`).join('、')}`)
                    }

                    reduceItem('精英梦境卡', numByBag - 1);
                    winMsg(logs.join('，'))
                    return true;
                },text : '节日活动专属物品，使用时会消耗背包中所有精英梦境卡。消耗的每一张卡都有10%几率获得1张传说梦境卡，90%概率获得1张随机的等级不高于你当前等级的精英怪物梦境卡'}),
            '传说梦境卡' : new Element({canUse : true, quality : 3, weight : 0, func(){
                    //获取可以获得的怪物
                    let filter = Object.keys(monsterCfgs).map(e => ({...monsterCfgs[e],name : e})).filter(e => !e.isNpc && !e.cthulhuMonster && e.level <= data.level && e.type === '传说');
                    if(filter.length === 0){
                        winMsg('没有可以获得的怪物卡', false, false)
                        return false;
                    }

                    let numByBag = getNumByBag('传说梦境卡');
                    //记录获取更高级卡片的数量
                    let count = 0;
                    //记录获取怪物卡片的数量
                    const cards = {};

                    for(let i = 0 ; i < numByBag ; i++){
                        if(randomNum() <= 10){
                            count++;
                        }else{
                            //随机怪物
                            let random = filter.getRandom();
                            if(!cards[random.name]){
                                cards[random.name] = 0;
                            }
                            cards[random.name]++;
                            addItem('怪物梦境卡', 1, {
                                quality : 3,
                                showName : random.name + '卡',
                                monster : random.name
                            });
                        }
                    }

                    const logs = [];

                    if(count > 0){
                        logs.push(`你获得了${count}张神话梦境卡`)
                        addItem('神话梦境卡', count);
                    }
                    if(Object.keys(cards).length){
                        logs.push(`你获得了以下怪物卡：${Object.keys(cards).map(e => `${e}*${cards[e]}`).join('、')}`)
                    }

                    reduceItem('传说梦境卡', numByBag - 1);
                    winMsg(logs.join('，'))
                    return true;
                },text : '节日活动专属物品，使用时会消耗背包中所有传说梦境卡。消耗的每一张卡都有10%几率获得1张神话梦境卡，90%概率获得1张随机的等级不高于你当前等级的传说怪物梦境卡'}),
            '神话梦境卡' : new Element({canUse : true, quality : 4, weight : 0, func(){
                    //获取可以获得的怪物
                    let filter = Object.keys(monsterCfgs).map(e => ({...monsterCfgs[e],name : e})).filter(e => !e.isNpc && !e.cthulhuMonster && e.level <= data.level && e.type === '神话' && !e.noOneKill);
                    if(filter.length === 0){
                        winMsg('没有可以获得的怪物卡', false, false)
                        return false;
                    }

                    let numByBag = getNumByBag('神话梦境卡');
                    //记录获取怪物卡片的数量
                    const cards = {};

                    for(let i = 0 ; i < numByBag ; i++){
                        //随机怪物
                        let random = filter.getRandom();
                        if(!cards[random.name]){
                            cards[random.name] = 0;
                        }
                        cards[random.name]++;
                        addItem('怪物梦境卡', 1, {
                            quality : 4,
                            showName : random.name + '卡',
                            monster : random.name
                        });
                    }


                    reduceItem('神话梦境卡', numByBag - 1);
                    winMsg(`你获得了以下怪物卡：${Object.keys(cards).map(e => `${e}*${cards[e]}`).join('、')}`)
                    return true;
                },text : '节日活动专属物品，使用时会消耗背包中所有神话梦境卡。消耗的每一张卡都能获得1张随机的等级不高于你当前等级的神话怪物梦境卡，但是不会获得免疫秒杀效果的怪物的卡片'}),
            '怪物梦境卡' : new Element({canUse : true, quality :1, onlyOne : true, weight : 0, func(){
                startBattle(this.monster, true, false, true);
                battleWin(false, battleWinMin, false);
                    return true;
                },text : '节日活动专属物品，使用后触发和这张卡上的怪物的战斗，然后立刻获得胜利，并获取战斗奖励'}),
        },
        //节日怪物
        monsters : {
            '梦魇' : {
                tags : ['魔兽','幽灵','不死族'],
                items : [{name : '儿时的梦',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '探索记忆',
                    type : 'atk',
                    text : '10%概率使用，侵入你的精神，挖掘你儿时的记忆，造成1.5倍伤害，玩家可以获得1~2个儿时的梦，玩家通过这种方式获得的儿时的梦不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,2);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('儿时的梦', addNum)
                            addBattleLog(`你想起了曾经的梦境，你获得了${addNum}个儿时的梦`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '普通梦境卡' : {
                '儿时的梦' : 100,
            },
            '精英梦境卡' : {
                '普通梦境卡' : 20,
            },
            '传说梦境卡' : {
                '精英梦境卡' : 20,
            },
            '神话梦境卡' : {
                '传说梦境卡' : 20,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {},
    },
    {
        //节日名
        name : '端午节活动',
        //节日日期文本
        dateText : '农历5月3日~5月7日',
        //说明文本
        text : '仲夏端午，苍龙七宿飞升于正南中央，处在全年最“中正”之位，是谓“飞龙在天”。',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '2',
            date : '0505',
            text : '端午节快乐！',
            dateText : '农历5月5日',
            gifts : {
                房宿日 : 1,
                心宿月 : 1,
                亢宿金 : 1,
                角宿木 : 1,
                箕宿水 : 1,
                尾宿火 : 1,
                氐宿土 : 1,
            }
        }],
        //节日日期
        date : ['0503','0504','0505','0506','0507'],
        //日期类型，1=公历，2=农历
        dateType : '2',
        //节日配方
        recipes : {
            '阴阳交融' : createRecipesCfg({'房宿日' : 5, '心宿月' : 5}),
            '五行相生' : createRecipesCfg({'亢宿金' : 5, '角宿木' : 5, '箕宿水' : 5, '尾宿火' : 5, '氐宿土' : 5}),
            '坐骑：七宿苍龙' : createRecipesCfg({'阴阳交融' : 1, '五行相生' : 1}),
        },
        //节日元素
        elements : {
            '角宿木' : new Element({text : '节日活动专属物品'}),
            '亢宿金' : new Element({text : '节日活动专属物品'}),
            '氐宿土' : new Element({text : '节日活动专属物品'}),
            '房宿日' : new Element({text : '节日活动专属物品'}),
            '心宿月' : new Element({text : '节日活动专属物品'}),
            '尾宿火' : new Element({text : '节日活动专属物品'}),
            '箕宿水' : new Element({text : '节日活动专属物品'}),
            '阴阳交融' : new Element({text : '节日活动专属物品'}),
            '五行相生' : new Element({text : '节日活动专属物品'}),
            '坐骑：七宿苍龙' : new Element({isMount : true, quality : 4, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 1000, weightUp : 500, spd : 100, skills : {
                    '飞龙在天': createRecipesCfg({'纤维': 1}, 0, null, 1000),
                }, text : '端午节活动专属坐骑，只能从端午节活动获得'}),
        },
        //活动怪物
        monsters : {},
        //节日商店
        shop : {},
        //节日怪物
        festivalMonsters : duanWuJieMonstrts,
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '沼泽' : {
                monster : {
                    ...terrainMonster('角木蛟', 80, duanWuJieMonstrts),
                },
            },
            '山脉' : {
                monster : {
                    ...terrainMonster('亢金龙', 80, duanWuJieMonstrts),
                },
            },
            '坑洞' : {
                monster : {
                    ...terrainMonster('氐土貉', 80, duanWuJieMonstrts),
                },
            },
            '丘陵' : {
                monster : {
                    ...terrainMonster('房日兔', 80, duanWuJieMonstrts),
                },
            },
            '森林' : {
                monster : {
                    ...terrainMonster('心月狐', 80, duanWuJieMonstrts),
                },
            },
            '草原' : {
                monster : {
                    ...terrainMonster('尾火虎', 80, duanWuJieMonstrts),
                },
            },
            '湖泊' : {
                monster : {
                    ...terrainMonster('箕水豹', 80, duanWuJieMonstrts),
                },
            },
        },
    },
    {
        //节日名
        name : '七夕活动',
        //节日日期文本
        dateText : '8月20日~8月24日',
        //说明文本
        text : '七夕时节，牛宿星与织女星相会，若能与恋人相伴，自能安神。（白话文：七夕节期间，游戏时间的每天第一次和养成人物对话，可以恢复1点理智值。如果已经HappyEnd，则养成人物界面会多出一个“鹊桥仙”的选项，选择该选项，可将理智上线回满到100，即使是初始上线不足100的种族，也会补满到100，仅限一次）',
        //赠送礼物的时间和赠送的礼物
        giftDate : [],
        //节日日期
        date : ['0820','0821','0822','0823','0824'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {},
        //活动怪物
        monsters : {},
        //节日商店
        shop : {},
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {},
    },
    {
        //节日名
        name : '中元节活动',
        //节日日期文本
        dateText : '8月28日~9月1日',
        //说明文本
        text : '年已过半，鬼门大开，寻常幽魂只当归家探亲，却有些恶鬼乘机兴风作浪',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0830',
            text : '中元节快乐！',
            dateText : '8月30日',
            gifts : {
                厉鬼魂魄 : 1,
            }
        }],
        //节日日期
        date : ['0828','0829','0830','0831','0901'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {
            '技能石：灵魂出窍' : createRecipesCfg({'厉鬼魂魄' : 1, '残魂' : 100}),
        },
        //节日元素
        elements : {
            '残魂' : new Element({text : '节日活动专属物品'}),
            '厉鬼魂魄' : new Element({text : '节日活动专属物品'}),
            '技能石：灵魂出窍' : new Element({
                battleUse : true,
                weight : 0,
                voidDust : 0,
                quality : 1,
                gold : 0,
                func : function(){
                    if(data.battleMonster.lhcq){
                        winMsg('你已经是灵魂出窍状态了', false, false)
                        return false;
                    }
                    data.battleMonster.lhcq = true;

                    data.atkSpd += 5;
                    addBattleLog(`你的灵魂脱离了肉体，获得5点攻速加成`)
                    return true;
                },
                text : '中元节活动专属技能，没有肉体的限制，灵魂的攻击更加迅捷，增加5点攻速加成，每场战斗只能使用一次'
            }),
        },
        //节日怪物
        monsters : {
            '作恶游魂' : {
                tags : ['幽灵'],
                items : [{name : '残魂',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '散魂手',
                    type : 'atk',
                    text : '10%概率使用，消耗自身灵魂进行攻击，造成1.5倍伤害，玩家可以获得1~3个残魂，玩家通过这种方式获得残魂不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,3);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('残魂', addNum)
                            addBattleLog(`作恶游魂身上飘出一些残魂，你获得了${addNum}个残魂`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商店
        shop : {},
        //节日怪物
        festivalMonsters : zhongYuanJieMonstrts,
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '山脉' : {
                monster : {
                    ...terrainMonster('兴风厉鬼', 1, zhongYuanJieMonstrts),
                },
            },
        },
    },
    {
        //节日名
        name : '中秋国庆活动',
        //节日日期文本
        dateText : '9月27日~10月8日',
        //说明文本
        text : '国庆节普国同庆，活动期间，装备锻造属性浮动从80%~120%改为100~120%',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0927',
            text : '中秋节快乐！',
            dateText : '9月27日',
            gifts : {
                五仁月饼 : 10
            }
        },{
            dateType : '1',
            date : '1001',
            text : '国庆节快乐！',
            dateText : '10月1日',
            gifts : {
                幸运卷轴 : 1
            }
        }],
        //节日日期
        date : ['0927','0928','0929','0930','1001','1002','1003','1004','1005','1006','1007','1008'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {},
        //节日元素
        elements : {
            '月饼' : new Element({canUse : true, hunger : 20, hp : 5, text : '节日活动专属物品'}),
            '五仁月饼' : new Element({canUse : true, battleUse : true, hunger : 100, hp : 50, text : '节日活动专属物品'}),
        },
        //节日怪物
        monsters : {
            '玉兔' : {
                tags : ['魔兽'],
                items : [],
                skills : [{
                    name : '吃月饼叭~',
                    type : 'start',
                    text : '进入战斗时立刻使用。丢给玩家一个月饼，然后逃离战斗。如果玩家的等级小于等于玉兔等级+10（例如面对40级玉兔，玩家1~50级都符合该要求），玉兔则有1%几率丢给玩家一个五仁月饼，否则只会丢给玩家一个普通的月饼。',
                    check : function(){return false},
                    use : function(){
                        if(data.level <= data.battleMonster.level + 10 && randomNum() <= 1){
                            addItem('五仁月饼');
                            msg('玉兔丢给你1个五仁月饼，然后逃走了')
                        }else{
                            addItem('月饼');
                            msg('玉兔丢给你1个月饼，然后逃走了')
                        }
                        battleEnd();
                    },
                }]
            }
        },
        //节日商定专属商品
        shop : {},
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {},
    },
];

//格式化节日特定地图上允许出现的资源和怪物，图鉴用的
function formatFestivalTerrainElements(festivalTerrainElements){
    const items = {};
    Object.keys(festivalTerrainElements).forEach(e => {
        if(festivalTerrainElements[e].elements){
            Object.keys(festivalTerrainElements[e].elements).forEach(el => {
                if(!items[el]){
                    items[el] = [];
                }
                items[el].push(e);
            })
        }
    })

    if(Object.keys(items).length === 0){
        return '';
    }

    return Object.keys(items).map(e => `${e}：${items[e].join('，')}`).join('<br>') + '<br>'
}

//格式化节日特定地图上允许出现的资源和怪物，图鉴用的
function formatFestivalTerrainMonsters(festivalTerrainElements){
    const items = {};
    Object.keys(festivalTerrainElements).forEach(e => {
        if(festivalTerrainElements[e].monster){
            Object.keys(festivalTerrainElements[e].monster).forEach(el => {
                if(!items[el]){
                    items[el] = [];
                }
                items[el].push(e);
            })
        }
    })

    if(Object.keys(items).length === 0){
        return '';
    }

    return Object.keys(items).map(e => `${e}：${items[e].join('，')}`).join('<br>') + '<br>'
}

//获取当前节日
function getFestival(){
    const thisDay = new Date();
    const monthDay = thisDay.format('MMdd')
    const chineseMonthDay = thisDay.getChinese();
    const arr = festivals.filter(e => {
        return e.dateType === '1' ? e.date.indexOf(monthDay) !== -1 : e.date.indexOf(chineseMonthDay) !== -1;
    });
    if(arr.length > 0){
        return arr[0];
    }
    return null;
}
const festival = getFestival();

//获取节日赠礼
function getFestivalGift(thisDay){
    if(festival){
        const monthDay = thisDay.format('MMdd')
        const chineseMonthDay = thisDay.getChinese();
        const ts = festival.giftDate.filter(e => e.dateType === '1' ? e.date === monthDay : e.date === chineseMonthDay);
        if(ts.length > 0){
            if(!data.getedGift){
                data.getedGift = [];
            }
            if(!data.getedGift.includes(new Date().format('yyyy-MM-dd'))){
                return ts[0];
            }
        }
        return null;
    }
}

//获取节日专属配方
function getFestivalRecipes(){
    if(festival){
        return festival.recipes;
    }
    return {}
}

//获取节日专属资源
function getFestivalElements(){
    let datas = {};
    festivals.forEach(e => {
        datas = {
            ...datas,
            ...e.elements
        }
    })
    return datas
}

//加载节日专属资源所在地形
function loadFestivalTerrainElements(){
    if(festival){
        Object.keys(festival.terrainElements).forEach(e => {
            if(festival.terrainElements[e].elements){
                terrainElements[e].elements = {
                    ...terrainElements[e].elements,
                    ...festival.terrainElements[e].elements
                }
            }
            if(festival.terrainElements[e].monster){
                terrainElements[e].monster = {
                    ...terrainElements[e].monster,
                    ...festival.terrainElements[e].monster
                }
            }
        })


        const dungeonMaps = Object.keys(dungeons).map(e => dungeons[e].map);
        Object.keys(terrainElements).forEach(e => {
            if(dungeonMaps.includes(e)){
                return;
            }
            Object.keys(festival.monsters).forEach(fm => {
                allMapList.forEach(m => {
                    terrainElements[e].monster = {
                        ...terrainElements[e].monster,
                        ...terrainMonster(`${m.level[1]}级${fm}`, 1)
                    }
                })
            })
        })
    }
    return {}
}

function loadFestivalMonsters(){
    if(festival){
        if(festival.festivalMonsters){
            monsterCfgs = {
                ...monsterCfgs,
                ...festival.festivalMonsters
            }
        }
        Object.keys(festival.monsters).forEach(e => {
            allMapList.forEach((m, index) => {
                monsterCfgs = {
                    ...monsterCfgs,
                    [`${m.level[1]}级${e}`] : {
                        tags : festival.monsters[e].tags,
                        atkTime : '全天',
                        atkProb : 0,
                        level : m.level[1],
                        hp : monsterCfgs[m.finalBoss].hp / 10,
                        atk : monsterCfgs[m.finalBoss].atk,
                        def : monsterCfgs[m.finalBoss].def,
                        exp : monsterCfgs[m.finalBoss].exp / 10,
                        atkSpd : monsterCfgs[m.finalBoss].atkSpd,
                        type : '精英',
                        isFestival : true,
                        items : festival.monsters[e].items.map(i => ({name : i.name, minNum : i.minNum * (index + 1), maxNum : i.maxNum * (index + 1)})),
                        text : '节日活动专属怪物'
                    },
                }

                const skills = [];
                if(festival.monsters[e].skills.length > 0){
                    festival.monsters[e].skills.forEach(e => {
                        skills.push(e.name);
                    })
                }
                monsterSkillMapping = {
                    ...monsterSkillMapping,
                    [`${m.level[1]}级${e}`] : skills,
                }
            })

            //添加技能
            if(festival.monsters[e].skills.length > 0){
                festival.monsters[e].skills.forEach(e => {
                    monsterSkills = {
                        ...monsterSkills,
                        [e.name] : e
                    }
                })
            }
        })
    }
}
loadFestivalMonsters();

//渲染节日商店
function renderFestivalShop(){
    $('.wandering-merchant-shop').show();
    $('.wandering-merchant-shop .buy').html('');
    Object.keys(festival.shop).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name" style="width:100%;text-align: center"><h4 style="margin: 0px">${e}<span class="to-cybernet" data-name="${e}">🔍</span></h4></div></div>`;
        html += `<div style="height: ${(Object.keys(festival.shop[e]).length + 1) * 40}px">${Object.keys(festival.shop[e]).map(i => `<div class="price" style="float: unset">${i}：${festival.shop[e][i]}/${getNumByBag(i, data.location.join() === data.world.home.location.join())}</div>`).join('')}<div class="buy-btns">`;
        html += `<button class="buy-festival-good-btn" data-name="${e}" data-num="1">买1个</button>`;
        html += `<button class="buy-festival-good-btn" data-name="${e}" data-num="10">买10个</button>`;
        html += `</div></div>`;
        $('.wandering-merchant-shop .buy').append(html);
    })
}

//购买节日商店
$('.wandering-merchant-shop .buy').on('click','.buy-festival-good-btn',function(){
    const name = $(this).attr('data-name');
    const num = parseInt($(this).attr('data-num'));

    const needs = festival.shop[name];

    for(const key in needs){
        if(getNumByBag(key, data.location.join() === data.world.home.location.join()) < needs[key] * num){
            winMsg(key + '不足',false,false)
            return;
        }
    }

    for(const key in needs){
        reduceItemByAll(key, needs[key] * num)
    }

    winMsg(`购买了${name}*${num}`)
    addItem(name,num);
    renderFestivalShop();

    save();
});

function getFestivalCyberent(){
    let fes = [];
    let name = null;
    if(festival){
        name = festival.name;
        fes = [
            ...festivals.filter(f => f.name === festival.name),
            ...festivals.filter(f => f.name !== festival.name),
        ]
    }else{
        fes = festivals;
    }

    return `<p>在现实当中的有些节日，游戏内会举行节日活动，活动时可能会在一些地形产生特殊的资源，出现特定的配方。有的活动会有独有的节日怪物，只在特定的地形刷新。节日怪物的刷新将会无视地图等级，即孤岛也可能刷出100级的节日怪物。如果该活动有活动怪物（注意！活动怪物不是节日怪物），则在任何地图的任何地形都可能出现活动怪物，活动怪物在任何地形都有1%概率刷新，活动怪物的属性固定为当前等级对应地图的世界BOSS的初始攻防，血量和经验为世界BOSS的十分之一，固定为精英怪物。节日结束后对应的怪物会直接从页面消失，如果和活动怪物战斗中退出游戏，下次进入游戏时如果节日活动已经结束，则会直接退出战斗，而不是继续战斗。有些活动还会有特定的节日商品，可以通过使用节日活动中获取的道具兑换商品，当一个节日有节日商品出售时，在家里会出现一个节日商店。在节日当天，还会有额外赠送的礼物，只要进入游戏即赠送：</p><p><h4 style="text-align: center">各个节日的活动情况</h4>${fes.map(e => `<p><a style="${name === e.name ? 'font-size:18px;font-weight:bold;color:red;' : ''}" href="javascript:seeFestival('${e.name}')">${e.name}(${e.dateText})</a></p>`).join('')}</p>`
}

//查看节日详情
function seeFestival(name){
    const e = festivals.filter(f => f.name === name)[0];

    let html = `<h3>${e.name}</h3><p><h4>活动时间：</h4>${e.dateText}<br>${Object.keys(e.recipes).length > 0 ? `<h4>活动配方：</h4>${Object.keys(e.recipes).map(r => `${r}*${e.recipes[r].getNum}(${e.recipes[r].need ? e.recipes[r].need : facility4level[e.recipes[r].level].join('/')})=${Object.keys(e.recipes[r].items).map(it => `${it}*${e.recipes[r].items[it]}`).join(`+`)}`).join('<br>')}<br>` : ''}${Object.keys(e.monsters).length > 0 ? `<h4>活动怪物：</h4>${Object.keys(e.monsters).join(`，`)}<br>` : ''}${Object.keys(e.shop).length > 0 ? `<h4>节日商品：</h4>${Object.keys(e.shop).join(`，`)}<br>` : ''}${Object.keys(e.terrainElements).length > 0 ? `${formatFestivalTerrainElements(e.terrainElements) ? `<h4>节日资源：</h4>${formatFestivalTerrainElements(e.terrainElements)}` : ''}${formatFestivalTerrainMonsters(e.terrainElements) ? `<h4>节日怪物：</h4>${formatFestivalTerrainMonsters(e.terrainElements)}` : ''}` : ''}${e.monsterItems ? `<h4>怪物额外掉落：</h4>${e.monsterItems.map(mi => `${mi.showName || mi.name}(${mi.minNum}~${mi.maxNum})`).join('<br>')}` : ''}<h4>节日赠礼：</h4>${e.giftDate.map(g => `${g.dateText}：${Object.keys(g.gifts).map(gi => `${gi}*${g.gifts[gi]}`).join('+')}`).join('<br>')}${e.text ? `<h4>额外说明：${e.text}</h4>` : ''}`;

    $('.common-win').show().find('.win-body').html(html);
}

//点击查看当前节日
$('#festival').click(function(){
    seeFestival(festival.name);
})
