//状态类
let status = {
    '攻速积累' : {
        name : '攻速积累',
        num : 1,//生效次数
        sleep : false,//该状态是否会导致不行动
        canAddNum : true,//是否可增加生效次数
        type : 'buff',
        keep : true,//是否回合结束时不削减层数
        text : '积累到10层可以额外攻击一次'
    },
    '冰冻' : {
        name : '冰冻',
        num : 1,//生效次数
        harm : 0,//造成的伤害
        sleep : true,//该状态是否会导致不行动
        canAddNum : false,//是否可增加生效次数
        keep : false,//是否回合结束时不削减层数
        text : '无法行动'
    },
    '燃烧' : {
        name : '燃烧',
        num : 3,
        harm : 0,
        sleep : false,
        canAddNum : true,
        text : '每回合造成伤害'
    },
    '强酸' : {
        name : '强酸',
        type : 'buff',
        num : 3,
        returnHarm : 0,
        sleep : false,
        canAddNum : true,
        text : '受到攻击时，攻击方也会受到伤害'
    },
    '目盲' : {
        name : '目盲',
        num : 3,
        reduceHitRate : 30,
        sleep : false,
        canAddNum : true,
        text : '降低命中率，默认降低30%'
    },
    '丢失目标' : {
        name : '丢失目标',
        num : 1,
        reduceHitRate : 100,
        sleep : false,
        canAddNum : false,
        text : '降低100%命中率'
    },
    '封印' : {
        name : '封印',
        num : 3,
        sleep : false,
        canAddNum : false,
        seal : true,
        text : '无法使用技能'
    },
    '放血' : {
        name : '放血',
        num : 3,
        sleep : false,
        canAddNum : true,
        reduceRecover : 0.75,
        text : '减少战斗中所有治疗能力，默认75%'
    },
    '红王' : {
        name : '红王',
        num : 1,
        sleep : false,
        type : 'buff',
        canAddNum : true,
        text : '红桃和方片效果翻倍，黑桃和梅花效果减半'
    },
    '黑王' : {
        name : '黑王',
        num : 1,
        sleep : false,
        type : 'buff',
        canAddNum : true,
        text : '黑桃和梅花效果翻倍，红桃和方片效果减半'
    },
    '缠绕' : {
        name : '缠绕',
        num : 4,
        sleep : false,
        canAddNum : true,
        text : '不知道有什么意义，但是这显然是负面状态'
    },
    '种子' : {
        name : '种子',
        num : 10,
        sleep : false,
        canAddNum : true,
        text : '你的身体里似乎多了什么东西'
    },
    '山岭' : {
        name : '山岭',
        num : 2,
        sleep : false,
        canAddNum : true,
        text : '山岭之力压迫在你身上'
    },
    '大地' : {
        name : '大地',
        type : 'buff',
        num : 3,
        sleep : false,
        canAddNum : true,
        text : '大地之力正在凝聚'
    },
    '力量' : {
        name : '力量',
        num : 1,
        sleep : false,
        canAddNum : false,
        keep :true,
        text : '力量凝聚在身体内'
    },
    '狂乱' : {
        name : '狂乱',
        type : 'buff',
        num : 1,
        sleep : false,
        canAddNum : true,
        keep :true,
        text : '内心越发的暴躁'
    },
    '生命之种' : {
        name : '生命之种',
        type : 'buff',
        num : 1,
        keep : true,
        sleep : false,
        canAddNum : true,
        text : '生命的种子种植于心中'
    },
    '生命剥削' : {
        name : '生命剥削',
        num : 1,
        keep : true,
        sleep : false,
        canAddNum : true,
        text : '生命正在流逝'
    },
    '生命积累' : {
        name : '生命积累',
        num : 1,
        keep : true,
        sleep : false,
        canAddNum : true,
        text : '生命之力需要积累一会儿'
    },
    '恢复' : {
        name : '恢复',
        type : 'buff',
        num : 5,
        addHp : 0,
        sleep : false,
        canAddNum : false,
        text : '每回合恢复生命值'
    },
    '天剑' : {
        name : '天剑',
        num : 10,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        text : '天剑已出鞘'
    },
    '雷剑' : {
        name : '雷剑',
        num : 10,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        text : '雷剑已出鞘'
    },
    '昊天镜' : {
        name : '昊天镜',
        num : 1,
        harm : 0,
        sleep : false,
        canAddNum : false,
        text : '昊!天!镜!'
    },
    '念咒' : {
        name : '念咒',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你正在念咒'
    },
    '狂热' : {
        name : '狂热',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你念咒的速度越来越快'
    },
    '强效' : {
        name : '强效',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你的法术被增强了'
    },
    '春之歌' : {
        name : '春之歌',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '命运的春夜之歌'
    },
    '临江' : {
        name : '临江',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '含情遥指碧波东，越王台殿蓼花红。'
    },
    '蔷薇' : {
        name : '蔷薇',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '去住闲人看，晴明远蝶来。'
    },
    '神游' : {
        name : '神游',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '竹叶青汾酒，三杯入画游。'
    },
    '饱和' : {
        name : '饱和',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '神力充斥着你的身体'
    },
    '暗影' : {
        name : '暗影',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你已逐渐融入阴影之中'
    },
    '灵魂守护' : {
        name : '灵魂守护',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '她的灵魂守护着你'
    },
    '受损' : {
        name : '受损',
        num : 1,
        harm : 0,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '每回合减少生命值，且该状态无法被清除负面状态的效果清除'
    },
    '制造旧日' : {
        name : '制造旧日',
        num : 1,
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '它正在制造什么无法描述的东西'
    },
    '扭曲形态' : {
        name : '扭曲形态',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你的身体越发扭曲'
    },
    '愤怒' : {
        name : '愤怒',
        num : 1,
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '来自神的愤怒'
    },
    '圣诞快乐' : {
        name : '圣诞快乐',
        num : 1,
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '圣诞快乐'
    },
    '持有武器' : {
        name : '持有武器',
        num : 1,
        keep : true,
        text : '该怪物拿着武器'
    },
    '穿戴护甲' : {
        name : '穿戴护甲',
        num : 1,
        keep : true,
        text : '该怪物穿着护甲'
    },
    '动物形态' : {
        name : '动物形态',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '你变身为了动物形态'
    },
    '巨熊形态' : {
        name : '巨熊形态',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '你变身为了巨熊形态'
    },
    '猎豹形态' : {
        name : '猎豹形态',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '你变身为了猎豹形态'
    },
    '提速' : {
        name : '提速',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        keep : true,
        text : '你正在提速'
    },
    '神速' : {
        name : '神速',
        num : 1,
        type : 'buff',
        keep : true,
        reduceHitRate : 30,
        sleep : false,
        canAddNum : false,
        text : '命中率降低80%，速度提高5000%',
    },
    '飞龙在天' : {
        name : '飞龙在天',
        num : 1,
        type : 'buff',
        keep : true,
        sleep : false,
        canAddNum : false,
        text : '攻击波动时直接取最大值',
    },
    '心悸' : {
        name : '心悸',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '你的赶到一阵心悸，似乎抓住了什么，又似乎失去了什么'
    },
    '冷静' : {
        name : '冷静',
        num : 10,
        type : 'buff',
        sleep : false,
        text : '你保持着冷静，不会因为理智原因而陷入疯狂'
    },
    '腰痛' : {
        name : '腰痛',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '攻击力降低10%，防御力降低20%，该状态无法被清除'
    },
    '煎熬' : {
        name : '煎熬',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '攻击力降低30%，防御力降低50%，该状态无法被清除'
    },
    '崩溃' : {
        name : '崩溃',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '攻击力降低50%，防御力降低80%，该状态无法被清除'
    },
    '毒素免疫' : {
        name : '毒素免疫',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        keep : true,
        text : '不会被附加其他名字带有“毒”的状态'
    },
    '不灭' : {
        name : '不灭',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        noDie : true,//战斗中至少保留1点血量不会死亡
        text : '每回合减少10点善良值，，善良值不足时该状态自动消失',
        //返回true则不会减少层数
        getKeep(obj){
            return data.evil <= -20;
        },
        //触发层数减少时会调用该方法，无论层数是否实际会减少，都会调用该方法，一般用于每回合都要消耗些啥才能维持的状态
        onReduce(obj){
            //这里因为是固定-10善良，所以不调用addEvil
            data.evil += 10;
        },
    },
    '杀欲' : {
        name : '杀欲',
        num : 1,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        text : '每回合减少10点邪恶值，邪恶值不足时该状态自动消失',
        getKeep(obj){
            return data.evil >= 20;
        },
        onReduce(obj){
            //这里因为是固定-10邪恶，所以不调用addEvil
            data.evil -= 10;
        },
        //失去该状态时
        lost(obj){
            data.atk -= data.level * 3;
        }
    },
    '大地之心' : {
        name : '大地之心',
        num : 5,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        text : '增加50防御',
        //失去该状态时
        lost(obj){
            obj.def -= 50;
        }
    },
    '龟缩' : {
        name : '龟缩',
        num : 1,
        type : 'buff',
        sleep : true,
        canAddNum : false,
        text : '无法行动，防御力增加100，每回合恢复2%生命值',
        getKeep(obj){
            return data.battleMonster.hp < data.battleMonster.maxHp * 0.8;
        },
        //失去该状态时
        lost(obj){
            data.def -= 100;
        }
    },
    '狂暴' : {
        name : '狂暴',
        num : 10,
        type : 'buff',
        sleep : false,
        canAddNum : false,
        text : '增加100攻击，状态结束后获得虚弱状态',
        //获得该状态时
        onGet(obj){
            obj.atk += 100;
        },
        //失去该状态时
        lost(obj){
            obj.atk -= 100;
            addStatus(obj, getStatus('虚弱'))
        }
    },
    '虚弱' : {
        name : '虚弱',
        num : 5,
        type : 'buff',
        sleep : false,
        canAddNum : true,
        text : '减少150攻击和50防御',
        //获得该状态时
        onGet(obj){
            obj.atk -= 150;
            obj.def -= 50;
        },
        //失去该状态时
        lost(obj){
            obj.atk += 150;
            obj.def += 50;
        }
    },
    '复活' : {
        name : '复活',
        num : 1,
        revive : true,//为true是，死亡后复活，并调用getReviveHp方法获取复活恢复多少血量
        type : 'buff',
        false : true,
        keep : true,
        text : '死亡后复活并会满血量，复活时会清除自身携带的所有带有复活效果的状态',
        getReviveHp(obj){
            return obj.maxHp / 2;
        },
    },
}
status = {
    ...status,
    '邪恶赐福' : {
        ...status['恢复'],
        name : '邪恶赐福'
    },
    '闪烁' : {
        ...status['恢复'],
        keep : true,
        num : 1,
        name : '闪烁'
    },
    '心灵守护' : {
        ...status['恢复'],
        name : '心灵守护',
        num : 3
    },
    '目标隐匿' : {
        ...status['丢失目标'],
        name : '目标隐匿',
        keep : true,
    },
    '闷棍' : {
        ...status['冰冻'],
        name : '闷棍',
        keep : true,
    },
    '断筋' : {
        ...status['冰冻'],
        name : '断筋',
        keep : true,
    },
    '茫然' : {
        ...status['冰冻'],
        name : '茫然',
    },
    '割喉' : {
        ...status['封印'],
        name : '割喉',
        keep : true,
    },
    '痛苦' : {
        ...status['放血'],
        name : '痛苦'
    },
    '骨折' : {
        ...status['放血'],
        name : '骨折'
    },
    '流血' : {
        ...status['燃烧'],
        name : '流血'
    },
    '烈阳' : {
        ...status['燃烧'],
        name : '烈阳',
        keep : true,
        canAddNum : false,
        num : 1,
        type : 'buff',
    },
    '寄生虫' : {
        ...status['受损'],
        name : '寄生虫'
    },
    '扭曲' : {
        ...status['燃烧'],
        name : '扭曲'
    },
    '眩晕' : {
        ...status['冰冻'],
        name : '眩晕'
    },
    '力竭' : {
        ...status['冰冻'],
        name : '力竭'
    },
    '僵直' : {
        ...status['冰冻'],
        name : '僵直'
    },
    '反应不及' : {
        ...status['冰冻'],
        name : '反应不及'
    },
    '减速' : {
        ...status['冰冻'],
        name : '减速'
    },
    '麻痹' : {
        ...status['冰冻'],
        name : '麻痹'
    },
    '石化' : {
        ...status['冰冻'],
        name : '石化'
    },
    '奥术飞弹' : {
        ...status['冰冻'],
        name : '奥术飞弹'
    },
    '拉开距离' : {
        ...status['冰冻'],
        name : '拉开距离'
    },
    '枯萎' : {
        ...status['燃烧'],
        name : '枯萎'
    },
    '万年霜雪' : {
        ...status['燃烧'],
        name : '万年霜雪',
        num : 1,
        keep : true,
        canAddNum : false,
    },
    '冰霜护体' : {
        ...status['强酸'],
        name : '冰霜护体'
    },
    '地刺' : {
        ...status['强酸'],
        keep : true,
        name : '地刺'
    },
    双仙 : {
        ...status['强酸'],
        num : 1,
        keep : true,
        name : '双仙'
    },
    '空中目标' : {
        ...status['目盲'],
        name : '空中目标'
    },
    '罡风' : {
        ...status['燃烧'],
        name : '罡风'
    },
    '血战' : {
        ...status['强酸'],
        name : '血战'
    },
    '沙尘' : {
        ...status['目盲'],
        name : '沙尘'
    },
    '灼烧' : {
        ...status['燃烧'],
        name : '灼烧'
    },
    '腐蚀' : {
        ...status['燃烧'],
        name : '腐蚀'
    },
    '厄运' : {
        ...status['目盲'],
        name : '厄运'
    },
    '天灾' : {
        ...status['强酸'],
        name : '天灾'
    },
    '中毒' : {
        ...status['燃烧'],
        name : '中毒'
    },
    '尸毒' : {
        ...status['燃烧'],
        name : '尸毒'
    },
    '纠缠' : {
        ...status['燃烧'],
        keep : true,
        num : 1,
        name : '纠缠'
    },
    '蛇毒' : {
        ...status['燃烧'],
        name : '蛇毒'
    },
    '生命流逝' : {
        ...status['燃烧'],
        name : '生命流逝'
    },
    '超载' : {
        ...status['冰冻'],
        name : '超载'
    },
    '维修中' : {
        ...status['冰冻'],
        name : '维修中'
    },
    '难以观察' : {
        ...status['目盲'],
        name : '难以观察'
    },
    '闪避' : {
        ...status['目盲'],
        name : '闪避'
    },
    '火花' : {
        ...status['强酸'],
        name : '火花'
    },
    '暴走' : {
        ...status['燃烧'],
        name : '暴走'
    },
    '内伤' : {
        ...status['放血'],
        name : '内伤'
    },
    '龙棘' : {
        ...status['强酸'],
        name : '龙棘',
    },
    '束缚' : {
        ...status['冰冻'],
        name : '束缚'
    },
    '铁木树人' : {
        ...status['强酸'],
        name : '铁木树人'
    },
    '紫衫树人' : {
        ...status['强酸'],
        name : '紫衫树人'
    },
    '黑刺树人' : {
        ...status['强酸'],
        name : '黑刺树人'
    },
    '躲藏' : {
        ...status['冰冻'],
        name : '躲藏'
    },
    '护卫' : {
        ...status['强酸'],
        name : '护卫'
    },
    '刺骨' : {
        ...status['缠绕'],
        name : '刺骨',
        text : '刺骨的寒冷'
    },
    '深海' : {
        ...status['燃烧'],
        name : '深海'
    },
    '陷阱' : {
        ...status['冰冻'],
        name : '陷阱'
    },
    '迷之蝶' : {
        ...status['目盲'],
        name : '迷之蝶'
    },
    '幽灵虫' : {
        ...status['燃烧'],
        name : '幽灵虫'
    },
    '疯狂' : {
        ...status['冰冻'],
        name : '疯狂'
    },
    '烈风' : {
        ...status['燃烧'],
        name : '烈风',
        keep : true,
        num : 1,
    },
    '风雨交加' : {
        ...status['燃烧'],
        name : '风雨交加',
        keep : true,
        num : 1,
    },
    '畏缩' : {
        ...status['冰冻'],
        name : '畏缩',
        keep : true,
    },
};

//获取状态，可以自定义部分属性
function getStatus(name,props = {}){
    const sta = {...status[name],...props};
    if(sta.harm < 0){
        sta.harm = 0;
    }
    return sta;
}

//添加状态
function addStatus(obj, sta){
    //毒素免疫判断
    if(hasStatus(obj, '毒素免疫') && sta.name.includes('毒')){
        if(obj.race){
            addBattleLog(`你免疫了${sta.name}状态`)
        }else{
            addBattleLog(`${obj.showName || obj.name}免疫了${sta.name}状态`)
        }
        return;
    }

    const mySta = obj.status.filter(e => e.name === sta.name);
    //已有则判断是否可增加次数，可以则增加生效次数，否则直接加入状态列表
    if(mySta.length > 0){
        if(sta.canAddNum){
            mySta[0].num += sta.num;
            //如果新伤害高于旧伤害，则用新伤害代替
            if(sta.harm && mySta[0].harm < sta.harm){
                mySta[0].harm = sta.harm;
            }
        }else if(!sta.num > mySta[0].num){
            mySta[0].num = sta.num;
        }
    }else{
        //触发获得时监听
        if(sta.onGet){
            sta.onGet(obj);
        }
        obj.status.push(sta);
    }
}

//删除状态
function removeStatus(obj, name){
    //找到该状态
    const mySta = obj.status.filter(e => e.name === name);
    //触发失去状态的监听
    if(mySta.length > 0 && status[mySta[0].name] && typeof status[mySta[0].name].lost === 'function'){
        status[mySta[0].name].lost(obj);
    }

    obj.status = obj.status.filter(e => e.name !== name);
}

//删除所有状态
function removeAllStatus(obj){
    obj.status.forEach(e => {
        //触发失去状态的监听
        if(status[e.name] && typeof status[e.name].lost === 'function'){
            status[e.name].lost(obj);
        }
    })
    obj.status = []
}

//删除所有负面状态
function removeAllDebuff(obj){
    obj.status = obj.status.filter(e => e.type === 'buff')
}

//删除所有正面状态
function removeAllBuff(obj){
    obj.status = obj.status.filter(e => e.type !== 'buff')
}

//判断是否拥有封印状态
function isSeal(obj){
    return obj.status.filter(e => e.seal).length > 0
}

//判断是否拥有不死属性
function isNoDie(obj){
    return obj.status.filter(e => e.noDie).length > 0
}

//判断是否可以复活
function canRevive(obj){
    return obj.status.filter(e => e.revive).length > 0
}

//判断是否拥有指定状态
function hasStatus(obj, name){
    return obj.status.filter(e => e.name === name).length > 0
}

//获取指定状态的持续回合数
function getStatuNum(obj, name){
    const sta = obj.status.filter(e => e.name === name);
    return sta.length > 0 ? sta[0].num : 0;
}

//状态次数减一
function reduceStatusNum(obj, name, final){
    if(!obj){
        return;
    }

    //找到该状态
    const mySta = obj.status.filter(e => e.name === name);

    if(mySta.length > 0){
        //获取keep
        let keep = mySta[0].keep;
        //不为true的话，再试图通过方法来获取keep
        if(!keep && status[mySta[0].name] && typeof status[mySta[0].name].getKeep === 'function'){
            keep = status[mySta[0].name].getKeep(obj);
        }

        //触发状态数量减少的监听
        if(status[mySta[0].name] && typeof status[mySta[0].name].onReduce === 'function'){
            status[mySta[0].name].onReduce(obj);
        }

        if(!keep || final){
            //次数不大于1则直接删除该状态，否则次数减一
            if(mySta[0].num <= 1){
                removeStatus(obj, name);
            }else{
                mySta[0].num--;
            }
        }
    }
}
