//变异概率(百分之)
const variationRate = 10;
//可变异等级差
const variationLevel = 10;

//变异词条,level代表词条等级，怪物只能获得不高于自己等级的词条。num代表基础掉落的变异核心数量，也代表了附魔等级，num=2的词缀至少需要20个变异核心，以此类推
const variations = {
    '元气的' : {atk : 0, def : 0, hp : 30, level : 1, num : 1},
    '勇敢的' : {atk : 3, def : 0, hp : 0, level : 1, num : 1},
    '顽强的' : {atk : 0, def : 2, hp : 0, level : 1, num : 1},

    '倔强的' : {atk : 3, def : 0, hp : 30, level : 5, num : 2},
    '不屈的' : {atk : 0, def : 2, hp : 30, level : 5, num : 2},
    '愤怒的' : {atk : 3, def : 2, hp : 0, level : 5, num : 2},

    '神气' : {atk : 3, def : 2, hp : 30, level : 10, num : 3},
    '强攻' : {atk : 5, def : 0, hp : 0, level : 10, num : 3},
    '防御' : {atk : 0, def : 3, hp : 0, level : 10, num : 3},
    '气血' : {atk : 0, def : 0, hp : 50, level : 10, num : 3},

    '战士' : {atk : 5, def : 3, hp : 0, level : 15, num : 4},
    '骑士' : {atk : 5, def : 0, hp : 50, level : 15, num : 4},
    '守卫' : {atk : 0, def :3, hp : 50, level : 15, num : 4},

    '强大的' : {atk : 5, def : 3, hp : 50, level : 20, num : 5},
    '有力的' : {atk : 8, def : 0, hp : 0, level : 20, num : 5},
    '耐打的' : {atk : 0, def : 5, hp : 0, level : 20, num : 5},
    '血厚的' : {atk : 0, def : 0, hp : 80, level : 20, num : 5},

    '凶狠的' : {atk : 8, def : 0, hp : 80, level : 25, num : 6},
    '壮硕的' : {atk : 8, def : 5, hp : 0, level : 25, num : 6},
    '防守的' : {atk : 0, def : 5, hp : 80, level : 25, num : 6},

    '战斗' : {atk : 8, def : 5, hp : 80, level : 30, num : 7},
    '巨力' : {atk : 10, def : 0, hp : 0, level : 30, num : 7},
    '格挡' : {atk : 0, def : 7, hp : 0, level : 30, num : 7},
    '山海' : {atk : 0, def : 0, hp : 100, level : 30, num : 7},

    '战斗的' : {atk : 10, def : 7, hp : 0, level : 35, num : 8},
    '持盾的' : {atk : 0, def : 7, hp : 100, level : 35, num : 8},
    '丰满的' : {atk : 10, def : 0, hp : 100, level : 35, num : 8},

    '角斗士' : {atk : 20, def : 10, hp : 200, level : 40, num : 9},
    '利爪' : {atk : 30, def : 0, hp : 0, level : 40, num : 9},
    '厚皮' : {atk : 0, def : 25, hp : 0, level : 40, num : 9},
    '结实的' : {atk : 0, def : 0, hp : 300, level : 40, num : 9},

    '半兽人' : {atk : 30, def : 25, hp : 0, level : 45, num : 10},
    '始祖龟' : {atk : 0, def : 25, hp : 300, level : 45, num : 10},
    '大矮人' : {atk : 30, def : 0, hp : 300, level : 45, num : 10},

    '巨人' : {atk : 30, def : 25, hp : 300, level : 50, num : 11},
    '巨兽' : {atk : 40, def : 0, hp : 0, level : 50, num : 11},
    '石象' : {atk : 0, def : 30, hp : 0, level : 50, num : 11},
    '铁塔' : {atk : 0, def : 0, hp : 400, level : 50, num : 11},

    '擎天' : {atk : 40, def : 30, hp : 0, level : 55, num : 12},
    '追日' : {atk : 0, def : 30, hp : 400, level : 55, num : 12},
    '开山' : {atk : 40, def : 0, hp : 400, level : 55, num : 12},

    '冥王' : {atk : 40, def : 30, hp : 400, level : 60, num : 13},
    '魔笛' : {atk : 60, def : 0, hp : 0, level : 60, num : 13},
    '神剑' : {atk : 0, def : 50, hp : 0, level : 60, num : 13},
    '神铠' : {atk : 0, def : 0, hp : 600, level : 60, num : 13},

    '终结者' : {atk : 60, def : 50, hp : 0, level : 65, num : 14},
    '开天者' : {atk : 0, def : 50, hp : 600, level : 65, num : 14},
    '断海者' : {atk : 60, def : 0, hp : 600, level : 65, num : 14},

    '不灭之握' : {atk : 60, def : 50, hp : 600, level : 70, num : 15},
    '山岚之风' : {atk : 80, def : 0, hp : 0, level : 70, num : 15},
    '不熄之火' : {atk : 0, def : 65, hp : 0, level : 70, num : 15},
    '不屈意志' : {atk : 0, def : 0, hp : 800, level : 70, num : 15},

    '断剑' : {atk : 80, def : 65, hp : 0, level : 75, num : 16},
    '破盾' : {atk : 0, def : 65, hp : 800, level : 75, num : 16},
    '碎心' : {atk : 80, def : 0, hp : 800, level : 75, num : 16},

    '仰望者' : {atk : 80, def : 65, hp : 800, level : 80, num : 17},
    '信仰者' : {atk : 100, def : 0, hp : 0, level : 80, num : 17},
    '追逐者' : {atk : 0, def : 80, hp : 0, level : 80, num : 17},
    '挑战者' : {atk : 0, def : 0, hp : 1000, level : 80, num : 17},

    '心剑' : {atk : 100, def : 80, hp : 0, level : 85, num : 18},
    '念盾' : {atk : 0, def : 80, hp : 1000, level : 85, num : 18},
    '魂霸' : {atk : 100, def : 0, hp : 1000, level : 85, num : 18},

    '身心一体' : {atk : 100, def : 80, hp : 1000, level : 90, num : 19},
    '意由心生' : {atk : 130, def : 0, hp : 0, level : 90, num : 19},
    '灵体合一' : {atk : 0, def : 110, hp : 0, level : 90, num : 19},
    '生生不息' : {atk : 0, def : 0, hp : 1300, level : 90, num : 19},

    '山河碎' : {atk : 130, def : 110, hp : 0, level : 95, num : 20},
    '万物生' : {atk : 0, def : 110, hp : 1300, level : 95, num : 20},
    '天地变' : {atk : 130, def : 0, hp : 1300, level : 95, num : 20},

    '风起云涌' : {atk : 130, def : 110, hp : 1300, level : 100, num : 21},
};