//弹窗关闭功能
$('.win-close-title,.win-close').click(function(e){
    e.stopPropagation();
    $(this).parent('.win').hide();
});

//发送消息，并记录日志
function msg(text, saveLog = true){
    if(saveLog){
        //日志只记录最近100条
        data.logs = [`${data.date.format('yyyy-MM-dd hh:mm')}：${text}`,...(data.logs.splice(0,99))];
    }
    //$('.msg-list').append(`<div class="msg" data-time="${new Date().getTime()}">${text}</div>`);
    $('.body-log').prepend(`<div class="body-log-msg">${text}</div>`);

    while ($('.body-log-msg').length > 100){
        $('.body-log-msg').last().remove();
    }
}

//发送悬浮消息，并记录日志
function winMsg(text, saveLog = true, showLog = true){
    if(saveLog){
        //日志只记录最近100条
        data.logs = [`${data.date.format('yyyy-MM-dd hh:mm')}：${text}`,...(data.logs.splice(0,99))];
    }
    if(showLog){
        $('.body-log').prepend(`<div class="body-log-msg">${text}</div>`);
    }
    $('.msg-list').append(`<div class="msg" data-time="${new Date().getTime()}">${text}</div>`);

    while ($('.body-log-msg').length > 100){
        $('.body-log-msg').last().remove();
    }
}

//定时清空悬浮消息
setInterval(function(){
    if($('.msg').length > 0){
        for(let i = 0, len = $('.msg').length ; i < len ; i++){
            const el = $($('.msg')[i]);
            if(new Date().getTime() - parseInt(el.attr('data-time')) >= 1000){
                el.remove();
            }
        }
    }
},200)

//切换tab标签
$('body').on('click', '.tab-head',function(){
    if($(this).attr('data-type') === 'oneOrBlank' && $(this).hasClass('active')){
        $(this).removeClass('active');

    }else if($(this).attr('data-type') === 'multiple'){
        if($(this).hasClass('active')){
            $(this).removeClass('active');
        }else{
            $(this).addClass('active');
        }

    }else{
        $(this).parent().find('.tab-head').removeClass('active');
        $(this).addClass('active');
    }
    const call = $(this).attr('data-call');
    if(call && window[call]){
        window[call]();
    }
})
