const runes = [
{
    name : 'la',//符文名
    text : '1#符文-拉',//符文说明
    hp : 20,
    level : 1,//最低掉落等级
    no : 1,//符文序号
    //怪物掉落配置
    monsterItem : {
        '普通' : [-8, 1],
        '精英' : [-3, 1],
        '传说' : [0, 1],
        '神话' : [1, 1],
    }
},{
    name : 'ta',//符文名
    text : '2#符文-塔',//符文说明
    endurance : 20,
    level : 1,//最低掉落等级
    no : 2,//符文序号
    monsterItem : {
        '普通' : [-8, 1],
        '精英' : [-3, 1],
        '传说' : [0, 1],
        '神话' : [1, 1],
    }
},{
    name : 'bel',//符文名
    text : '3#符文-贝尔',//符文说明
    atk : 2,
    level : 1,//最低掉落等级
    no : 3,//符文序号
    monsterItem : {
        '普通' : [-8, 1],
        '精英' : [-3, 1],
        '传说' : [0, 1],
        '神话' : [1, 1],
    }
},{
    name : 'lu',//符文名
    text : '4#符文-鲁',//符文说明
    def : 1,
    level : 1,//最低掉落等级
    no : 4,//符文序号
    monsterItem : {
        '普通' : [-10, 1],
        '精英' : [-5, 1],
        '传说' : [-3, 1],
        '神话' : [-1, 1],
    }
},{
    name : 'fail',//符文名
    text : '5#符文-费尔',//符文说明
    suck : 2,
    level : 1,//最低掉落等级
    no : 5,//符文序号
    monsterItem : {
        '普通' : [-10, 1],
        '精英' : [-5, 1],
        '传说' : [-3, 1],
        '神话' : [-1, 1],
    }
},{
    name : 'xi',//符文名
    text : '6#符文-西',//符文说明
    hp : 50,
    level : 11,//最低掉落等级
    no : 6,//符文序号
    monsterItem : {
        '普通' : [-10, 1],
        '精英' : [-5, 1],
        '传说' : [-3, 1],
        '神话' : [-1, 1],
    }
},{
    name : 'ben',//符文名
    text : '7#符文-本',//符文说明
    endurance : 50,
    level : 11,//最低掉落等级
    no : 7,//符文序号
    monsterItem : {
        '普通' : [-15, 1],
        '精英' : [-10, 1],
        '传说' : [-5, 1],
        '神话' : [-2, 1],
    }
},{
    name : 'tin',//符文名
    text : '8#符文-汀',//符文说明
    atk : 5,
    level : 11,//最低掉落等级
    no : 8,//符文序号
    monsterItem : {
        '普通' : [-15, 1],
        '精英' : [-10, 1],
        '传说' : [-5, 1],
        '神话' : [-2, 1],
    },
},{
    name : 'hal',//符文名
    text : '9#符文-哈尔',//符文说明
    def : 3,
    level : 11,//最低掉落等级
    no : 9,//符文序号
    monsterItem : {
        '普通' : [-15, 1],
        '精英' : [-10, 1],
        '传说' : [-5, 1],
        '神话' : [-2, 1],
    }
},{
    name : 'fa',//符文名
    text : '10#符文-发',//符文说明
    suck : 3,
    level : 11,//最低掉落等级
    no : 10,//符文序号
    monsterItem : {
        '普通' : [-40, 1],
        '精英' : [-30, 1],
        '传说' : [-20, 1],
        '神话' : [-3, 1],
    }
},{
    name : 'at',//符文名
    text : '11#符文-艾特',//符文说明
    hp : 100,
    level : 21,//最低掉落等级
    no : 11,//符文序号
    monsterItem : {
        '普通' : [-50, 1],
        '精英' : [-40, 1],
        '传说' : [-30, 1],
        '神话' : [-3, 1],
    }
},{
    name : 'pol',//符文名
    text : '12#符文-波尔',//符文说明
    endurance : 100,
    level : 21,//最低掉落等级
    no : 12,//符文序号
    monsterItem : {
        '普通' : [-60, 1],
        '精英' : [-50, 1],
        '传说' : [-40, 1],
        '神话' : [-4, 1],
    }
},{
    name : 'lo',//符文名
    text : '13#符文-罗',//符文说明
    atk : 8,
    level : 21,//最低掉落等级
    no : 13,//符文序号
    monsterItem : {
        '普通' : [-80, 1],
        '精英' : [-70, 1],
        '传说' : [-60, 1],
        '神话' : [-4, 1],
    }
},{
    name : 'na',//符文名
    text : '14#符文-纳',//符文说明
    def : 5,
    level : 21,//最低掉落等级
    no : 14,//符文序号
    monsterItem : {
        '普通' : [-90, 1],
        '精英' : [-80, 1],
        '传说' : [-70, 1],
        '神话' : [-5, 1],
    }
},{
    name : 'pit',//符文名
    text : '15#符文-皮特',//符文说明
    suck : 5,
    level : 21,//最低掉落等级
    no : 15,//符文序号
    monsterItem : {
        '普通' : [-100, 1],
        '精英' : [-90, 1],
        '传说' : [-80, 1],
        '神话' : [-6, 1],
    }
},{
    name : 'cal',//符文名
    text : '16#符文-卡尔',//符文说明
    hp : 200,
    level : 31,//最低掉落等级
    no : 16,//符文序号
    monsterItem : {
        '普通' : [-120, 1],
        '精英' : [-100, 1],
        '传说' : [-80, 1],
        '神话' : [-7, 1],
    }
},{
    name : 'lin',//符文名
    text : '17#符文-琳',//符文说明
    endurance : 200,
    level : 31,//最低掉落等级
    no : 17,//符文序号
    monsterItem : {
        '普通' : [-150, 1],
        '精英' : [-130, 1],
        '传说' : [-110, 1],
        '神话' : [-8, 1],
    }
},{
    name : 'nir',//符文名
    text : '18#符文-尼尔',//符文说明
    atk : 12,
    level : 31,//最低掉落等级
    no : 18,//符文序号
    monsterItem : {
        '普通' : [-200, 1],
        '精英' : [-180, 1],
        '传说' : [-160, 1],
        '神话' : [-9, 1],
    }
},{
    name : 'luf',//符文名
    text : '19#符文-鲁夫',//符文说明
    def : 8,
    level : 31,//最低掉落等级
    no : 19,//符文序号
    monsterItem : {
        '普通' : [-300, 1],
        '精英' : [-250, 1],
        '传说' : [-200, 1],
        '神话' : [-10, 1],
    }
},{
    name : 'xia',//符文名
    text : '20#符文-夏',//符文说明
    suck : 7,
    level : 31,//最低掉落等级
    no : 20,//符文序号
    monsterItem : {
        '普通' : [-500, 1],
        '精英' : [-400, 1],
        '传说' : [-300, 1],
        '神话' : [-15, 1],
    }
},{
    name : 'bill',//符文名
    text : '21#符文-比尔',//符文说明
    hp : 300,
    level : 41,//最低掉落等级
    no : 21,//符文序号
    monsterItem : {
        '普通' : [-800, 1],
        '精英' : [-600, 1],
        '传说' : [-400, 1],
        '神话' : [-15, 1],
    }
},{
    name : 'jar',//符文名
    text : '22#符文-杰',//符文说明
    endurance : 300,
    level : 41,//最低掉落等级
    no : 22,//符文序号
    monsterItem : {
        '普通' : [-1000, 1],
        '精英' : [-800, 1],
        '传说' : [-600, 1],
        '神话' : [-15, 1],
    }
},{
    name : 'our',//符文名
    text : '23#符文-奥尔',//符文说明
    atk : 18,
    level : 41,//最低掉落等级
    no : 23,//符文序号
    monsterItem : {
        '普通' : [-1500, 1],
        '精英' : [-1200, 1],
        '传说' : [-900, 1],
        '神话' : [-20, 1],
    }
},{
    name : 'vin',//符文名
    text : '24#符文-文',//符文说明
    def : 12,
    level : 41,//最低掉落等级
    no : 24,//符文序号
    monsterItem : {
        '普通' : [-2000, 1],
        '精英' : [-1500, 1],
        '传说' : [-1000, 1],
        '神话' : [-20, 1],
    }
},{
    name : 'tel',//符文名
    text : '25#符文-特尔',//符文说明
    suck : 10,
    level : 41,//最低掉落等级
    no : 25,//符文序号
    monsterItem : {
        '普通' : [-2500, 1],
        '精英' : [-2000, 1],
        '传说' : [-1500, 1],
        '神话' : [-20, 1],
    }
},{
    name : 'co',//符文名
    text : '26#符文-克',//符文说明
    hp : 500,
    level : 51,//最低掉落等级
    no : 26,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-3000, 1],
        '精英' : [-3500, 1],
        '传说' : [-2000, 1],
        '神话' : [-25, 1],
    }
},{
    name : 'fen',//符文名
    text : '27#符文-芬',//符文说明
    endurance : 500,
    level : 61,//最低掉落等级
    no : 27,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-10000, 1],
        '精英' : [-8000, 1],
        '传说' : [-6000, 1],
        '神话' : [-25, 1],
    }
},{
    name : 'ur',//符文名
    text : '28#符文-乌尔',//符文说明
    atk : 25,
    level : 71,//最低掉落等级
    no : 28,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-20000, 1],
        '精英' : [-15000, 1],
        '传说' : [-10000, 1],
        '神话' : [-30, 1],
    }
},{
    name : 'beta',//符文名
    text : '29#符文-贝塔',//符文说明
    def : 16,
    level : 81,//最低掉落等级
    no : 29,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-50000, 1],
        '精英' : [-40000, 1],
        '传说' : [-30000, 1],
        '神话' : [-40, 1],
    }
},{
    name : 'tir',//符文名
    text : '30#符文-泰尔',//符文说明
    suck : 12,
    level : 81,//最低掉落等级
    no : 30,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-100000, 1],
        '精英' : [-80000, 1],
        '传说' : [-60000, 1],
        '神话' : [-50, 1],
    }
},{
    name : 'mik',//符文名
    text : '31#符文-米克',//符文说明
    noWear : true,
    level : 81,//最低掉落等级
    no : 31,//符文序号
    max : true,//最大号的一批符文，等级大于这个符文等级的怪都会掉落
    monsterItem : {
        '普通' : [-500000, 1],
        '精英' : [-400000, 1],
        '传说' : [-300000, 1],
        '神话' : [-60, 1],
    }
}];

//便捷创建符文之语
function createRuneWord(name,nos,attrs){
    let str = '';
    let runeArr = [];
    nos.forEach(e => {
        str += runes[e - 1].name;
        runeArr.push(runes[e - 1].name);
    })

    return {
        [str] : {
            name,
            runes : runeArr,
            ...attrs
        }
    }
}

//符文之语
const runeWord = {
    ...createRuneWord('力量',[3,2],{
        atk : 3,
        endurance : 40
    }),
    ...createRuneWord('生命',[4,1],{
        def : 2,
        hp : 40
    }),
    ...createRuneWord('防守者',[4,1,4,1],{
        def : 8,
        hp : 100
    }),
    ...createRuneWord('顽固不化',[2,1,1,2,2,4],{
        def : 5,
        hp : 100,
        endurance : 200
    }),
    ...createRuneWord('清风',[6,9],{
        def : 5,
        hp : 60
    }),
    ...createRuneWord('格斗家',[8,9],{
        atk : 8,
        def : 5
    }),
    ...createRuneWord('刺客',[8,3,3],{
        atk : 18
    }),
    ...createRuneWord('气血',[6,1,1,6],{
        hp : 250
    }),
    ...createRuneWord('旋律',[1,10,1,6,10],{
        suck : 8,
        hp : 200
    }),
    ...createRuneWord('血腥盛宴',[5,10,6,10,10],{
        suck : 20,
        hp : 100
    }),
    ...createRuneWord('粘土人',[9,6,4,9,8,9],{
        atk : 10,
        hp : 120,
        def : 20
    }),
    ...createRuneWord('臂力',[11,13],{
        atk : 10,
        hp : 100
    }),
    ...createRuneWord('血欲',[5,11,10],{
        suck : 8,
        hp : 100
    }),
    ...createRuneWord('狂战士',[8,13,7],{
        suck : 5,
        atk : 15,
        endurance : 80
    }),
    ...createRuneWord('钻石',[7,12,2],{
        endurance : 300
    }),
    ...createRuneWord('战士',[14,13,6],{
        atk : 11,
        def : 8,
        hp : 80,
        endurance : 50,
    }),
    ...createRuneWord('刺杀者',[13,2,13],{
        atk : 21,
        endurance : 30,
    }),
    ...createRuneWord('坦克',[11,14,9],{
        def : 12,
        hp : 100,
        endurance : 50,
    }),
    ...createRuneWord('精锐',[8,9,13,14],{
        atk : 20,
        def : 15,
        hp : 100,
        endurance : 200
    }),
    ...createRuneWord('饮血',[15,10,15,10],{
        suck : 30,
        hp : 200
    }),
    ...createRuneWord('均衡',[15,6,13,14,1,11],{
        atk : 25,
        def : 15,
        hp : 250,
        suck : 15,
        endurance : 200
    }),
    ...createRuneWord('巨人',[16,19],{
        def : 10,
        hp : 300
    }),
    ...createRuneWord('战斗',[18,17],{
        atk : 14,
        endurance : 300
    }),
    ...createRuneWord('吸血鬼',[18,20,20],{
        suck : 20,
        atk : 18
    }),
    ...createRuneWord('海龟',[19,16,19,17],{
        def : 25,
        hp : 400,
        endurance : 400
    }),
    ...createRuneWord('圣骑士',[19,13,18,16],{
        atk : 30,
        def : 15,
        hp : 400,
        endurance : 100
    }),
    ...createRuneWord('盾山',[19,17,9,19,1],{
        def : 40,
        hp : 200,
        endurance : 400
    }),
    ...createRuneWord('血神',[18,20,20,15,20],{
        suck : 40,
        atk : 20,
        hp : 300
    }),
    ...createRuneWord('决斗',[18,8,20,8,16,8],{
        atk : 60,
        hp : 200,
        suck : 15,
    }),
    ...createRuneWord('刺骨',[18,13,12,14,14,15],{
        atk : 40,
        def : 20,
        endurance : 400,
        suck : 10
    }),
    ...createRuneWord('全能',[20,18,16,6,19,17],{
        atk : 50,
        def : 20,
        hp : 500,
        suck : 30,
        endurance : 1000
    }),
    ...createRuneWord('冲锋',[23,18,13,23,22],{
        atk : 120,
        endurance : 500
    }),
    ...createRuneWord('水元素',[21,16,1,24,11,21],{
        def : 20,
        hp : 2000,
        endurance : 500
    }),
    ...createRuneWord('血祭',[26,25,1,18,30,21],{
        atk : 20,
        hp : 1200,
        suck : 20,
    }),
    ...createRuneWord('山河盾御',[29,11,22,4,19,17],{
        def : 100,
        hp : 500,
        endurance : 2000,
    }),
    ...createRuneWord('末日征兆',[28,29,31,30,28,29],{
        atk : 150,
        def : 80,
        hp : 500,
        suck : 80,
        noWear : true
    }),
};

//宝石的前缀
const gemNames = [
{
    name : '碎裂的',
    level : 1,
    monsterItem : {
        '普通' : [-50, 1],
        '精英' : [-10, 1],
        '传说' : [-5, 1],
        '神话' : [-1, 1],
    }
},{
    name : '裂开的',
    level : 11,
    monsterItem : {
        '普通' : [-200, 1],
        '精英' : [-20, 1],
        '传说' : [-10, 1],
        '神话' : [-1, 1],
    }
},{
    name : '完整的',
    level : 21,
    monsterItem : {
        '普通' : [-500, 1],
        '精英' : [-30, 1],
        '传说' : [-5, 1],
        '神话' : [-1, 1],
    }
},{
    name : '无瑕的',
    level : 31,
    monsterItem : {
        '普通' : [-2000, 1],
        '精英' : [-40, 1],
        '传说' : [-15, 1],
        '神话' : [-1, 1],
    }
},{
    name : '完美的',
    level : 41,
    monsterItem : {
        '普通' : [-10000, 1],
        '精英' : [-50, 1],
        '传说' : [-20, 1],
        '神话' : [-1, 1],
    }
},{
    name : '璀璨的',
    level : 51,
    max : true,//最大号的一批宝石，等级大于这个宝石等级的怪都会掉落
    monsterItem : {
        '普通' : [-50000, 1],
        '精英' : [-60, 1],
        '传说' : [-25, 1],
        '神话' : [-1, 1],
    }
}
];

//宝石的类型
const gemTypes = [
{
    type : '红宝石',
    attr : 'hp',
},{
    type : '黄宝石',
    attr : 'endurance',
},{
    type : '紫宝石',
    attr : 'atk',
},{
    type : '绿宝石',
    attr : 'def',
},{
    type : '橙色宝石',
    attr : 'suck',
}
];

//标签列表
let tags = ['魔物', '史莱姆', '人型生物', '哥布林', '野兽', '巨型生物', '污染', '傀儡', '不死族', '魔兽', '元素生物', '幽灵', '植物', '兽人', '龙', '神', '克系生物'];
/*Object.keys(monsterCfgs).forEach(e => tags=[...tags,...monsterCfgs[e].tags]);
[...new Set(tags)]*/

//根据等级获得所有这一等级的宝石
function getGemByLevel(level){
    const arr = gemNames.filter(e => e.level === level);
    if(arr.length === 0){
        return []
    }
    const name = arr[0].name;
    return gemTypes.map(e => ({name : `${name}${e.type}`,minNum : 1, maxNum : 1}))
}

//创建宝石
function createGems(){
    //不同级别对应的属性数值
    const levelAttrNum = {
        1 : {
            hp : 20,
            endurance : 20,
            atk : 2,
            def : 1,
            suck : 2
        },
        11 : {
            hp : 50,
            endurance : 50,
            atk : 5,
            def : 3,
            suck : 3
        },
        21 : {
            hp : 100,
            endurance : 100,
            atk : 8,
            def : 5,
            suck : 5
        },
        31 : {
            hp : 200,
            endurance : 200,
            atk : 12,
            def : 8,
            suck : 7
        },
        41 : {
            hp : 300,
            endurance : 300,
            atk : 18,
            def : 12,
            suck : 10
        },
        51 : {
            hp : 500,
            endurance : 500,
            atk : 25,
            def : 16,
            suck : 12
        }
    };

    const gems = [];

    gemNames.forEach(name => {
        gemTypes.forEach(type => {
            gems.push({
                name : `${name.name}${type.type}`,
                level : name.level,
                monsterItem : name.monsterItem,
                [type.attr] : levelAttrNum[name.level][type.attr],
                text : '可以在镶嵌台镶嵌到有孔的装备里。5个同级别宝石可以合成高1级的宝石，使用后会将该宝石全部合成为更高级的宝石，不想全部合成的话请把要保留的放入仓库',
                max : name.max,
                canUse : true,
                func : function(){
                    const num = getNumByBag(this.name);
                    if(num >= 5){
                        const names = gemNames.filter(e => e.level === this.level + 10);
                        if(names.length > 0){
                            const canGet = parseInt(num / 5);
                            reduceItem(this.name, canGet * 5 - 1);
                            const newName = names[0].name + this.name.substr(3);
                            addItem(newName, canGet);
                            winMsg(`合成${newName}*${canGet}`)
                            return true;
                        }else{
                            winMsg('没有更上级的宝石了', false, false)
                            return false;
                        }
                    }else{
                        winMsg('数量不足，无法合成', false, false)
                        return false;
                    }


                    if(num >= 3){
                        const rune = runes.filter(e => e.no === this.no + 1);
                        if(rune.length > 0){
                            const canGet = parseInt(num / 3);

                            reduceItem(this.name, canGet * 3 - 1);
                            addItem(rune[0].name, canGet);
                            winMsg(`合成${rune[0].name}*${canGet}`)
                            return true;
                        }else{
                            winMsg('没有更上级的宝石了', false, false)
                            return false;
                        }
                    }else{
                        winMsg('数量不足，无法合成', false, false)
                        return false;
                    }
                }
            })
        })
    })

    return gems;
}

//创建针对不同标签的镶嵌物
function createTagInlays(){
    const items = [];
    const qualitys = Object.keys(qualityAttr);
    qualitys.forEach(e => {
        e = parseInt(e)
        const rate =parseFloat2Fiexd((e + 1) * 0.05);
        tags.forEach(tag => {
            items.push({
                name : `${qualityAttr[e].name}的${tag}宝石`,
                level : e * 10 + 1,
                canGetTag : tag,
                quality : e,
                atkTags : [{tag, rate}],
                text : `所有拥有${tag}标签的怪物都有几率掉落，只有镶嵌在武器上才会生效。对拥有${tag}标签的怪物提高${rate}倍伤害。一件装备上不能镶嵌多个针对同一个怪物标签的宝石`,
            })
        })
    })

    return items;
}

//除了符文之外的镶嵌物
const inlays = [
    ...createTagInlays(),
    ...createGems(),
    {
        name : '永恒珠宝',
        level : 1,
        max : true,
        monsterItem : {
            '普通' : [-10000, 1],
            '精英' : [-9000, 1],
            '传说' : [-5000, 1],
            '神话' : [-1000, 1],
        },
        noWear : true,
        text : '所有怪物都有万分之一概率掉落，也可以在神殿购买。可以在镶嵌台镶嵌到有孔的装备里'
    },
    {
        name : '龙魂宝石',
        level : 80,
        monsterItem : null,//为null说明不是所有怪物都掉落
        hp : 1000,
        atk : 30,
        def : 20,
        text : '可以在镶嵌台镶嵌到有孔的装备里'
    },
]

//不同品质打孔需要的神性结晶
const addHoleNeed = {
    0 : 1,
    1 : 2,
    2 : 3,
    3 : 5,
    4 : 10,
};

//怪物掉获取落符文和镶嵌物
function getMonsterRunes(type, level, tags){
    const items = [];
    if(data.dlcOriginal){
        return items;
    }
    runes.filter(e => e.level <= level /*&& (e.level > level - 10 || e.max)*/).forEach(e => {
        items.push({name : e.name, minNum : e.monsterItem[type][0], maxNum : e.monsterItem[type][1]});
    })
    inlays.filter(e => e.level <= level /*&& (e.level > level - 10 || e.max)*/).forEach(e => {
        if(e.monsterItem){
            items.push({name : e.name, minNum : e.monsterItem[type][0], maxNum : e.monsterItem[type][1]});
        }
        if(e.canGetTag && tags && tags.includes(e.canGetTag)){
            const arr = ['普通','精英','传说','神话'];
            items.push({name : e.name, minNum : parseInt(-30 * (e.quality + 1) / (arr.indexOf(type) + 1)), maxNum : 1});
        }
    })
    return items;
}

//不同符文等级对应的粉尘数量
const levelVoidDush = {
    1 : 10,
    11 : 20,
    21 : 50,
    31 : 100,
    41 : 200,
    51 : 500,
    61 : 1000,
    71 : 1500,
    81 : 2000,
    80 : 2000,
};

//获取物品配置中用的符文信息
function getElementsRunes(){
    const eleRunes = {};

    runes.forEach(e => {
        eleRunes[e.name] = new Element({isInlay :true, name :e.name, weight : 0, showName : `${e.name}(${e.no}#符文)`,level : e.level, no :e.no, voidDust : levelVoidDush[e.level], gold : levelVoidDush[e.level]*5, hp : e.hp, endurance : e.endurance, atk : e.atk, def : e.def, suck :e.suck, noWear : e.noWear, text : `${e.text}<br>最低掉落等级：${e.level}。可以在镶嵌台镶嵌到有孔的装备里，按照一定顺序镶嵌可以组成符文之语。点击使用可将3个符文合成为1个更高级符文(3个1#会合成1个2#，而不是3个加攻击的合成变成1个加更多攻击的)，使用后会将该符文全部合成为更高级的符文，不想全部合成的话请把要保留的放入仓库`, canUse : true, func : function(){
            const num = getNumByBag(this.name);
            if(num >= 3){
                const rune = runes.filter(e => e.no === this.no + 1);
                if(rune.length > 0){
                    const canGet = parseInt(num / 3);

                    reduceItem(this.name, canGet * 3 - 1);
                    addItem(rune[0].name, canGet);
                    winMsg(`合成${rune[0].name}*${canGet}`)
                    return true;
                }else{
                    winMsg('没有更上级的符文了', false, false)
                    return false;
                }
            }else{
                winMsg('数量不足，无法合成', false, false)
                return false;
            }
        }});
    })

    return eleRunes;
}

//获取物品配置中用的镶嵌物信息
function getElementsInlays(){
    const eleInlays = {};

    inlays.forEach(e => {
        eleInlays[e.name] = new Element({isInlay :true, atkTags : e.atkTags || [],quality : e.quality || 0, name :e.name,level : e.level, voidDust : levelVoidDush[e.level], gold : levelVoidDush[e.level]*5, hp : e.hp, endurance : e.endurance, atk : e.atk, def : e.def, suck :e.suck, noWear : e.noWear, text : e.text, canUse : e.canUse, func : e.func});
    })

    return eleInlays;
}

//获取镶嵌物附加属性说明文本
function getInlayText(name, firstNotBr){
    const item = elementCfgs[name];
    let text = '';
    if(item.getHp()){
        text += `${firstNotBr ? '' : '<br>'}HP+${item.getHp()}`;
    }
    if(item.getAtk(item)){
        text += `${firstNotBr ? '' : '<br>'}攻击：${item.getAtk(item)}`;
    }
    if(item.def){
        text += `${firstNotBr ? '' : '<br>'}防御：${item.def}`;
    }
    if(item.suck){
        text += `${firstNotBr ? '' : '<br>'}吸血：${item.suck}%`;
    }
    if(item.endurance){
        text += `${firstNotBr ? '' : '<br>'}耐久度+${item.endurance}`;
    }
    if(item.noWear){
        text += `${firstNotBr ? '' : '<br>'}永不磨损`;
    }
    if(item.atkTags && item.atkTags.length > 0){
        text += `${firstNotBr ? '' : '<br>'}${item.atkTags.map(e => `对[${e.tag}]${e.rate < 0 ? '减少' : '增加'}${e.rate}倍伤害`).join('，')}`;
    }
    return text;
}

//获取符文之语属性说明文本
function getRuneWordText(name){
    const item = runeWord[name];
    let text = '';
    if(item.hp){
        text += `<br>HP+${item.hp}`;
    }
    if(item.atk){
        text += `<br>攻击：${item.atk}`;
    }
    if(item.def){
        text += `<br>防御：${item.def}`;
    }
    if(item.suck){
        text += `<br>吸血：${item.suck}%`;
    }
    if(item.noWear){
        text += `<br>永不磨损`;
    }
    if(item.endurance > 1){
        text += `<br>耐久度+${item.endurance}`;
    }
    return text;
}

//根据镶嵌物增加属性
function addAttr(equip, name){
    const item = elementCfgs[name];

    if(item.getHp()){
        equip.hp += item.getHp();
    }
    if(item.getAtk(item)){
        equip.atk += item.getAtk(item);
    }
    if(item.def){
        equip.def += item.def;
    }
    if(item.suck){
        equip.suck += item.suck;
    }
    if(item.noWear){
        equip.noWear = item.noWear;
    }
    if(item.endurance > 1){
        equip.endurance += item.endurance;
        equip.maxEndurance += item.endurance;
    }
    if(item.atkTags && item.atkTags.length > 0){
        if(!equip.atkTags){
            equip.atkTags = [];
        }
        item.atkTags.forEach(e => {
            equip.atkTags.push(e);
        })
    }

}

//根据符文之语增加属性
function addRuneWordAttr(equip, name){
    const item = runeWord[name];

    if(item.hp){
        equip.hp += item.hp;
    }
    if(item.atk){
        equip.atk += item.atk;
    }
    if(item.def){
        equip.def += item.def;
    }
    if(item.suck){
        equip.suck += item.suck;
    }
    if(item.noWear){
        equip.noWear = item.noWear;
    }
    if(item.endurance > 1){
        equip.endurance += item.endurance;
        equip.maxEndurance += item.endurance;
    }

    equip.showName = `${equip.name}：${item.name}`;
}

//镶嵌预览
let preInlay = {};
//选中的孔的下标
let hole = -1;
//渲染镶嵌台
function renderInlay(){
    preInlay = {};
    hole = -1;
    $('.inlay-equips').html('');
    $('.inlay-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && e.hole.length > 0){
            $('.inlay-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })

    renderInlays();
}

//渲染镶嵌物列表
function renderInlays(){
    $('.inlay-items').html('');
    $('.inlay-items').append(`<div class="bag-item" data-id="-1">取消</div>`);
    $('.inlay-items').append(`<div class="bag-item" data-id="-2" style="background-color: #03a9f4;color: #fff">查询符文之语</div>`);
    data.bag.forEach(e => {
        if(e.isInlay){
            const num = getCanUseNum(e);
            if(num <= 0){
                return;
            }
            $('.inlay-items').append(`<div class="bag-item" data-id="${e.id}">${e.showName || e.name}(${e.level})<br>x${num}</div>`);
        }
    })
}

//获取当前还可以使用的符文数量，这里的数量去掉了已经选中准备镶嵌的数量
function getCanUseNum(item){
    return getNumByBag(item.name) - Object.keys(preInlay).filter(e => preInlay[e] === item.name).length
}

//选中装备时
$('.inlay-equips').on('click','.bag-item',function(){
    preInlay = {};
    hole = -1;
    renderInlays();
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    //渲染窗口文本
    $('.inlay-equip-info').attr('data-id',id).html(text).find('.uninlay').append('-点这镶嵌');
});

//点击未镶嵌的孔洞时
$('.inlay-equip-info').on('click','.uninlay',function(){
    //获取物品
    const index = $(this).attr('data-index');
    $('.inlay-equip-info .active').removeClass('active');
    $(this).addClass('active');
    hole = index;
});

//直接镶嵌选中的符文之语，请确保这些符文背包中都存在
function selectRunsWordInlay(name){
    let arr = runeWord[name].runes;
    arr.forEach((e,i) => {
        preInlay[i] = e;
        $('.inlay-equip-info .uninlay.hole').eq(i).html(`▲${e}${getInlayText(e)}`);
    })
    renderInlays();
    $('.common-win').hide();
}

//点击符文时
$('.inlay-items').on('click','.bag-item',function(){
    const id = $(this).attr('data-id');

    if(id == '-2'){
        const equipId = $('.inlay-equip-info').attr('data-id');
        let eq = null;
        if(equipId){
            eq = getBagItemById(equipId);
        }

        function checkHasAllRunes(eq, rw){
            if(eq.hole){
               for(let i = 0 ; i < eq.hole.length ; i++){
                   if(eq.hole[i]){
                       return false;
                   }
               }
            }
            let arr = rw.runes;
            let flag = true;
            const needs = {};
            arr.forEach(e => {
                if(!needs[e]){
                    needs[e] = 0;
                }
                needs[e]++;
            })
            Object.keys(needs).forEach(e => {
                if(getNumByBag(e) < needs[e]){
                    flag = false;
                }
            })
            return flag;
        }

        $('.common-win').show().find('.win-body').html(`<div style="width: 100%;height: 100%;padding: 20px;overflow: auto"><div class="panel">请仔细阅读<u class="blue"><span class="to-cybernet" data-name="符文之语" onclick="javascript:$('.common-win').hide();">[图鉴-说明-符文之语🔍</span>]</u>后，再使用该功能</div>${Object.keys(runeWord).filter(e => eq ? runeWord[e].runes.length === eq.hole.length : true).map(e => {
            return `<div class="panel"><h5>${runeWord[e].name}(${runeWord[e].runes.length}孔)</h5>${runeWord[e].runes.map(r => `${r}(${runes.filter(ru => ru.name === r)[0].no}#)`).join('+')}${getRuneWordText(e)}<br>${eq && eq.quality === 0 ? `<button ${checkHasAllRunes(eq,runeWord[e]) ? 'class="active"' : 'disabled'} onclick="javascript:selectRunsWordInlay('${e}')">选择</button>` : `<font color="red">警告：你这件装备无法触发符文之语，可以使用符文之语的装备这里看不到这段话，而是会显示一个选择按钮</font>`}</div>`;
        }).join('<br>')}</div>`)
        return;
    }

    if(hole !== -1){
        if(id == '-1'){
            preInlay[hole] = null;
            $('.inlay-equip-info .active').html('△&nbsp;未镶嵌-点这镶嵌');
        }else{
            //获取物品
            const item = getBagItemById(id);

            preInlay[hole] = item.name;
            $('.inlay-equip-info .active').html(`▲${item.name}${getInlayText(item.name)}`);
        }
        renderInlays();
    }
});

//点击镶嵌
$('.aff-inlay').click(function(){
    const equipId = $('.inlay-equip-info').attr('data-id');

    if(!equipId){
        winMsg('未选择装备', false, false)
        return;
    }
    if(Object.keys(preInlay).filter(e => preInlay[e]).length === 0){
        winMsg('未选择新的镶嵌物', false, false)
        return;
    }

    //获取装备
    const eq = getBagItemById(equipId);

    //校验等级是否提升
    let oldLevel = eq.level;
    let newLevel = eq.level;
    Object.keys(preInlay).forEach(e => {
        if(preInlay[e]){
            //提升装备等级
            if(newLevel < elementCfgs[preInlay[e]].level){
                newLevel = elementCfgs[preInlay[e]].level
            }
        }
    })
    if(newLevel > oldLevel && !confirm(`镶嵌物等级高于装备等级，镶嵌后装备等级将变为${newLevel}级，玩家无法装备比自己等级高的装备，是否确认镶嵌？`)){
        return;
    }

    //获取所有已经有的怪物标签
    let hasTags = [];
    for(let i = 0 ; i < eq.hole.length ; i++){
        if(eq.hole[i] && elementCfgs[eq.hole[i]].atkTags){
            hasTags = [...hasTags, ...elementCfgs[eq.hole[i]].atkTags.map(e => e.tag)];
        }
    }

    let map = Object.keys(preInlay).map(e => preInlay[e]);
    for(let i = 0 ; i < map.length ; i++){
        if(map[i] && elementCfgs[map[i]].atkTags && elementCfgs[map[i]].atkTags.length > 0){
            let tags = elementCfgs[map[i]].atkTags.map(e => e.tag);
            if(hasTags.hasOne(tags)){
                winMsg(`一件装备上不能镶嵌多个针对同一个怪物标签的宝石`)
                return;
            }else{
                hasTags = [
                    ...hasTags,
                    ...tags,
                ];
            }
        }
    }

    //如果是已穿上的装备，则先卸下来
    let equiped = false;
    if((data.weapon && data.weapon.id === equipId) || (data.armor && data.armor.id === equipId)){
        equiped = true;
        equip(eq);
    }

    const attrs = {
        atk : 0,
        def : 0,
        hp : 0,
        suck : 0,
        endurance : 0,
        atkTags : []
    };
    //获取原本镶嵌物的属性总和
    eq.hole.forEach(e => {
        if(e){
            attrs.atk += elementCfgs[e].atk || 0;
            attrs.def += elementCfgs[e].def || 0;
            attrs.hp += elementCfgs[e].hp || 0;
            attrs.suck += elementCfgs[e].suck || 0;
            attrs.endurance += elementCfgs[e].endurance || 0;
            if(elementCfgs[e].atkTags){
                attrs.atkTags = [...attrs.atkTags,...elementCfgs[e].atkTags]
            }
        }
    })

    //循环镶嵌
    Object.keys(preInlay).forEach(e => {
        if(preInlay[e]){
            //镶嵌进孔洞
            eq.hole[parseInt(e)] = preInlay[e];
            //减少符文
            reduceItem(preInlay[e])
            //提升装备等级
            if(eq.level < elementCfgs[preInlay[e]].level){
                eq.level = elementCfgs[preInlay[e]].level
            }
        }
    })

    //记录全名，用于判断符文之语
    let allName = '';
    //是否所有孔洞都镶嵌了
    let inHoleNum = 0;
    eq.hole.forEach(e => {
        if(e){
            inHoleNum++;
            allName += e;
        }
    })

    //如果全部孔洞都镶嵌了，且装备是普通品质，且是符文之语，则装备变为符文之语装备
    if(inHoleNum === eq.hole.length && eq.quality === 0 && runeWord[allName] && !(eq.showName && Object.keys(runeWord).filter(i => eq.showName.endsWith(runeWord[i].name)).length > 0)){
        //先扣除原本镶嵌物品的属性
        eq.atk -= attrs.atk;
        eq.def -= attrs.def;
        eq.hp -= attrs.hp;
        eq.suck -= attrs.suck;
        eq.endurance -= attrs.endurance;
        if(eq.maxEndurance){
            eq.maxEndurance -= attrs.endurance;
        }

        //扣除标签伤害
        attrs.atkTags.forEach(e => {
            if(eq.atkTags && eq.atkTags.length > 0){
                let ts = eq.atkTags.filter(t => t.tag === e.tag);
                if(ts.length){
                    ts[0].rate = parseFloat2Fiexd(ts[0].rate - e.rate)
                }
            }
        })
        addRuneWordAttr(eq, allName)
    }else{//否则增加镶嵌物属性
        Object.keys(preInlay).forEach(e => {
            if(preInlay[e]){
                //添加属性
                addAttr(eq, preInlay[e]);
            }
        })
    }

    //重新穿上
    if(equiped){
        equip(eq);
    }

    save();
    winMsg('镶嵌成功')
    renderInlay();
})

//渲染符文法阵
function renderRuneCircle(){
    $('.rune-circle-equips').html('');
    $('.old-equip-info').attr('data-id','').html('');
    $('.new-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && e.hole.length > 1 && !e.quality && ((e.showName && Object.keys(runeWord).filter(i => e.showName.endsWith(runeWord[i].name)).length > 0) || e.hole.filter(i => i).length === 0)){
            if(e.showName){
                const filter = Object.keys(runeWord).filter(i => e.showName.endsWith(runeWord[i].name));
                if(filter.length > 0 && runeWord[filter[0]].runes.length !== e.hole.length){
                    return;
                }
            }

            $('.rune-circle-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//符文法阵选中装备时
$('.rune-circle-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    if(item.showName && Object.keys(runeWord).filter(e => item.showName.endsWith(runeWord[e].name)).length > 0){
        //渲染窗口文本
        $('.old-equip-info').attr('data-id',id).html(text);
    }else if(item.hole.filter(e => e).length === 0){
        //渲染窗口文本
        $('.new-equip-info').attr('data-id',id).html(text);
    }
});

//点击转移符文之语
$('.transfer-rune-word').click(function(){
    const oldId = $('.old-equip-info').attr('data-id');
    const newId = $('.new-equip-info').attr('data-id');

    if(oldId && newId){
        const oldEq = getBagItemById(oldId);
        const newEq = getBagItemById(newId);
        if(oldEq.hole.length === newEq.hole.length){
            if(confirm('符文之语转移会摧毁原本的装备，且被转移的装备如果等级低于已有符文之语的装备，会强行被拉高到原装备相同等级（不论符文等级），是否确认转移？')){
                //如果是已穿上的装备，则先卸下来
                let equiped = false;
                if((data.weapon && data.weapon.id === oldId) || (data.armor && data.armor.id === oldId)){
                    equip(oldEq);
                }
                if((data.weapon && data.weapon.id === newId) || (data.armor && data.armor.id === newId)){
                    equiped = true;
                    equip(newEq);
                }

                newEq.hole = oldEq.hole;
                addRuneWordAttr(newEq, Object.keys(runeWord).filter(e => runeWord[e].name === oldEq.showName.replace(`${oldEq.name}：`,''))[0])
                data.bag = data.bag.filter(e => e.id !== oldId)

                if(newEq.level < oldEq.level){
                    newEq.level = oldEq.level
                }

                //重新穿上
                if(equiped){
                    equip(newEq);
                }
                winMsg('符文之语已转移')
                save();
                renderRuneCircle();
            }
        }else{
            winMsg('两件装备孔数不一致', false, false)
        }
    }else{
        winMsg('请选择参与转移的装备', false, false)
    }
});

//渲染打孔器
function renderAddHole(){
    $('.add-hole-btn').html(`神性结晶(${getNumByBag('神性结晶', true)})`);
    $('.equip-add-hole .equip-add-hole-circle-equips').html('');
    $('.equip-add-hole .equip-add-hole-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.filter(e => !e.washing).forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石')){
            $('.equip-add-hole .equip-add-hole-circle-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//打孔器选中装备时
$('.equip-add-hole .equip-add-hole-circle-equips').on('click','.bag-item',function(){
    renderAddHoleEqInfo($(this).attr('id'));
});
function renderAddHoleEqInfo(id){
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    $('.equip-add-hole .equip-add-hole-equip-info').attr('data-id',id).html(text);
}

//神性结晶打孔
$('.add-hole-btn').click(function(){
    const equipId = $('.equip-add-hole .equip-add-hole-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)
    if(eq){
        if(eq.hole.filter(ho => ho).length > 0){
            winMsg('不能用神性结晶给已镶嵌的装备打孔', false, false)
            return;
        }

        const num = getNumByBag('神性结晶', true);
        const need = addHoleNeed[eq.quality];

        if(num >= need){
            //获取背包中的数量
            const bagNum = getNumByBag('神性结晶');
            //优先使用背包中的物品
            if(bagNum >= need){
                reduceItem('神性结晶', need);
            }else{
                if(bagNum > 0){
                    reduceItem('神性结晶', bagNum);
                }
                reduceItemByStore('神性结晶', need - bagNum);
            }

            //打孔
            const rn = randomNum(1,100);
            const holeNum = rn >= 1 && rn <= 65 ? randomNum(1,2) : rn >=66 && rn <= 90 ? randomNum(3,4) : randomNum(5,6);
            eq.hole = new Array(holeNum);
            winMsg('打孔成功，获得孔数：' + eq.hole.length)
            renderAddHole();
            renderAddHoleEqInfo(equipId);
            save();
        }else{
            winMsg('神性结晶不足', false, false)
        }
    }
})
//打孔石打孔
$('.add-hole-stone-btn').click(function(){
    const equipId = $('.equip-add-hole .equip-add-hole-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)

    if(eq){
        if(eq.hole.length >= 9){
            winMsg('孔数已达上限', false, false)
            return false;
        }

        let name = '';
        if(eq.isWeapon){
            for(let i = 9 ; i > 0 ; i--){
                if(!name){
                    const tempName = i + '0级武器打孔石';
                    const num = getNumByBag(tempName);
                    if(num > 0){
                        name = tempName
                    }
                }
            }
            if(!name){
                winMsg('武器打孔石不足', false, false)
               return;
            }
        }else{
            for(let i = 9 ; i > 0 ; i--){
                if(!name){
                    const tempName = i + '0级护甲打孔石';
                    const num = getNumByBag(tempName);
                    if(num > 0){
                        name = tempName
                    }
                }
            }
            if(!name){
                winMsg('护甲打孔石不足', false, false)
                return;
            }
        }

        addHole(eq, parseInt(name));
        reduceItem(name)
        renderAddHole();
        renderAddHoleEqInfo(equipId);
        save();
    }
})
//万能打孔石打孔
$('.add-hole-stone-all-btn').click(function(){
    const equipId = $('.equip-add-hole .equip-add-hole-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)

    if(eq){
        if(eq.hole.length >= 12){
            winMsg('孔数已达上限', false, false)
            return false;
        }

        let name = '';
        if(eq.isWeapon){
            name = '万能武器打孔石';
            if(getNumByBag(name) < 1){
                winMsg('万能武器打孔石不足', false, false)
                return;
            }
        }else{
            name = '万能护甲打孔石';
            if(getNumByBag(name) < 1){
                winMsg('万能护甲打孔石不足', false, false)
                return;
            }
        }

        addHole(eq, 1000);
        reduceItem(name)
        renderAddHole();
        renderAddHoleEqInfo(equipId);
        save();
    }
})
