//配方
let recipes = {
    /* 空手就可以制作的物品 */
    '木斧' : createRecipesCfg({'树枝' : 1, '纤维' : 2, '木材' : 2}),
    '木镐' : createRecipesCfg({'树枝' : 1, '纤维' : 2, '木材' : 2}),
    '木铲' : createRecipesCfg({'树枝' : 1}),
    '石矛' : createRecipesCfg({'树枝' : 1, '纤维' : 2, '燧石' : 1}),
    '草甲' : createRecipesCfg({'树枝' : 3, '纤维' : 5}),
    '背篓' : createRecipesCfg({'树枝' : 5, '纤维' : 2}),
    '树枝' : createRecipesCfg({'木材' : 1}, 0, null, 3),

    /* 制作等级1的物品 */
    //采集工具
    '布' : createRecipesCfg({'碎布片' : 5, '纤维' : 2, '尖牙' : 1}, 1),
    '铁片' : createRecipesCfg({'铁锭' : 1}, 1, null, 8),
    '石斧' : createRecipesCfg({'树枝' : 3, '纤维' : 2, '石头' : 5}, 1),
    '石镐' : createRecipesCfg({'树枝' : 3, '纤维' : 2, '石头' : 5}, 1),
    '铁斧' : createRecipesCfg({'树枝' : 5, '铁锭' : 3}, 1),
    '铁镐' : createRecipesCfg({'树枝' : 5, '铁锭' : 3}, 1),
    '鱼竿' : createRecipesCfg({'树枝' : 2,'纤维' : 5,'木材' : 3,'铁锭' : 1}, 1),

    //药品
    '草药膏' : createRecipesCfg({'草药' : 3, '粘液' : 1}, 1),
    '荧光粉' : createRecipesCfg({'骨头' : 3,'火焰灰烬' : 1}, 1),
    '蘑菇药膏' : createRecipesCfg({'微光蘑菇' : 3, '荧光粉' : 2}, 1),
    '特效草药膏' : createRecipesCfg({'草药膏' : 1, '史莱姆精华' : 3}, 1),
    '血肉药膏' : createRecipesCfg({'血肉花蕊' : 2, '食人花汁' : 3, '暗影血肉' : 1}, 1),
    '血肉之心' : createRecipesCfg({'血肉果实' : 3, '灵魂草' : 3}, 1),

    //背包
    '布包' : createRecipesCfg({'布' : 3, '纤维' : 10, '尖牙' : 2}, 1),
    '皮包' : createRecipesCfg({'兽皮' : 10, '纤维' : 10, '尖牙' : 5}, 1),
    '灵纹布包' : createRecipesCfg({'灵魂残片' : 20, '布' : 20, '尖牙' : 5, '纤维' : 10}, 1),
    '海胆皮包' : createRecipesCfg({'海胆皮' : 20, '鱼人牙齿' : 5, '纤维' : 10}, 1),
    '毛线背包' : createRecipesCfg({'羊毛' : 30, '柔韧根茎' : 10, '兽人之牙' : 5}, 1),
    '魔兽皮包-1' : createRecipesCfg({'魔兽皮' : 20, '虎皮' : 10, '灵魂晶粉' : 10}, 1),
    '魔兽皮包-2' : createRecipesCfg({'石化颊囊' : 20, '石化毛皮' : 10, '黄水晶' : 10}, 1),
    '珍贵皮包-1' : createRecipesCfg({'重皮' : 20, '青牙兽皮' : 10, '大地之皮' : 10, '幽灵蛛丝' : 5}, 1),
    '珍贵皮包-2' : createRecipesCfg({'鳄鱼皮' : 20, '泰坦硬皮' : 10, '河马皮' : 10, '水纹毒丝' : 5}, 1),
    '龙皮背包' : createRecipesCfg({'幼龙皮' : 10, '五彩蛟麟' : 10, '幽灵蛛丝' : 10}, 1),
    '真龙皮包' : createRecipesCfg({'龙鳞' : 10, '龙皮' : 10, '特制尸油' : 5}, 1),

    //炼金室专属配方
    '微效治疗药剂' : createRecipesCfg({'草药' : 5, '蛇胆' : 1}, 1, '炼金室'),
    '弱效治疗药剂-1' : createRecipesCfg({'草药' : 3, '微光蘑菇' : 5, '微效治疗药剂' : 1}, 1, '炼金室'),
    '弱效治疗药剂-2' : createRecipesCfg({'草药' : 3, '鱼人眼球' : 5, '元素水' : 3}, 1, '炼金室'),
    '中效治疗药剂-1' : createRecipesCfg({'食人花汁' : 3, '灵魂晶粉' : 2, '弱效治疗药剂' : 1}, 1, '炼金室'),
    '中效治疗药剂-2' : createRecipesCfg({'石血藤' : 5, '弱效治疗药剂' : 1}, 1, '炼金室'),
    '高效治疗药剂' : createRecipesCfg({'灵魂草' : 3, '血肉树心' : 1, '中效治疗药剂' : 1}, 1, '炼金室'),
    '强效治疗药剂' : createRecipesCfg({'草药' : 5, '女妖心脏' : 1, '龙兽肝脏' : 1, '高效治疗药剂' : 1}, 1, '炼金室'),
    '龙血药剂' : createRecipesCfg({'水晶空瓶' : 1, '龙血' : 5, '龙晶' : 1, '强效治疗药剂' : 1}, 1, '炼金室'),
    '哥布林心脉精华-1' : createRecipesCfg({'哥布林之心' : 1, '红水晶' : 5}, 1, '炼金室'),
    '哥布林心脉精华-2' : createRecipesCfg({'哥布林之心' : 1, '纯净水晶' : 2}, 1, '炼金室'),
    '魔蛟心脉精华' : createRecipesCfg({'哥布林心脉精华' : 5, '魔蛟精血' : 3, '魔蛟骨髓' : 2}, 1, '炼金室'),
    '狂暴心脉精华' : createRecipesCfg({'哥布林心脉精华' : 2, '狂暴内胆' : 1, '毒沼花' : 5}, 1, '炼金室'),
    '巫毒药剂' : createRecipesCfg({'毒囊' : 2,'蛇胆' : 1,'草药' : 3,'芦苇' : 2,'粘液' : 3}, 1, '炼金室'),
    '魔晶炸弹' : createRecipesCfg({'魔晶石' : 10,'贝壳' : 1,'尖牙' : 5,'石头' : 3}, 1, '炼金室'),
    '火焰爆弹' : createRecipesCfg({'红水晶' : 3,'火焰灰烬' : 5, '硬壳' : 2, '魔核' : 1}, 1, '炼金室'),
    '潮汐珠宝' : createRecipesCfg({'纯净水晶' : 1,'元素水' : 5, '螃蟹壳' : 2, '珍珠' : 1}, 1, '炼金室'),
    '飞雷矛' : createRecipesCfg({'疾风鹰羽' : 5,'雷角' : 1,'柔韧根茎' : 3, '紫晶' : 5}, 1, '炼金室'),
    '石化炸弹' : createRecipesCfg({'石之核' : 5,'黄水晶' : 1,'石化甲壳' : 3}, 1, '炼金室'),
    '幽灵猛毒' : createRecipesCfg({'幽灵毒囊' : 5,'剧毒尾刺' : 1,'黄酮胆' : 1, '巫毒药剂' : 1}, 1, '炼金室'),
    '病毒吹箭' : createRecipesCfg({'病毒粘液' : 5,'长针管' : 1,'毒沼花' : 3, '水纹毒牙' : 1}, 1, '炼金室'),
    '尸毒飞镖' : createRecipesCfg({'尸毒牙' : 5,'异化骨头' : 3,'灵魂草' : 3, '幽灵猛毒' : 1, '尸核' : 5}, 1, '炼金室'),

    //熔炉专属配方
    '铁锭-1' : createRecipesCfg({'铁矿' : 2,'木材' : 1}, 1, '熔炉'),
    '铁锭-2' : createRecipesCfg({'铁片' : 10,'木材' : 2}, 1, '熔炉'),
    '铜锭' : createRecipesCfg({'铜矿' : 2,'木材' : 1}, 1, '熔炉'),
    '金锭' : createRecipesCfg({'金矿' : 20,'木材' : 20}, 1, '熔炉'),

    //厨房专属配方
    '烤肉' : createRecipesCfg({'肉' : 1}, 1, '厨房'),
    '烤鱼' : createRecipesCfg({'鱼' : 1}, 1, '厨房'),
    '鱼汤' : createRecipesCfg({'鱼' : 3,'水' : 5}, 1, '厨房'),
    '蟹肉大餐-1' : createRecipesCfg({'螃蟹' : 5, '草药' : 1}, 1, '厨房'),
    '蟹肉大餐-2' : createRecipesCfg({'蟹肉' : 5, '草药' : 1}, 1, '厨房'),
    '烤干贝' : createRecipesCfg({'贝肉' : 5, '草药' : 1}, 1, '厨房'),
    '蘑菇煲' : createRecipesCfg({'蘑菇' : 5,'水' : 3}, 1, '厨房'),
    '烤羊肉' : createRecipesCfg({'羊肉' : 1}, 1, '厨房'),
    '烤魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 1, '厨房'),
    '蜜汁血蕊' : createRecipesCfg({'血肉花蕊' : 1,'食人花汁' : 2}, 1, '厨房'),
    '亚龙肉排' : createRecipesCfg({'亚龙肉' : 1}, 1, '厨房'),

    //次元研究室专属配方
    '灵魂追猎-1' : createRecipesCfg({'灵魂石' : 1,'魔核' : 1, '魔晶石' : 10}, 1, '次元研究室'),
    '灵魂追猎-2' : createRecipesCfg({'潮汐之心' : 1,'水之核' : 1, '魔晶石' : 10}, 1, '次元研究室'),
    '次元钥匙' : createRecipesCfg({'神性结晶' : 1, '魔晶石' : 10}, 1, '次元研究室'),
    '次元信标' : createRecipesCfg({'神性结晶' : 1, '灵魂追猎' : 10}, 1, '次元研究室'),
    '次元移动-1' : createRecipesCfg({'神性结晶' : 1, '灵魂石' : 1}, 1, '次元研究室'),
    '次元移动-2' : createRecipesCfg({'神性结晶' : 1, '纯净水晶' : 5}, 1, '次元研究室'),

    //亵渎室专属配方
    '神性炸弹-1' : createRecipesCfg({'神性液体' : 5, '神性结晶' : 1, '魔晶石' : 20, '红水晶' : 10}, 1, '亵渎室'),
    '神性炸弹-2' : createRecipesCfg({'神性液体' : 5, '神性结晶' : 1, '魔晶石' : 20, '纯净水晶' : 4}, 1, '亵渎室'),
    '神性药剂' : createRecipesCfg({'神性液体' : 6, '神性结晶' : 10, '遗忘之魂' : 2}, 1, '亵渎室'),
    '强效神性药剂' : createRecipesCfg({'神性药剂' : 2, '风暴药剂' : 1, '赐福神力' : 1, '卫士之盾' : 40}, 1, '亵渎室'),
    '灵魂威慑' : createRecipesCfg({'神性液体' : 2, '纯净水晶' : 2, '哥布林魔晶' : 1}, 1, '亵渎室'),
    '神性爆弹' : createRecipesCfg({'纯净水晶' : 10,'魔力水晶' : 5, '神性结晶' : 5, '魔力之源' : 5, '龙晶' : 1}, 1, '亵渎室'),

    //时空法阵专属配方
    '回城卷轴' : createRecipesCfg({'时空粉尘' : 3, '神性结晶' : 1}, 1, '时空法阵'),
    '小型传送阵' : createRecipesCfg({'时空粉尘' : 5, '神性结晶' : 1}, 1, '时空法阵'),
    '短程传送卷轴' : createRecipesCfg({'时空粉尘' : 1, '神性结晶' : 1}, 1, '时空法阵'),

    //生命祭坛专属配方
    '转生卷轴：巨龙' : createRecipesCfg({'巨龙血脉' : 10, '神性结晶' : 10, '神血' : 1}, 1, '生命祭坛'),
    '灵魂标记：亡灵族' : createRecipesCfg({'不死印记' : 10, '不灭灵魂' : 10, '神性结晶' : 10}, 1, '生命祭坛'),
    '灵魂标记：巫妖' : createRecipesCfg({'不死印记' : 10, '不灭灵魂' : 10, '死灵之书' : 10, '灵魂护符' : 10}, 1, '生命祭坛'),
    '巫妖生态研究笔记' : createRecipesCfg({'死灵之书' : 10, '灵魂护符' : 10}, 1, '生命祭坛'),

    //神力窃取室专属配方
    '重生十字章' : createRecipesCfg({'赐福神力' : 5, '神性结晶' : 10, '神血' : 1}, 1, '神力窃取室'),
    '巨龙之力' : createRecipesCfg({'赐福神力' : 1, '龙血' : 10, '诅咒魂晶' : 3, '龙魂' : 1, '巨龙之殇' : 1}, 1, '神力窃取室'),
    '龙魂药剂' : createRecipesCfg({'五龙魂' : 1, '巨龙之力' : 1, '风暴药剂' : 1, '龙血药剂' : 1, '龙晶' : 10}, 1, '神力窃取室'),
    '天赋神晶' : createRecipesCfg({'赐福神力' : 1, '精铁断剑' : 20, '大剑士徽章' : 20, '冠军凭证' : 10}, 1, '神力窃取室'),
    '风暴号角' : createRecipesCfg({'战争号角' : 1, '沙尘印记' : 1, '神性结晶' : 1}, 1, '神力窃取室'),
    '风暴药剂' : createRecipesCfg({'水晶空瓶' : 1, '暴风龙眼' : 1, '神性结晶' : 1}, 1, '神力窃取室'),
    '龙魂宝石' : createRecipesCfg({'五彩石' : 1, '五龙魂' : 1, '赐福神力' : 1, '神性结晶' : 20}, 1, '神力窃取室'),
    '神灵之力' : createRecipesCfg({'神格' : 1, '神血' : 10, '神性结晶' : 100}, 1, '神力窃取室'),
    '五龙魂' : createRecipesCfg({'龙魂' : 1, '红龙魂' : 1, '蓝龙魂' : 1, '绿龙魂' : 1, '黑龙魂' : 1}, 1, '神力窃取室'),
    '五彩石' : createRecipesCfg({'璀璨的红宝石' : 5, '璀璨的黄宝石' : 5, '璀璨的紫宝石' : 5, '璀璨的绿宝石' : 5, '璀璨的橙色宝石' : 5}, 1, '神力窃取室'),

    //天赋祭坛专属配方
    ...getBatchItem(Object.keys(races).filter(e => e.includes('-') && races[e].godRace && !e.startsWith('断肠人')), function(name){
        return {
            [name] : createRecipesCfg({'天赋神晶' : 1}, 1, '天赋祭坛')
        }
    }),

    //纳米机器专属配方
    '黄昏盾牌' : createRecipesCfg({'机械碎片' : 10, '机械核心' : 1, '红水晶' : 10, '黑曜石' : 10}, 1, '纳米机器'),
    '海洋盾牌' : createRecipesCfg({'机械碎片' : 10, '机械核心' : 1, '蓝水晶' : 10, '水之核' : 10}, 1, '纳米机器'),
    '紫星盾牌' : createRecipesCfg({'机械碎片' : 20, '机械核心' : 2, '紫晶' : 10, '灵魂晶粉' : 10}, 1, '纳米机器'),
    '山岭盾牌' : createRecipesCfg({'机械碎片' : 20, '机械核心' : 2, '黄水晶' : 10, '石之核' : 10}, 1, '纳米机器'),
    '世界之盾' : createRecipesCfg({'机械碎片' : 30, '机械核心' : 3, '大地之皮' : 10, '五彩蛟麟' : 5}, 1, '纳米机器'),
    '病毒之盾' : createRecipesCfg({'机械碎片' : 30, '机械核心' : 3, '毒晶' : 10, '病毒脑核' : 5}, 1, '纳米机器'),
    '幽灵盾牌' : createRecipesCfg({'机械碎片' : 50, '机械核心' : 4, '诅咒核心' : 10, '不灭灵魂' : 3}, 1, '纳米机器'),
    '冠军盾牌' : createRecipesCfg({'机械碎片' : 80, '机械核心' : 5, '冠军凭证' : 5, '赐福神力' : 3}, 1, '纳米机器'),
    '暴风盾牌' : createRecipesCfg({'机械碎片' : 100, '机械核心' : 8, '沙尘印记' : 5, '暴风龙眼' : 3}, 1, '纳米机器'),
    '龙盾' : createRecipesCfg({'机械碎片' : 150, '机械核心' : 10, '龙鳞' : 10, '龙晶' : 5}, 1, '纳米机器'),

    '贤者之石' : createRecipesCfg({'草木神力精华' : 1, '森林神力精华' : 1, '山脉神力精华' : 1, '大地神力精华' : 1, '生命神力精华' : 1}, 1, '最终退路'),

    //活动配方
    ...getFestivalRecipes()
}

//锻造配方
const forgeRecipes = {
    '利齿匕首' : createForgeRecipesCfg({'尖牙' : 5,'铁片' : 5,'铜锭' : 1}),
    '软皮甲' : createForgeRecipesCfg({'粘液' : 5,'软皮' : 5,'纤维' : 2,'尖牙' : 1}),
    '兽爪拳刃' : createForgeRecipesCfg({'利爪' : 10,'兽皮' : 5,'蜘蛛丝' : 2,'铜锭' : 1}),
    '兽皮甲' : createForgeRecipesCfg({'兽皮' : 10,'软皮' : 5,'粘液' : 5,'尖牙' : 1,'纤维' : 3}),
    '羽刃扇' : createForgeRecipesCfg({'羽毛' : 10,'铁锭' : 5,'蜘蛛丝' : 10,'兽皮' : 5,'粘液' : 30}),
    '甲壳衣' : createForgeRecipesCfg({'甲壳' : 10,'软皮' : 5,'蜘蛛丝' : 5,'尖牙' : 2}),
    '哥布林杀手' : createForgeRecipesCfg({'哥布林魔晶' : 3,'哥布林之心' : 5,'铁锭' : 5,'兽皮' : 10}),
    '弱小联合' : createForgeRecipesCfg({'闪耀的皮' : 10,'哥布林魔晶' : 3,'哥布林之心' : 5,'神性液体' : 10}),

    '麦林之刃' : createForgeRecipesCfg({'兽骨' : 5,'硬皮' : 5,'黑曜石' : 5}),
    '冲锋甲' : createForgeRecipesCfg({'硬壳' : 5,'硬皮' : 5,'黑曜石' : 10}),
    '重锤' : createForgeRecipesCfg({'兽骨' : 5,'黑曜石' : 5,'矮人胡环' : 5}),
    '矮人之心' : createForgeRecipesCfg({'矮人胡环' : 5,'灵魂残片' : 5,'血肉精华' : 5}),
    '熔火剑' : createForgeRecipesCfg({'火结晶' : 5,'火焰灰烬' : 5,'魔核' : 3,'黑曜石' : 5}),
    '残火盔甲' : createForgeRecipesCfg({'火结晶' : 5,'火焰灰烬' : 10,'灵魂残片' : 10,'魔核' : 3}),
    '疯狂撕咬' : createForgeRecipesCfg({'地穴领主之爪' : 10,'魔核' : 10,'灵魂石' : 5,'残破的剑' : 1}),
    '灵魂外壳' : createForgeRecipesCfg({'地穴领主的壳' : 10,'神性魂石' : 5,'远古精魄' : 5,'遗忘之魂' : 3}),

    '鱼蟹锤' : createForgeRecipesCfg({'鱼人鳞片' : 10,'鱼人牙齿' : 5,'巨大蟹钳' : 10,'海胆皮' : 5}),
    '刺壳甲' : createForgeRecipesCfg({'鱼人鳞片' : 5,'螃蟹壳' : 10,'海胆毒刺' : 10,'珊瑚' : 5}),
    '鳞枪' : createForgeRecipesCfg({'鱼人鳞片' : 20,'海胆毒刺' : 5,'蓝水晶' : 10}),
    '蓝龟板甲' : createForgeRecipesCfg({'海龟壳' : 5,'鱼人眼球' : 20,'蓝水晶' : 5}),
    '碧水枪' : createForgeRecipesCfg({'蓝鳞蛇皮' : 10,'海胆毒刺' : 5,'元素水' : 10,'蓝水晶' : 10}),
    '波涛甲' : createForgeRecipesCfg({'蓝鳞蛇皮' : 10,'元素水' : 5,'水之核' : 5,'珍珠' : 3,'蓝水晶' : 5}),
    '潮汐权杖' : createForgeRecipesCfg({'潮汐之眼' : 5,'潮汐之心' : 3,'海象角' : 3,'海象牙' : 5}),
    '怒浪重皮' : createForgeRecipesCfg({'海浪之鳞' : 10,'海象皮' : 5,'蓝光鳞片' : 10,'光辉鱼眼' : 5,'冰凉鱼油' : 5}),

    '战刀' : createForgeRecipesCfg({'史莱姆核心' : 5,'哥布林手爪' : 10,'哥布林残刃' : 5}),
    '柔韧软甲' : createForgeRecipesCfg({'史莱姆核心' : 5,'坚韧软皮' : 10,'破口袋' : 10}),
    '魔兽锋芒' : createForgeRecipesCfg({'魔兽骨' : 5,'魔兽皮' : 5,'魔兽爪' : 10,'角蛇的角' : 5,'柔韧根茎' : 5}),
    '魔兽骨甲' : createForgeRecipesCfg({'魔兽骨' : 10,'魔兽皮' : 5,'虎皮' : 5,'柔韧根茎' : 5}),
    '元素冲击' : createForgeRecipesCfg({'雷角' : 5,'疾风鹰羽' : 5,'蝎尾狮的尾巴' : 5,'暗影血肉' : 5}),
    '兽人战甲' : createForgeRecipesCfg({'柔韧根茎' : 5,'疾风鹰羽' : 5,'兽人之牙' : 5,'兽人之心' : 5}),
    '兽人必须死' : createForgeRecipesCfg({'柔韧根茎' : 10,'疯狂之血' : 5,'疯狂的心' : 3,'紫晶之核' : 10}),
    '紫晶狂兽神' : createForgeRecipesCfg({'疯狂之血' : 15,'疯狂的心' : 5,'神性紫晶' : 5,'神性枢纽' : 10}),

    '强酸利刃' : createForgeRecipesCfg({'强酸粘液' : 5,'战刀残片' : 5,}),
    '强韧重甲' : createForgeRecipesCfg({'酸性软皮' : 10,'强酸粘液' : 5,'重甲零件' : 5}),
    '御灵权杖' : createForgeRecipesCfg({'骨头杖' : 5,'骨头项链' : 5,'幽灵蛛丝' : 5,'毒牙' : 5}),
    '毒刺铠甲' : createForgeRecipesCfg({'狼鞍' : 5,'骨刺' : 5,'幽灵蛛丝' : 5,'幽灵毒囊' : 5,'剧毒尾刺' : 5}),
    '荒原战刀' : createForgeRecipesCfg({'巨爪' : 10,'巨牙' : 10,'荒芜之核' : 5,'青牙' : 10}),
    '亚龙皮甲' : createForgeRecipesCfg({'重壳' : 5,'重皮' : 10,'亚龙鳞' : 10,'青牙兽皮' : 5,'黄酮鳞' : 5}),
    '大地兽骨锤' : createForgeRecipesCfg({'大地之牙' : 10,'大地之皮' : 5,'兽人獠牙' : 10}),
    '大地兽骨甲' : createForgeRecipesCfg({'大地之牙' : 5,'大地之皮' : 10,'氏族旗帜' : 10}),
    '闪耀骑士剑' : createForgeRecipesCfg({'五彩蛟麟' : 10,'魔蛟精血' : 5,'骑士颅骨' : 3,'残破徽章' : 3,'魔餍魂核' : 3}),
    '狰狞巨兽' : createForgeRecipesCfg({'荒芜核心' : 3,'荒芜麟爪' : 5,'龙晶' : 1,'幼龙鳞' : 10,'幼龙皮' : 10}),

    '僵尸剑' : createForgeRecipesCfg({'亡灵骨刀' : 5,'亡灵骨杖' : 5,'尸水' : 10,'尸核' : 5,'异化骨头' : 5}),
    '僵尸甲' : createForgeRecipesCfg({'骸骨' : 20,'尸水' : 5,'尸核' : 5,'异化血肉' : 5}),
    '灵魂毒刺' : createForgeRecipesCfg({'幽魂碎片' : 10,'幽魂核心' : 5,'尸毒牙' : 5,'染血屠刀' : 5,'异化血液' : 10}),
    '血肉护甲' : createForgeRecipesCfg({'幽魂碎片' : 10,'幽魂核心' : 5,'尸毒蛇皮' : 5,'灵魂血肉' : 10,'血肉核心' : 5}),
    '亡灵之手' : createForgeRecipesCfg({'尸巫法杖' : 5,'亡灵法核' : 5,'吸血鬼牙' : 5,'亡灵碎石' : 10,'异化大骨' : 5}),
    '亡灵石甲' : createForgeRecipesCfg({'亡灵法核' : 5,'吸血鬼牙' : 10,'血族翅膀' : 5,'血肉石翼' : 10,'血肉核心' : 5}),
    '怨恨长枪' : createForgeRecipesCfg({'骷髅骑枪' : 5,'血魔之心' : 5,'血魔残骸' : 10,'怨恨之魂' : 5,'灵魂结晶' : 5}),
    '诅咒铠甲' : createForgeRecipesCfg({'骷髅马鞍' : 5,'血魔之心' : 5,'血魔残骸' : 10,'诅咒核心' : 5,'灵魂结晶' : 5}),

    '荒骨之咬' : createForgeRecipesCfg({'精密骨骼' : 10,'骨质大剑' : 5,'战士徽章' : 5,'巨魔骨矛' : 5}),
    '赐福甲胄' : createForgeRecipesCfg({'精密骨骼' : 10,'战士徽章' : 5,'赐福铠甲' : 5,'巨魔颅骨' : 5}),
    '魔法弓' : createForgeRecipesCfg({'魔法宝石' : 5,'精密断弓' : 5,'附魔箭矢' : 10,'枯朽粘液' : 15,'灰白的皮' : 10}),
    '魔法斗篷' : createForgeRecipesCfg({'魔法宝石' : 5,'法师帽' : 10,'附魔箭矢' : 10,'枯朽粘液' : 15,'灰白的皮' : 10}),
    '元素之灵' : createForgeRecipesCfg({'赐福长枪' : 5,'骑士徽章' : 5,'鲜血骨爪' : 10,'元素印记' : 5}),
    '元素庇佑' : createForgeRecipesCfg({'骑士徽章' : 5,'鲜血图腾' : 5,'元素印记' : 5,'女巫徽章' : 5}),

    '狂信战锤' : createForgeRecipesCfg({'负重锁链' : 5,'狂信徽章' : 5,'卫士徽章' : 5,'制式战弓' : 5,'制式箭矢' : 10}),
    '信仰卫士' : createForgeRecipesCfg({'染血锁环' : 5,'信仰雕像' : 5,'卫士之盾' : 5,'制式箭矢' : 10}),
    '狩猎长刀' : createForgeRecipesCfg({'猎人陷阱' : 10,'淬毒匕首' : 5,'精铁钩爪' : 10,'战兽爪' : 10,'白皮' : 10}),
    '猎人皮甲' : createForgeRecipesCfg({'鲜血毛皮' : 10,'精铁钩爪' : 10,'浸水皮' : 10,'白鳞' : 10,'白皮' : 10}),
    '荣耀魔剑' : createForgeRecipesCfg({'女妖手爪' : 10,'飓风魔核' : 5,'荣耀长枪' : 5,'神圣连枷' : 5}),
    '妖风圣衣' : createForgeRecipesCfg({'女妖翅膀' : 10,'飓风魔皮' : 10,'荣耀马鞍' : 5,'神圣长袍' : 5}),

    '亚龙之咬' : createForgeRecipesCfg({'烈焰亚龙牙' : 15,'冰霜亚龙牙' : 15,'剧毒亚龙牙' : 15,'黑暗亚龙牙' : 15,'亚龙鳞' : 25}),
    '亚龙鳞甲' : createForgeRecipesCfg({'烈焰亚龙牙' : 10,'冰霜亚龙牙' : 10,'剧毒亚龙牙' : 10,'黑暗亚龙牙' : 10,'亚龙鳞' : 40}),
    '龙魂之力' : createForgeRecipesCfg({'红龙魂' : 5,'蓝龙魂' : 5,'绿龙魂' : 5,'黑龙魂' : 5,'龙晶' : 5}),
    '龙魂守护' : createForgeRecipesCfg({'红龙魂' : 5,'蓝龙魂' : 5,'绿龙魂' : 5,'黑龙魂' : 5,'龙鳞' : 20}),

    ...newMapElements.forgeRecipes,
};
