//地图允许出现的可采集元素和怪物配置
const terrainElements = {
    '草原' : {
        monster : {
            ...terrainMonster('史莱姆', 80),
            ...terrainMonster('哥布林', 30),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 10),
            ...terrainMonster('巨鼠', 10),

            ...terrainMonster('大史莱姆', 80),
            ...terrainMonster('哥布林战士', 30),
            ...terrainMonster('疾风狼', 10),
            ...terrainMonster('雷角马', 10),

            ...terrainMonster('强酸史莱姆', 80),
            ...terrainMonster('重装哥布林', 30),
            ...terrainMonster('迅猛龙', 10),

            ...terrainMonster('神选战士', 80),
            ...terrainMonster('神选法师', 80),
            ...terrainMonster('神选游侠', 80),
            ...terrainMonster('神选骑士', 80),
            ...terrainMonster('骷髅剑士', 80),
            ...terrainMonster('巨魔骷髅', 80),
            ...terrainMonster('亡灵蠕虫', 80),
            ...terrainMonster('神选冠军骑士', 10),
            ...terrainMonster('大剑士', 5),

            ...terrainMonster('苦修士', 30),
            ...terrainMonster('狂信徒', 20),
            ...terrainMonster('巡游卫士', 80),

            ...terrainMonster('无害小动物', 0),
            ...terrainMonster('草木之神', 30),
            ...terrainMonster('五首龙神', 5),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 5),
            ...terrainElement('草药丛', [-1,2], 3),
            ...terrainElement('树木', [0,1], 2),
            ...terrainElement('石块', [0,1], 1),
            ...terrainElement('浆果丛', [1,3], 4),
        }
    },
    '丘陵' : {
        monster : {
            ...terrainMonster('哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 30),
            ...terrainMonster('巨鼠', 10),

            ...terrainMonster('哥布林战士', 80),
            ...terrainMonster('雷角马', 50),
            ...terrainMonster('食人花', 10),
            ...terrainMonster('疾风猎鹰', 5),

            ...terrainMonster('重装哥布林', 80),
            ...terrainMonster('哥布林骑士', 30),
            ...terrainMonster('哥布林祭司', 20),
            ...terrainMonster('青牙兽', 10),

            ...terrainMonster('神选战士', 80),
            ...terrainMonster('神选法师', 80),
            ...terrainMonster('神选游侠', 80),
            ...terrainMonster('神选骑士', 80),
            ...terrainMonster('骷髅剑士', 80),
            ...terrainMonster('巨魔骷髅', 80),
            ...terrainMonster('亡灵蠕虫', 80),
            ...terrainMonster('神选冠军骑士', 10),
            ...terrainMonster('大剑士', 5),

            ...terrainMonster('苦修士', 30),
            ...terrainMonster('狂信徒', 20),
            ...terrainMonster('巡游卫士', 50),
            ...terrainMonster('哨塔射手', 80),

            ...terrainMonster('大地之神', 30),
            ...terrainMonster('五首龙神', 5),
        },
        elements : {
            ...terrainElement('草丛', [1,3], 5),
            ...terrainElement('草药丛', [-1,2], 3),
            ...terrainElement('树木', [1,3], 4),
            ...terrainElement('石块', [0,2], 2),
            ...terrainElement('浆果丛', [1,2], 3),
        }
    },
    '森林' : {
        monster : {
            ...terrainMonster('哥布林', 50),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 80),
            ...terrainMonster('蜘蛛', 30),
            ...terrainMonster('巨蟒', 10),

            ...terrainMonster('哥布林战士', 50),
            ...terrainMonster('疾风狼', 80),
            ...terrainMonster('暗影猎豹', 80),
            ...terrainMonster('剑齿虎', 80),
            ...terrainMonster('食人花', 80),

            ...terrainMonster('重装哥布林', 50),
            ...terrainMonster('刺蛇', 80),
            ...terrainMonster('迅猛龙', 30),
            ...terrainMonster('青牙兽', 10),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('五彩魔蛟', 5),
            ...terrainMonster('重瞳魔猿', 10),

            ...terrainMonster('隐秘猎人', 80),
            ...terrainMonster('巡游卫士', 30),
            ...terrainMonster('阴影杀手', 70),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),

            ...terrainMonster('森林之神', 30),
            ...terrainMonster('五首龙神', 5),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 5),
            ...terrainElement('草药丛', [0,2], 3),
            ...terrainElement('树木', [4,6], 8),
            ...terrainElement('石块', [0,1], 1),
            ...terrainElement('浆果丛', [2,3], 5),
        }
    },
    '戈壁' : {
        monster : {
            ...terrainMonster('哥布林', 30),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('蝎子', 80),
            ...terrainMonster('蠕虫', 50),
            ...terrainMonster('巨蜥', 80),

            ...terrainMonster('死神蝎', 80),
            ...terrainMonster('荒原狼', 80),
            ...terrainMonster('厚皮蜥', 50),
            ...terrainMonster('荒龙', 30),
        },
        elements : {
            ...terrainElement('草丛', [0,2], 3),
            ...terrainElement('石块', [1,3], 3),
            ...terrainElement('树木', [0,2], 3),
            ...terrainElement('仙人掌', [0,2], 3),
            ...terrainElement('铁矿石', [-5,2], 2),
            ...terrainElement('铜矿石', [-5,2], 2),
            ...terrainElement('金矿石', [-5,2], 2),
        }
    },
    '沙漠' : {
        monster : {
            ...terrainMonster('蝎子', 80),
            ...terrainMonster('蠕虫', 50),
            ...terrainMonster('巨蜥', 10),
        },
        elements : {
            ...terrainElement('树木', [0,1], 2),
            ...terrainElement('仙人掌', [2,4], 6),
        }
    },
    '绿洲' : {
        monster : {
            ...terrainMonster('史莱姆', 80),
            ...terrainMonster('哥布林', 50),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('巨蜥', 70),
            ...terrainMonster('巨蟒', 30),
        },
        elements : {
            ...terrainElement('树木', [0,2], 3),
            ...terrainElement('仙人掌', [1,3], 4),
            ...terrainElement('草丛', [1,2], 3),
            ...terrainElement('水源', [3,5], 6),
        }
    },
    '河滩' : {
        monster : {
            ...terrainMonster('哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('巨蟒', 30),
            ...terrainMonster('食人鱼', 20),

            ...terrainMonster('哥布林战士', 50),
            ...terrainMonster('角蛇', 80),
            ...terrainMonster('疾风狼', 20),
            ...terrainMonster('暗影猎豹', 20),
            ...terrainMonster('雷角马', 30),
            ...terrainMonster('蝎尾狮', 5),
            ...terrainMonster('半兽人', 10),

            ...terrainMonster('厚皮蜥', 20),
            ...terrainMonster('迅猛龙', 50),
            ...terrainMonster('黄酮蟒', 80),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('大地熊', 30),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('神选战士', 80),
            ...terrainMonster('神选游侠', 80),
            ...terrainMonster('骷髅剑士', 80),
            ...terrainMonster('巨魔骷髅', 80),
            ...terrainMonster('神选冠军骑士', 10),
            ...terrainMonster('大剑士', 5),

            ...terrainMonster('隐秘猎人', 50),
            ...terrainMonster('巡游卫士', 30),
            ...terrainMonster('水生战兽', 80),
            ...terrainMonster('白鳞水蟒', 80),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),

            ...terrainMonster('五首龙神', 5),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 5),
            ...terrainElement('浆果丛', [0,2], 3),
            ...terrainElement('石块', [0,1], 1),
            ...terrainElement('水源', [3,5], 8),
            ...terrainElement('鱼群', [1,2], 3),
        }
    },
    '峡谷' : {
        monster : {
            ...terrainMonster('蝎子', 50),
            ...terrainMonster('蜘蛛', 80),
            ...terrainMonster('哥布林', 50),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 20),

            ...terrainMonster('荒龙', 80),
            ...terrainMonster('青牙兽', 30),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('大地熊', 10),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),
        },
        elements : {
            ...terrainElement('草丛', [1,2], 3),
            ...terrainElement('浆果丛', [0,1], 2),
            ...terrainElement('石块', [1,3], 3),
            ...terrainElement('树木', [0,1], 2),
            ...terrainElement('铁矿石', [-1,1], 1),
            ...terrainElement('铜矿石', [-1,1], 1),
            ...terrainElement('金矿石', [-1,1], 1),
        }
    },
    '湖泊' : {
        monster : {
            ...terrainMonster('史莱姆', 50),
            ...terrainMonster('哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 30),
            ...terrainMonster('巨蟒', 50),
            ...terrainMonster('食人鱼', 10),
            ...terrainMonster('鳄龟', 50),

            ...terrainMonster('迅猛龙', 50),
            ...terrainMonster('青牙兽', 50),
            ...terrainMonster('黄酮蟒', 80),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('大地熊', 30),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('隐秘猎人', 50),
            ...terrainMonster('巡游卫士', 30),
            ...terrainMonster('水生战兽', 80),
            ...terrainMonster('白鳞水蟒', 80),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 5),
            ...terrainElement('浆果丛', [1,2], 3),
            ...terrainElement('石块', [0,1], 1),
            ...terrainElement('水源', [3,5], 8),
            ...terrainElement('鱼群', [1,2], 3),
            ...terrainElement('树木', [0,1], 2),
        }
    },
    '山脉' : {
        monster : {
            ...terrainMonster('哥布林', 50),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('狼', 20),
            ...terrainMonster('狮鹫', 30),

            ...terrainMonster('剑齿虎', 50),
            ...terrainMonster('疾风猎鹰', 80),
            ...terrainMonster('蝎尾狮', 30),

            ...terrainMonster('迅猛龙', 80),
            ...terrainMonster('青牙兽', 50),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('大地熊', 80),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('鹰身女妖', 80),
            ...terrainMonster('飓风龙兽', 80),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),

            ...terrainMonster('山脉之神', 30),
            ...terrainMonster('五首龙神', 5),
        },
        elements : {
            ...terrainElement('草丛', [1,3], 4),
            ...terrainElement('草药丛', [-1,2], 3),
            ...terrainElement('浆果丛', [1,2], 3),
            ...terrainElement('石块', [2,5], 5),
            ...terrainElement('树木', [0,2], 3),
            ...terrainElement('铁矿石', [0,3], 3),
            ...terrainElement('铜矿石', [0,3], 3),
            ...terrainElement('金矿石', [-1,1], 1),
            ...terrainElement('魔晶矿脉', [0,1], 1),
        }
    },
    '洞穴' : {
        monster : {
            ...terrainMonster('史莱姆', 50),
            ...terrainMonster('哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('蜘蛛', 50),
            ...terrainMonster('巨鼠', 20),
            ...terrainMonster('巨蟒', 10),

            ...terrainMonster('哥布林战士', 80),
            ...terrainMonster('角蛇', 30),
            ...terrainMonster('地穴领主', 10),

            ...terrainMonster('幽灵蛛', 80),
            ...terrainMonster('死神蝎', 50),
            ...terrainMonster('重装哥布林', 70),
            ...terrainMonster('哥布林祭司', 70),
            ...terrainMonster('刺蛇', 20),
            ...terrainMonster('青牙兽', 20),
            ...terrainMonster('大地熊', 20),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),
        },
        elements : {
            ...terrainElement('草药丛', [-1,1], 2),
            ...terrainElement('石块', [2,5], 5),
            ...terrainElement('铁矿石', [1,3], 3),
            ...terrainElement('铜矿石', [1,3], 3),
            ...terrainElement('金矿石', [1,3], 3),
            ...terrainElement('魔晶矿脉', [1,3], 3),
        }
    },
    '沼泽' : {
        monster : {
            ...terrainMonster('巨蟒', 50),
            ...terrainMonster('史莱姆', 30),
            ...terrainMonster('哥布林', 20),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('蜘蛛', 50),
            ...terrainMonster('狼', 10),
            ...terrainMonster('食人鱼', 5),

            ...terrainMonster('刺蛇', 50),
            ...terrainMonster('幽灵蛛', 80),
            ...terrainMonster('厚皮蜥', 80),
            ...terrainMonster('黄酮蟒', 50),
            ...terrainMonster('五彩魔蛟', 5),

            ...terrainMonster('神选战士', 50),
            ...terrainMonster('神选游侠', 70),
            ...terrainMonster('女巫', 80),
            ...terrainMonster('骷髅剑士', 80),
            ...terrainMonster('巨魔骷髅', 80),
            ...terrainMonster('亡灵蠕虫', 80),
            ...terrainMonster('大剑士', 5),

            ...terrainMonster('怒焰亚龙', 80),
            ...terrainMonster('冰霜亚龙', 80),
            ...terrainMonster('毒液亚龙', 80),
            ...terrainMonster('黑暗亚龙', 80),
            ...terrainMonster('红龙', 10),
            ...terrainMonster('蓝龙', 10),
            ...terrainMonster('绿龙', 10),
            ...terrainMonster('黑龙', 10),
            ...terrainMonster('沙暴地龙', 5),
        },
        elements : {
            ...terrainElement('草丛', [1,2], 3),
            ...terrainElement('浆果丛', [0,1], 2),
            ...terrainElement('草药丛', [-1,1], 2),
            ...terrainElement('水源', [2,4], 5),
            ...terrainElement('鱼群', [0,1], 2),
            ...terrainElement('树木', [1,2], 3),
            ...terrainElement('芦苇从', [1,3], 5),
        }
    },
    '海滩' : {
        monster : {
            ...terrainMonster('食人鱼', 80),
            ...terrainMonster('鱼人', 30),
            ...terrainMonster('鳄龟', 70),
            ...terrainMonster('哥布林巨人', 5),

            ...terrainMonster('巨钳蟹', 90),
            ...terrainMonster('铁甲海龟', 90),
            ...terrainMonster('弄潮鱼人', 5),
            ...terrainMonster('独角海象', 10),

            ...terrainMonster('大史莱姆', 30),
            ...terrainMonster('疾风猎鹰', 60),
            ...terrainMonster('剑齿虎', 40),
        },
        elements : {
            ...terrainElement('水源', [3,5], 8),
            ...terrainElement('鱼群', [1,2], 3),
            ...terrainElement('沙坑', [1,3], 5),
        }
    },

    '溶洞' : {
        monster : {
            ...terrainMonster('大哥布林', 60),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 70),
            ...terrainMonster('蝙蝠', 80),
            ...terrainMonster('巨蝎', 20),
            ...terrainMonster('猩红蝾螈', 50),
        },
        elements : {
            ...terrainElement('水源', [1,3], 5),
            ...terrainElement('蘑菇群', [1,3], 5),
            ...terrainElement('微光蘑菇群', [1,2], 3),
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('扭曲树', [0,2], 3),
        }
    },
    '矿坑' : {
        monster : {
            ...terrainMonster('大哥布林', 20),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 30),
            ...terrainMonster('骷髅', 50),
            ...terrainMonster('食尸鬼', 50),
            ...terrainMonster('蝙蝠', 50),
            ...terrainMonster('巨蝎', 10),
            ...terrainMonster('黑矮人', 70),
        },
        elements : {
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('铁矿石', [1,3], 3),
            ...terrainElement('铜矿石', [1,3], 3),
            ...terrainElement('金矿石', [1,3], 3),
            ...terrainElement('魔晶矿脉', [1,3], 3),
        }
    },
    '暗河' : {
        monster : {
            ...terrainMonster('大哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 70),
            ...terrainMonster('食尸鬼', 30),
            ...terrainMonster('蝙蝠', 60),
            ...terrainMonster('巨蝎', 20),
            ...terrainMonster('食人鱼', 50),
            ...terrainMonster('黑矮人', 20),
            ...terrainMonster('猩红蝾螈', 80),
        },
        elements : {
            ...terrainElement('水源', [1,3], 5),
            ...terrainElement('鱼群', [0,2], 4),
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('扭曲树', [0,1], 2),
        }
    },
    '熔岩' : {
        monster : {
            ...terrainMonster('黑矮人', 20),
            ...terrainMonster('火蛇', 80),
            ...terrainMonster('火元素', 80),
        },
        elements : {
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('红晶矿', [1,3], 3),
            ...terrainElement('黑曜石矿', [3,5], 5),
        }
    },
    '苔洞' : {
        monster : {
            ...terrainMonster('大哥布林', 50),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 50),
            ...terrainMonster('蝙蝠', 10),
            ...terrainMonster('巨蝎', 40),
            ...terrainMonster('猩红蝾螈', 50),
        },
        elements : {
            ...terrainElement('水源', [1,3], 5),
            ...terrainElement('蘑菇群', [2,5], 8),
            ...terrainElement('微光蘑菇群', [1,3], 5),
            ...terrainElement('脆石壁', [1,2], 2),
            ...terrainElement('扭曲树', [0,2], 3),
        }
    },
    '通道' : {
        monster : {
            ...terrainMonster('大哥布林', 80),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 70),
            ...terrainMonster('食尸鬼', 20),
            ...terrainMonster('蝙蝠', 50),
            ...terrainMonster('巨蝎', 10),
            ...terrainMonster('黑矮人', 10),
            ...terrainMonster('猩红蝾螈', 20),
        },
        elements : {
            ...terrainElement('蘑菇群', [1,3], 5),
            ...terrainElement('微光蘑菇群', [0,1], 2),
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('扭曲树', [0,2], 3),
        }
    },
    '遗迹' : {
        monster : {
            ...terrainMonster('大哥布林', 70),
            ...terrainMonster('哥布林巨人', 5),
            ...terrainMonster('哥布林英雄', 3),
            ...terrainMonster('洞穴人', 40),
            ...terrainMonster('骷髅', 80),
            ...terrainMonster('食尸鬼', 80),
            ...terrainMonster('游荡者', 20),
        },
        elements : {
            ...terrainElement('蘑菇群', [1,3], 5),
            ...terrainElement('微光蘑菇群', [0,1], 2),
            ...terrainElement('脆石壁', [1,4], 4),
            ...terrainElement('扭曲树', [0,2], 3),
        }
    },


    '浅底' : {
        monster : {
            ...terrainMonster('硬鳞鱼人', 90),
            ...terrainMonster('巨钳蟹', 50),
            ...terrainMonster('披甲鱼人', 30),
            ...terrainMonster('蓝鳞海蛇', 70),
            ...terrainMonster('鱼人斥候', 70),
            ...terrainMonster('鱼人战士', 70),
            ...terrainMonster('鱼人法师', 70),
            ...terrainMonster('弄潮鱼人', 5),
        },
        elements : {
            ...terrainElement('水源', [2,4], 5),
            ...terrainElement('鱼群', [1,2], 3),
            ...terrainElement('沙坑', [1,2], 3),
            ...terrainElement('扇贝', [0,1], 2),
        }
    },
    '珊瑚' : {
        monster : {
            ...terrainMonster('巨钳蟹', 30),
            ...terrainMonster('毒刺海胆', 80),
            ...terrainMonster('铁甲海龟', 70),
            ...terrainMonster('蓝鳞海蛇', 90),
        },
        elements : {
            ...terrainElement('水源', [3,5], 7),
            ...terrainElement('鱼群', [1,2], 3),
            ...terrainElement('珊瑚群', [1,3], 5),
            ...terrainElement('扇贝', [1,2], 3),
        }
    },
    '礁石' : {
        monster : {
            ...terrainMonster('硬鳞鱼人', 80),
            ...terrainMonster('披甲鱼人', 30),
            ...terrainMonster('铁甲海龟', 60),
            ...terrainMonster('鱼人斥候', 90),
            ...terrainMonster('鱼人战士', 70),
            ...terrainMonster('鱼人法师', 70),
            ...terrainMonster('弄潮鱼人', 5),
            ...terrainMonster('哥布林英雄', 3),
        },
        elements : {
            ...terrainElement('石块', [1,3], 3),
            ...terrainElement('藤壶群', [1,2], 3),
        }
    },
    '旋涡' : {
        monster : {
            ...terrainMonster('巨钳蟹', 10),
            ...terrainMonster('毒刺海胆', 50),
            ...terrainMonster('铁甲海龟', 30),
            ...terrainMonster('蓝鳞海蛇', 60),
            ...terrainMonster('水元素', 90),
        },
        elements : {
            ...terrainElement('水源', [3,5], 7),
            ...terrainElement('鱼群', [2,3], 4),
            ...terrainElement('扇贝', [1,2], 3),
        }
    },
    '深水' : {
        monster : {
            ...terrainMonster('巨钳蟹', 30),
            ...terrainMonster('毒刺海胆', 90),
            ...terrainMonster('铁甲海龟', 50),
            ...terrainMonster('蓝鳞海蛇', 80),
            ...terrainMonster('水元素', 95),
        },
        elements : {
            ...terrainElement('水源', [3,5], 7),
            ...terrainElement('鱼群', [2,4], 5),
            ...terrainElement('珊瑚群', [0,1], 2),
            ...terrainElement('扇贝', [1,3], 4),
        }
    },
    '矿壁' : {
        monster : {
            ...terrainMonster('硬鳞鱼人', 60),
            ...terrainMonster('巨钳蟹', 50),
            ...terrainMonster('铁甲海龟', 50),
            ...terrainMonster('披甲鱼人', 50),
            ...terrainMonster('鱼人斥候', 80),
            ...terrainMonster('鱼人战士', 80),
            ...terrainMonster('鱼人法师', 80),
            ...terrainMonster('弄潮鱼人', 5),
            ...terrainMonster('哥布林英雄', 3),
        },
        elements : {
            ...terrainElement('水源', [3,5], 7),
            ...terrainElement('蓝晶矿', [1,3], 3),
        }
    },
    '滩涂' : {
        monster : {
            ...terrainMonster('硬鳞鱼人', 80),
            ...terrainMonster('巨钳蟹', 80),
            ...terrainMonster('铁甲海龟', 70),
            ...terrainMonster('披甲鱼人', 70),
            ...terrainMonster('鱼人斥候', 90),
            ...terrainMonster('鱼人战士', 90),
            ...terrainMonster('鱼人法师', 90),
            ...terrainMonster('弄潮鱼人', 5),
            ...terrainMonster('哥布林英雄', 3),
        },
        elements : {
            ...terrainElement('水源', [1,3], 4),
            ...terrainElement('沙坑', [1,3], 5),
            ...terrainElement('扇贝', [1,2], 4),
        }
    },


    '部落' : {
        monster : {
            ...terrainMonster('半兽人', 90),
            ...terrainMonster('强兽人', 50),
        },
        elements : {
            ...terrainElement('羊群', [1,3], 5),
            ...terrainElement('井', [1,2], 2),
            ...terrainElement('杂物堆', [0,2], 4),
        }
    },
    '废墟' : {
        monster : {
            ...terrainMonster('蝎尾狮', 80),
            ...terrainMonster('哥布林战士', 50),
            ...terrainMonster('角蛇', 10),
        },
        elements : {
            ...terrainElement('宝箱', [-3,1], 1),
            ...terrainElement('脆石壁', [1,3], 3),
        }
    },
    '晶林' : {
        monster : {
            ...terrainMonster('晶化幽灵', 80),
            ...terrainMonster('紫晶巨人', 20),
        },
        elements : {
            ...terrainElement('紫晶簇', [1,4], 4),
        }
    },


    '氏族' : {
        monster : {
            ...terrainMonster('氏族兽人', 80),
            ...terrainMonster('兽人酋长', 10),
        },
        elements : {
            ...terrainElement('羊群', [1,3], 5),
            ...terrainElement('井', [1,2], 2),
            ...terrainElement('杂物堆', [0,2], 4),
        }
    },
    '盆地' : {
        monster : {
            ...terrainMonster('刺蛇', 30),
            ...terrainMonster('幽灵蛛', 20),
            ...terrainMonster('死神蝎', 50),
            ...terrainMonster('迅猛龙', 70),
            ...terrainMonster('黄酮蟒', 80),
            ...terrainMonster('地牙野猪', 50),
            ...terrainMonster('五彩魔蛟', 5),
        },
        elements : {
            ...terrainElement('草丛', [1,2], 3),
            ...terrainElement('浆果丛', [0,1], 2),
            ...terrainElement('草药丛', [-1,1], 2),
            ...terrainElement('水源', [2,4], 5),
            ...terrainElement('树木', [1,2], 3),
        }
    },
    '兽穴' : {
        monster : {
            ...terrainMonster('迅猛龙', 30),
            ...terrainMonster('青牙兽', 80),
            ...terrainMonster('黄酮蟒', 50),
            ...terrainMonster('地牙野猪', 80),
            ...terrainMonster('大地熊', 80),
            ...terrainMonster('五彩魔蛟', 5),
        },
        elements : {
            ...terrainElement('草药丛', [-1,1], 2),
            ...terrainElement('石块', [2,5], 5),
            ...terrainElement('铁矿石', [1,3], 3),
            ...terrainElement('铜矿石', [1,3], 3),
            ...terrainElement('金矿石', [1,3], 3),
        }
    },



    '焦土' : {
        monster : {
            ...terrainMonster('骷髅战士', 80),
            ...terrainMonster('骷髅法师', 80),
            ...terrainMonster('活尸', 50),
            ...terrainMonster('死亡骑士', 3),
        },
        elements : {
            ...terrainElement('骨堆', [1,2], 3),
            ...terrainElement('尸体', [2,3], 4),
        }
    },
    '墓园' : {
        monster : {
            ...terrainMonster('骷髅战士', 80),
            ...terrainMonster('骷髅法师', 80),
            ...terrainMonster('活尸', 80),
            ...terrainMonster('幽魂', 50),
            ...terrainMonster('血肉屠夫', 30),
            ...terrainMonster('巫妖', 5),
            ...terrainMonster('憎恶', 5),
            ...terrainMonster('龙人活尸', 3),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 4),
            ...terrainElement('灵魂草丛', [1,2], 3),
            ...terrainElement('血肉魔树', [0,2], 3),
            ...terrainElement('骨堆', [1,2], 3),
            ...terrainElement('尸体', [2,3], 4),
            ...terrainElement('灵魂晶矿', [1,2], 3),
        }
    },
    '坟场' : {
        monster : {
            ...terrainMonster('骷髅战士', 50),
            ...terrainMonster('骷髅法师', 50),
            ...terrainMonster('尸巫', 80),
            ...terrainMonster('幽魂', 80),
            ...terrainMonster('血肉屠夫', 30),
            ...terrainMonster('巫妖', 5),
            ...terrainMonster('憎恶', 5),
            ...terrainMonster('龙人活尸', 3),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 4),
            ...terrainElement('灵魂草丛', [1,2], 3),
            ...terrainElement('血肉魔树', [0,2], 3),
            ...terrainElement('骨堆', [1,2], 3),
            ...terrainElement('尸体', [2,3], 4),
            ...terrainElement('灵魂晶矿', [1,2], 3),
        }
    },
    '肉林' : {
        monster : {
            ...terrainMonster('血肉亡灵', 80),
            ...terrainMonster('血肉屠夫', 80),
            ...terrainMonster('憎恶', 5),
        },
        elements : {
            ...terrainElement('活化血肉', [2,3], 5),
            ...terrainElement('血水', [1,3], 4),
            ...terrainElement('血肉魔树', [2,3], 4),
        }
    },
    '残骸' : {
        monster : {
            ...terrainMonster('幽魂', 50),
            ...terrainMonster('骷髅骑士', 80),
            ...terrainMonster('血肉屠夫', 50),
            ...terrainMonster('死亡骑士', 3),
        },
        elements : {
            ...terrainElement('灵魂草丛', [1,2], 3),
            ...terrainElement('血肉魔树', [0,1], 2),
            ...terrainElement('巨大骨架', [1,2], 3),
            ...terrainElement('大块血肉', [1,2], 3),
        }
    },
    '血池' : {
        monster : {
            ...terrainMonster('血魔', 80),
            ...terrainMonster('僵尸蟒', 80),
            ...terrainMonster('血肉屠夫', 30),
            ...terrainMonster('憎恶', 5),
        },
        elements : {
            ...terrainElement('灵魂草丛', [1,3], 4),
            ...terrainElement('血肉魔树', [1,2], 3),
            ...terrainElement('血水', [2,4], 5),
        }
    },
    '鬼堡' : {
        monster : {
            ...terrainMonster('吸血鬼', 80),
            ...terrainMonster('石像鬼', 80),
            ...terrainMonster('巫妖', 5),
        },
        elements : {
            ...terrainElement('灵魂草丛', [1,2], 3),
            ...terrainElement('烂家具', [2,3], 3),
        }
    },
    '骨山' : {
        monster : {
            ...terrainMonster('尸巫', 70),
            ...terrainMonster('骷髅骑士', 80),
            ...terrainMonster('怨灵', 80),
            ...terrainMonster('死亡骑士', 3),
            ...terrainMonster('巫妖', 5),
        },
        elements : {
            ...terrainElement('灵魂草丛', [1,2], 3),
            ...terrainElement('骨堆', [2,4], 5),
        }
    },


    '营地' : {
        monster : {
            ...terrainMonster('神选战士', 80),
            ...terrainMonster('神选法师', 80),
            ...terrainMonster('神选游侠', 80),
            ...terrainMonster('神选骑士', 80),
            ...terrainMonster('女巫', 80),
            ...terrainMonster('神选冠军骑士', 10),
            ...terrainMonster('大剑士', 5),
        },
        elements : {
            ...terrainElement('物资箱', [1,2], 2),
        }
    },
    '坑洞' : {
        monster : {
            ...terrainMonster('骷髅剑士', 50),
            ...terrainMonster('巨魔骷髅', 30),
            ...terrainMonster('亡灵蠕虫', 70),
            ...terrainMonster('鲜血巨魔', 80),
        },
        elements : {
            ...terrainElement('草丛', [2,3], 4),
            ...terrainElement('石块', [1,2], 2),
        }
    },


    '村庄' : {
        monster : {
            ...terrainMonster('苦修士', 80),
            ...terrainMonster('狂信徒', 80),
            ...terrainMonster('荣耀骑士', 80),
        },
        elements : {
            ...terrainElement('民宅', [3,5], 5),
            ...terrainElement('果树', [2,3], 5),
        }
    },
    '城镇' : {
        monster : {
            ...terrainMonster('狂信徒', 80),
            ...terrainMonster('荣耀骑士', 80),
            ...terrainMonster('大神官', 80),
            ...terrainMonster('神眷圣骑士', 10),
            ...terrainMonster('战争领主', 5),
        },
        elements : {
            ...terrainElement('房屋', [3,5], 5),
            ...terrainElement('豪宅', [2,3], 3),
            ...terrainElement('城主府', [1,1], 1),
        }
    },


    //副本地形
    '血战' : {
        monster : {
            ...terrainMonster('扭曲邪物', 100),
            ...terrainMonster('扭曲的憎恨', 100),
            ...terrainMonster('血肉幽灵船', 100),
            ...terrainMonster('扭曲晶魂', 100),
            ...terrainMonster('污浊山魄', 100),
            ...terrainMonster('无名肉山', 100),
            ...terrainMonster('死离人形', 100),
            ...terrainMonster('腐烂吸血鬼', 100),
            ...terrainMonster('深渊领主', 100),
        },
    },
    '花园' : {
        monster : {
            ...terrainMonster('神性史莱姆', 100),
            ...terrainMonster('远古残魂', 100),
            ...terrainMonster('鱼人祭司', 100),
            ...terrainMonster('魔晶巨人', 100),
            ...terrainMonster('赤土龙龟', 100),
            ...terrainMonster('荒芜亚龙', 100),
            ...terrainMonster('绿龙幼崽', 100),
            ...terrainMonster('青年黑龙', 100),
            ...terrainMonster('诅咒凶魂', 100),
            ...terrainMonster('幽灵龙', 100),
            ...terrainMonster('使徒行者', 100),
        },
    },
    '巢穴' : {
        monster : {
            ...terrainMonster('哥布林巨人', 100),
            ...terrainMonster('游荡者', 100),
            ...terrainMonster('弄潮鱼人', 100),
            ...terrainMonster('紫晶巨人', 100),
            ...terrainMonster('山岭巨人', 100),
            ...terrainMonster('五彩魔蛟', 100),
            ...terrainMonster('暴水獭', 100),
            ...terrainMonster('巫妖', 100),
            ...terrainMonster('憎恶', 100),
            ...terrainMonster('神选冠军骑士', 100),
            ...terrainMonster('战争领主', 100),
            ...terrainMonster('红龙', 100),
            ...terrainMonster('蓝龙', 100),
            ...terrainMonster('绿龙', 100),
            ...terrainMonster('黑龙', 100),
        },
    },
    '领地' : {
        monster : {
            ...terrainMonster('哥布林英雄', 100),
            ...terrainMonster('地穴领主', 100),
            ...terrainMonster('独角海象', 100),
            ...terrainMonster('兽人酋长', 100),
            ...terrainMonster('重瞳魔猿', 100),
            ...terrainMonster('死亡骑士', 100),
            ...terrainMonster('龙人活尸', 100),
            ...terrainMonster('大剑士', 100),
            ...terrainMonster('神眷圣骑士', 100),
            ...terrainMonster('沙暴地龙', 100),
        },
    },
    '晶脉' : {
        monster : {
            ...terrainMonster('碎裂的宝石巨人', 100),
            ...terrainMonster('裂开的宝石巨人', 100),
            ...terrainMonster('完整的宝石巨人', 100),
            ...terrainMonster('无瑕的宝石巨人', 100),
            ...terrainMonster('完美的宝石巨人', 100),
            ...terrainMonster('璀璨的宝石巨人', 100),
        },
    },
    '果冻' : {
        monster : {
            ...terrainMonster('史莱姆', 100),
            ...terrainMonster('大史莱姆', 100),
            ...terrainMonster('强酸史莱姆', 100),
        },
    },
};

//追加新地图关联内容
Object.keys(newMapElements.terrainElements).forEach(e => {
    if(terrainElements[e]){
        for(const key in newMapElements.terrainElements[e].monster){
            newMapElements.terrainElements[e].monster = {
                ...newMapElements.terrainElements[e].monster,
                ...terrainMonster(key, newMapElements.terrainElements[e].monster[key])
            }
        }
        terrainElements[e].monster = {...terrainElements[e].monster,...newMapElements.terrainElements[e].monster};
        terrainElements[e].elements = {...terrainElements[e].elements,...newMapElements.terrainElements[e].elements};
    }else{
        terrainElements[e] = {
            elements : newMapElements.terrainElements[e].elements,
            monster : {}
        }
        for(const key in newMapElements.terrainElements[e].monster){
            terrainElements[e].monster = {
                ...terrainElements[e].monster,
                ...terrainMonster(key, newMapElements.terrainElements[e].monster[key])
            }
        }
    }
})

//活动资源
loadFestivalTerrainElements();

//坐骑列表
const mountList = Object.keys(elementCfgs).filter(e => elementCfgs[e].isMount).map(e => e.replace('坐骑：',''));

//龙蛋列表
const dungeonEggs = Object.keys(elementCfgs).filter(e => e.endsWith('龙蛋'));
