//赞助商列表
let countPoint = 0;
//const wsIp = 'localhost';
const wsIp = '116.204.123.41';
let ws = null;

//获取用户CODE，全难度唯一
function getCode(){
    let code = localStorage.getItem('idCode');
    if(!code){
        if(conf.code){
            if(conf.code.length === 8){
                code = conf.code;
            }else{
                code = S4() + S4();
                alert('检测到您的ID异常，可能是1.87版本的BUG导致的，已重新生成ID');
            }
        }else{
            code = S4() + S4();
        }
        localStorage.setItem('idCode', code);
    }

    if(conf.code !== code){
        conf.code = code;
        save(confSavedName, conf);
    }
    return code;
}

//获取用户名称，全难度唯一
function getName(){
    const userInfo = localStorage.getItem('userInfo');
    return userInfo ? JSON.parse(userInfo).userName : '你';
}

//链接WebSocket
/*function linkWs(){
    try{
        if(!$('.chat-room').is(':hidden')){
            $('#chatroom').removeClass('has-new');
        }
        if(!ws){
            systemMsg("聊天室功能已废弃，官方Q群5群：697251775，6群：275659772");
            ws = new WebSocket(`ws:${wsIp}:9013/chatroom/websocket`);

            $('#chat-room-name').val(getName());

            //连接成功时调用
            ws.onopen = function(evt){
                setTimeout(() => {
                    systemMsg("成功连接到聊天室，官方Q群5群：697251775（要满了），6群：275659772（新群，但是已经有一些大佬入驻等待萌新入群）");
                    systemMsg("不想看聊天室的可以在系统中关闭。本游戏完全用爱发电，也不可能有精力去弄太多限制过滤之类的，请大家在聊天室保持文明守序，不要刷屏和发敏感信息，否则只能关闭聊天室了");
                    systemMsg("如果遇到卡关的情况，请看tap论坛攻略区加精的的寒影全图通关攻略，寒影都能通关的打法，其他任何种族都可以参照着通关");
                }, 500)
            };

            //接收到服务器的消息时调用
            ws.onmessage = function(evt){
                try{
                    const data = JSON.parse(evt.data);
                    if(data.isOldList){
                        JSON.parse(data.list).forEach(e => {
                            appendChatRoomMsg(e.msg, e.name, e.code, e.time, e.info);
                        })
                    }else{
                        appendChatRoomMsg(data.msg, data.name, data.code, data.time, data.info);
                    }
                    $('.online-num').html('(在线人数：' + data.count + ')');
                    if($('.chat-room').is(':hidden')){
                        $('#chatroom').addClass('has-new');
                    }
                }catch(e){}
            };

            //连接关闭时调用
            ws.onclose = function(evt){
                ws = null;
                systemMsg("聊天室连接已断开");
            };

            window.sendMsg = function(msg){
                appendChatRoomMsg(msg, getName(), getCode(), new Date().format('yyyy-MM-dd hh:mm:ss'), getRoleInfo());
                ws.send(JSON.stringify({name : getName(), code :getCode(), msg, info : getRoleInfo()}));
            }
        }

    }catch (e) {
        systemMsg('聊天室链接错误')
    }
}*/

//获取当前角色信息
function getRoleInfo(){
    const dlcs = [];
    if(data.dlcMonsterEquip){dlcs.push('怪物武装')}
    if(data.dlcMonsterItem){dlcs.push('怪物物品')}
    if(data.dlcFateMonth){dlcs.push('命运之月')}
    if(data.dlcWorldEnd){dlcs.push('世界末日')}
    if(data.dlcLastMagic){dlcs.push('末法时代')}
    if(data.dlcOriginal){dlcs.push('原初体验')}
    if(data.dlcDragonKnight){dlcs.push('龙骑士')}
    return `${diff}&nbsp;&nbsp;${data.order || 1}周目${data.level}级${data.race.name}${dlcs.length > 0 ? `&nbsp;&nbsp;DLC：${dlcs.join('+')}` : ''}`;
}

function sendMsg(msg){}

/*//打开聊天室
$('#chatroom').click(function(){
    $('.chat-room').show();
    linkWs();
});*/

//改名
function changeChatRoomName(){
    const val = $('#chat-room-name').val();
    if(val != null && val !== ''){
        if(val.length > 8){
            alert('名字不能超过8个字符')
            return;
        }
        localStorage.setItem('idName', val);
        alert('改名成功')
    }else{
        alert('名字不合规则')
        $('#chat-room-name').val(getName());
    }
}

//系统消息
function systemMsg(text){
    appendChatRoomMsg(text, '系统消息', '00000000');
}

//追加聊天室消息
function appendChatRoomMsg(text, name = getName(), code = getCode(), time = new Date().format('yyyy-MM-dd hh:mm:ss'), info){
    $('.chat-room-body').prepend(`<div class="chat-room-msg"><div class="chat-room-msg-title"><span class="chat-room-msg-name">${name}[${code}]</span><span class="chat-room-msg-time">${time}</span></div>${info ? `<div class="chat-room-msg-info">${$(`<span>${info}</span>`).text()}</div>` : ''}<div class="chat-room-msg-context">${$(`<span>${text}</span>`).text()}</div></div>`);
}

//监听回车
$('#chat-room-text').bind('keydown',function(event){
    if(event.keyCode == "13") {
        sendChatRoomMsg();
    }
});

//发消息
function sendChatRoomMsg(){
    const val = $('#chat-room-text').val();
    if(val != null && val !== ''){
        if(val.length > 200){
            alert('一次不能发送超过200个字符')
            return;
        }
        $('#chat-room-text').val('');
        sendMsg(val);
        while ($('.chat-room-body .chat-room-msg').length > 100){
            $('.chat-room-body .chat-room-msg').last().remove();
        }
    }
}

function initSponsor() {
    const userInfo = localStorage.getItem('userInfo');
    let key = getCode();
    if(userInfo){
        key = JSON.parse(userInfo).account;
    }
    $.get(`http://${wsIp}:9014/sponsor/buSponsor/querySponsor`, {key}, resp => {
        if (resp.success && resp.data) {
            countPoint = parseInt((resp.data.gold ? resp.data.gold * 10 : 0) + (resp.data.extraPoint || 0));
            renderSponsorShop()
        }
    }, 'json');
}

//初始化公告
function initAnno() {
    $.get(`http://${wsIp}:9014/sponsor/buAnno`, {
        p_order_ : 'updateDate',
        p_orderFlag_ : 'DESC',
        limit : 5,
    }, resp => {
        if (resp.success && resp.data && resp.data.rows) {
            window.annos = resp.data.rows || [];

            if(window.annos.length > 0) {
                let annoDate = new Date(window.annos[0].updateDate).format('yyyy-MM-dd hh:mm:ss');
                if(conf.updateCode !== annoDate){
                    conf.updateCode = annoDate;
                    save(confSavedName, conf);
                    renderAnnos();
                }
            }
        }
    }, 'json');
}

//渲染公告
function renderAnnos(){
    window.annos = window.annos || [];
    $('.common-win').show().find('.win-body').html(`<h1 style="text-align: center">公告</h1>${window.annos.map(e => `<p style="padding: 0 10px"><h4>${new Date(e.updateDate).format('yyyy-MM-dd')}</h4>${e.annoText}</p>`).join('')}`)
}

//复制账号
function copyContent(value = window.userInfo.account, type = 'input') {
    const input = document.createElement(type);
    input.setAttribute('readonly', 'readonly'); // 设置为只读, 防止在 ios 下拉起键盘
    // input.setAttribute('value', value); // textarea 不能用此方式赋值, 否则无法复制内容
    input.value = value;
    document.body.appendChild(input);
    input.setSelectionRange(0, 9999); // 防止 ios 下没有全选内容而无法复制
    input.select();
    document.execCommand('copy');
    document.body.removeChild(input);
    winMsg('账号已复制', false, false)
}

//渲染爱发电弹窗
function renderLoginWin(){
    $('.login-win').hide();
    $('.aifadian-win').hide();
    const userInfo = localStorage.getItem('userInfo');
    if(userInfo){
        window.userInfo = JSON.parse(userInfo);
        $('.user-info-account').html(window.userInfo.account);
        $('.user-info-name').html(window.userInfo.userName);
        $('.aifadian-win').show();
    }else{
        $('.login-win').show();
    }
}

//前往爱发电
function goAifadian(){
    if(confirm(`前往爱发电后无法后退，必须关掉重启才能回到游戏页面，是否确认前往？`)){
        window.location.href = 'https://afdian.net/a/shihunshu'
    }
}

//表单校验
function check(type = 'login'){
    const account = $('.login-win input[name=account]').val();
    const pws = $('.login-win input[name=pws]').val();
    const userName = $('.login-win input[name=userName]').val();
    let reg = /^[a-zA-Z0-9_@]+$/;

    if(!account || !pws || (type === 'login' ? false : !userName)){
        alert(`请输入账号、密码和用户名`);
        return;
    }
    if(account.length < 4 || account.length > 20 || pws.length < 4 || pws.length > 20){
        alert(`账号和密码至少需要输入4个字符，最多20个字符`);
        return;
    }
    if(!reg.test(account) || !reg.test(pws)){
        alert(`账号和密码只能输入英文字母、数字以及_和@`);
        return;
    }

    if(userName){
        reg = /^[a-zA-Z0-9\u4e00-\u9fa5]+$/;
        if(userName.length > 8){
            alert(`名称最多只能输入8个字符`);
            return;
        }
        if(!reg.test(userName)){
            alert(`名称只能输入英文字母、数字和汉字`);
            return;
        }
    }

    return true;
}

//登录
function login(){
    const account = $('.login-win input[name=account]').val();
    const pws = $('.login-win input[name=pws]').val();
    const userName = $('.login-win input[name=userName]').val();
    if(check()){
        $.get(`http://${wsIp}:9014/sponsor/buUser/login`, {
            account,
            pws,
            userName
        }, resp => {
            if(resp.success){
                localStorage.setItem('userInfo', JSON.stringify({
                    account,
                    userName : resp.data.userName
                }))
                renderLoginWin();
            }else{
                $('.alert-win').show().find('.alert-win-title').html(resp.data);
            }
        }, 'json')
    }
}

//注册
function register(){
    const account = $('.login-win input[name=account]').val();
    const pws = $('.login-win input[name=pws]').val();
    const userName = $('.login-win input[name=userName]').val();
    if(check('register')){
        $.ajax({
            type: "POST",
            url: `http://${wsIp}:9014/sponsor/buUser/register`,
            dataType: "json",
            data: {
                account,
                pws,
                userName,
                remark : getCode()
            },
            success: resp => {
                if(resp.success){
                    localStorage.setItem('userInfo', JSON.stringify({
                        account,
                        userName
                    }))
                    renderLoginWin();
                    $('.alert-win').show().find('.alert-win-title').html(`注册成功`);
                }else{
                    $('.alert-win').show().find('.alert-win-title').html(resp.data);
                }
            }
        });
    }
}

//注销登录
function logout(){
    if(confirm(`是否确认要退出登录？`)){
        localStorage.removeItem('userInfo')
        window.userInfo = null;
        renderLoginWin();
    }
}
