//怪物列表
const map3ShandiMonsters = {
    '土狼' : {
        tags : ['野兽'],
        atkTime : '日',
        atkProb : 5,
        level : 21,
        hp : 450,
        atk : 50,
        def : 5,
        exp : 100,
        atkSpd : 3,
        type : null,
        items : [{name : '肉',minNum : 1, maxNum : 3},{name : '硬狼皮',minNum : 1, maxNum : 2}, {name : '石化尖牙',minNum : 1, maxNum : 2}, {name : '石化利爪',minNum : 1, maxNum : 2}],
    },
    '穿山兽' : {
        tags : ['野兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 22,
        hp : 350,
        atk : 40,
        def : 30,
        exp : 150,
        atkSpd : 3,
        type : null,
        items : [{name : '石化鳞片',minNum : 2, maxNum : 4}, {name : '石化尖牙',minNum : 1, maxNum : 2}, {name : '石化利爪',minNum : 1, maxNum : 2}],
    },
    '森蚺' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 23,
        hp : 500,
        atk : 45,
        def : 25,
        exp : 300,
        atkSpd : 4,
        type : null,
        items : [{name : '蛇胆',minNum : 1, maxNum : 1}, {name : '石化鳞片',minNum : 1, maxNum : 3}, {name : '大蛇牙',minNum : 1, maxNum : 2}, {name : '肉',minNum : 2, maxNum : 3}],
    },
    '岩雀' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 24,
        hp : 550,
        atk : 50,
        def : 20,
        exp : 400,
        atkSpd : 3,
        type : null,
        items : [{name : '石化羽毛',minNum : 1, maxNum : 3}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 1, maxNum : 2}, {name : '石化喙',minNum : 0, maxNum : 1}, {name : '石化利爪',minNum : 1, maxNum : 2}],
    },
    '石猴' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 25,
        hp : 600,
        atk : 55,
        def : 20,
        exp : 450,
        atkSpd : 3,
        type : null,
        items : [{name : '石化毛皮',minNum : 1, maxNum : 1}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 3}, {name : '石化尖牙',minNum : 1, maxNum : 3}],
    },
    '地钉仓鼠' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 26,
        hp : 500,
        atk : 50,
        def : 10,
        exp : 500,
        atkSpd : 3,
        type : null,
        items : [{name : '石化颊囊',minNum : 1, maxNum : 2}, {name : '魔兽肉',minNum : 0, maxNum : 1}, {name : '魔核',minNum : 1, maxNum : 1}],
    },
    '圆角山羊' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 27,
        hp : 600,
        atk : 60,
        def : 30,
        exp : 600,
        atkSpd : 3,
        type : null,
        items : [{name : '圆角',minNum : 1, maxNum : 2}, {name : '石化毛皮',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '魔核',minNum : 1, maxNum : 1}],
    },
    '厚土毒蝎' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 28,
        hp : 500,
        atk : 90,
        def : 30,
        exp : 700,
        atkSpd : 2,
        type : null,
        items : [{name : '石化甲壳',minNum : 1, maxNum : 1}, {name : '石化钳子',minNum : 1, maxNum : 2}, {name : '土毒蝎尾',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 1, maxNum : 2}, {name : '魔核',minNum : 1, maxNum : 1}]
    },
    '石甲巨鹰' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 29,
        hp : 700,
        atk : 70,
        def : 40,
        exp : 800,
        atkSpd : 3,
        type : null,
        items : [{name : '石化大羽',minNum : 1, maxNum : 3}, {name : '石化巨爪',minNum : 1, maxNum : 2}, {name : '石化大喙',minNum : 1, maxNum : 1}, {name : '石化皮肤',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 1, maxNum : 2}, {name : '魔核',minNum : 1, maxNum : 1}],
    },
    '壮硕石元素' : {
        tags : ['元素生物'],
        atkTime : '日',
        atkProb : 5,
        level : 30,
        hp : 1000,
        atk : 70,
        def : 50,
        exp : 1000,
        atkSpd : 2,
        type : null,
        items : [{name : '石之核',minNum : 1, maxNum : 1}, {name : '元素碎石',minNum : 2, maxNum : 5}],
    },
    '山岭巨人' : {
        tags : ['人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 3000,
        atk : 90,
        def : 50,
        exp : 2500,
        atkSpd : 1,
        type : '精英',
        items : [{name : '山岭之心',minNum : 1, maxNum : 1}, {name : '石巨人之眼',minNum : 1, maxNum : 2}, {name : '魔力之源',minNum : 1, maxNum : 1}],
    },
    '重瞳魔猿' : {
        tags : ['魔兽','人型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 30,
        hp : 8000,
        atk : 120,
        def : 45,
        exp : 4000,
        atkSpd : 4,
        type : '传说',
        items : [{name : '魔力毛皮',minNum :1, maxNum : 1}, {name : '石化重瞳',minNum : 1, maxNum : 2},{name : '石化猿脑',minNum : 1, maxNum : 1}],
    },
    '赤土龙龟' : {
        tags : ['魔兽', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 15000,
        atk : 120,
        def : 80,
        exp : 6000,
        atkSpd : 1,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：石甲术',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 1, maxNum : 3},{name : '龙龟碎壳',minNum : 2, maxNum : 5},{name : '赤土之源',minNum : 1, maxNum : 1}],
    },
    '污浊山魄' : {
        tags : ['不死族', '幽灵', '污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 11000,
        atk : 155,
        def : 40,
        exp : 6500,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 200, maxNum : 1},{name : '变异核心',minNum : 200, maxNum : 200}],
    },
    '土元素领主' : {
        tags : ['元素生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 30000,
        atk : 90,
        def : 40,
        exp : 25000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '30级武器打孔石',minNum : 1, maxNum : 3},{name : '30级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：4点',minNum : 1, maxNum : 1}],
    },
};

//地图信息
const map3Shandi = {
    index : 2,
    name : '山地',
    level : [21,30],
    worldBoss : '重瞳魔猿',
    mythMonster : ['赤土龙龟','污浊山魄'],
    finalBoss : '土元素领主',

    //配置
    confs : {
        //地形列表
        terrainArray : [
            '溪流','地脉','悬崖','孤峰','山脊','海崖',//新地形
            '峡谷','盆地','兽穴',//本就有但是和原本的同等级地图无重叠的地形
        ],
        //地形可以和哪些其他地形相邻
        terrainJoinTerrain : {
            '溪流' : ['溪流','地脉','悬崖','孤峰','山脊','海崖','峡谷','盆地','兽穴'],
            '地脉' : ['溪流','地脉','悬崖','孤峰','山脊','海崖','峡谷','盆地','兽穴'],
            '悬崖' : ['溪流','地脉','悬崖','孤峰','山脊','海崖','峡谷','盆地','兽穴'],
            '孤峰' : ['溪流','地脉','悬崖','孤峰','山脊','海崖','峡谷','盆地','兽穴'],
            '山脊' : ['溪流','地脉','悬崖','孤峰','山脊','海崖','峡谷','盆地','兽穴'],
        },
        //地形可以和哪些其他地形相邻，这里面的配置会追加到当前已有的地形中
        terrainJoinTerrainAppend : {
            '峡谷' : ['溪流','地脉','悬崖','孤峰','山脊','海崖'],
            '盆地' : ['溪流','地脉','悬崖','孤峰','山脊','海崖'],
            '兽穴' : ['溪流','地脉','悬崖','孤峰','山脊','海崖'],
        },
        //每个地形对应的颜色
        terrainColor : {
            '溪流' : '#89ccdb',
            '地脉' : '#795548',
            '悬崖' : '#a90000',
            '孤峰' : '#9e9e9e',
            '山脊' : '#cb6904',
            '海崖' : '#0037ff',
        },
        //采集元素
        elements : {
            //地图上生成的可采集资源
            '黄晶矿' : new Element({canGather :true, mopUp : true, time : 10, num : 3, needItem : ['铁镐','光荣镐'], getItem : [{name : '黄水晶',minNum : 1, maxNum : 2},{name : '魔力水晶',minNum : 0, maxNum : 1}]}),
            '红色藤蔓' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 3,getItem : [{name : '石血藤',minNum : 1, maxNum : 2}]}),
            '岩缝' : new Element({canGather :true, mopUp : true, time : 30, num : 1, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '石头',minNum : 1, maxNum : 2},{name : '大地之心',minNum : 3, maxNum : 1}]}),
            '石冉树' : new Element({canGather :true, mopUp : true, time : 20, num : 10, day : 5, needItem : ['铁斧','光荣斧'], getItem : [{name : '石冉木',minNum : 0, maxNum : 1}]}),

            //本地图的元素，例如：药剂，药膏，背包，盾牌，装备，坐骑，投掷品，弓胚
            '黄水晶' : new Element({voidDust : 10, gold : 50, elemental : {土 : 5}}),
            '石血藤' : new Element({canUse : true, hp : 3, voidDust : 6, gold : 30, elemental : {木 : 1}}),
            '大地之心' : new Element({battleUse : true, voidDust : 1000, gold : 5000, func(){
                    if(!getStatuNum(data, '大地之心')){
                        data.def += 50;
                    }
                    addStatus(data, getStatus('大地之心'))
                    return true;
                },
                text : '使用后获得大地之心状态，防御力增加50，持续5回合，多次使用可叠加持续回合数'}),
            '石冉木' : new Element({voidDust : 20, gold : 100, elemental : {土 : 4, 木 : 3}}),

            '石化炸弹' : new Element({isThrow : true, atk : 300, weight : 10, endurance : 1, voidDust : 200, gold : 1000, throwFunc(){
                    if(randomNum(1,100) <= 30){
                        addStatus(data.battleMonster, getStatus('石化'))
                    }
                }, text : '30%概率使怪物石化1回合'}),
        },
        //怪物列表
        monsters : map3ShandiMonsters,
        //怪物掉落物品
        monsterItems : {
            '硬狼皮' : new Element({fromMonster : true, voidDust : 25, gold : 75, elemental : {木 : 4, 土 : 6}}),
            '石化尖牙' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {土 : 8}}),
            '石化鳞片' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 4, 土 : 6}}),
            '石化利爪' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 7, 土 : 4}}),
            '大蛇牙' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 7, 木 : 4}}),
            '石化羽毛' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {木 : 3, 土 : 4}}),
            '石化喙' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {金 : 4, 土 : 5}}),
            '石化毛皮' : new Element({fromMonster : true, voidDust : 60, gold : 300, elemental : {木 : 7, 土 : 2}}),
            '石化颊囊' : new Element({fromMonster : true, voidDust : 60, gold : 300, elemental : {木 : 6, 土 : 2}}),
            '圆角' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 5, 土 : 3}}),
            '石化甲壳' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 6, 土 : 4}}),
            '石化钳子' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 3, 土 : 5}}),
            '土毒蝎尾' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {木 : 3, 水 : 8}}),
            '石化大羽' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 4, 土 : 5}}),
            '石化皮肤' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 7, 土 : 4}}),
            '石化巨爪' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {土 : 7, 金 : 3}}),
            '石化大喙' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 2, 金 : 5}}),
            '石之核' : new Element({fromMonster : true, voidDust : 80, gold : 400, elemental : {土 : 10}}),
            '元素碎石' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {土 : 5}}),
            '山岭之心' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 3, 金 : 2}}),
            '石巨人之眼' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 3, 金 : 2}}),
            '魔力之源' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {极 : 8}}),
            '魔力毛皮' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 10, 极 : 1}}),
            '石化重瞳' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 8, 土 : 5, 极 : 1}}),
            '石化猿脑' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {极 : 10}}),
            '龙龟碎壳' : new Element({fromMonster : true, voidDust : 500, gold : 2500, elemental : {金 : 5, 极 : 2}}),
            '赤土之源' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {土 : 20, 极 : 2}}),
            '技能石：石甲术' : new Element({
                battleUse : true,
                voidDust : 20,
                quality : 1,
                gold : 50,
                func : function(){
                    if(data.battleMonster.sjs){
                        winMsg('每场战斗只能使用一次',false,false)
                        return false;
                    }

                    data.battleMonster.sjs = true;
                    data.def += parseInt(data.def * 0.3);
                    data.atkSpd -= 1;
                    const text = `使用了石甲术，防御力增加30%，攻速-1`;
                    addBattleLog(text)
                    return true;
                },
                text : '防御力增加30%，攻速-1，每场战斗只能使用一次'
            }),
        },
        //怪物技能
        monsterSkill : {
            地钉仓鼠 : [{
                name : '地刺',
                type : 'start',
                text : '进入战斗时触发，给自己附加地刺状态，受到玩家攻击时，给玩家造成怪物自身50%攻击力的伤害，该状态不会自动消失。',
                check : function(){return false},
                use : function(){
                    addStatus(data.battleMonster, getStatus('地刺', {returnHarm : parseInt(data.battleMonster.atk * 0.5)}))
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被附加了地刺状态。`);
                },
            }],
            山岭巨人 : [{
                name : '山岭重拳',
                atr : 50,
                type : 'atk',
                text : '30%概率使用，使用时命中率为50%，命中即造成3.5倍攻击力的伤害。无论是否命中，都会给自身附加僵直状态，无法行动，持续1回合。',//技能说明
                getStatus : function(){
                    addStatus(data.battleMonster, getStatus('僵直'))
                    return null
                },
                check : function(){return randomNum() <= 30},
                getNum : function(){return data.battleMonster.atk * 3.5},
            }],
            重瞳魔猿 : [{
                name : '重拳',
                extend : '横扫'
            }],
            赤土龙龟 : [{
                name : '龟缩',
                type : 'berserk',
                text : '生命值低于50%，且身上没有龟缩状态时，有百分之10%几率使用，缩入龟壳中，获得龟缩状态，无法行动，防御力增加100，每回合恢复2%生命值。龟缩状态不会随回合结束而减少层数，当生命值高于80%时自动取消龟缩状态',
                check : function(){
                    if(data.battleMonster.hp < (data.battleMonster.maxHp * 0.5) && !hasStatus(data.battleMonster, '龟缩')){
                        return randomNum(1,100) <= 10
                    }
                    return false;
                },
                use : function(){
                    data.battleMonster.def += 100;
                    addStatus(data.battleMonster, getStatus('龟缩', {addHp : parseInt(data.battleMonster.maxHp * 0.02)}))
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了龟缩，缩入了龟壳中`)
                },
            }],
            污浊山魄 : ['腐蚀'],
            土元素领主 : [{
                name : '硬化',
                type : 'berserk',
                text : '20%概率使用，在当前属性的基础上提高10%攻击力和20%防御力，最少提高10点。',
                check : function(){return randomNum() <= 20},
                use : function(){
                    worldBossAddAttr(0.1, 0.2);
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了硬化，提高了10%攻击力和20%防御力`)
                },
            },'世界之力'],
        },
        //地形下的怪物和资源，如果是已有的地形，则会在原本的基础上追加，否则会新建，要注意得有上个地图的守关BOSS
        terrainElements : {
            '溪流' : {
                monster : {
                    土狼 : 80,
                    穿山兽 : 70,
                    森蚺 : 90,
                    石猴 : 50,
                    地钉仓鼠 : 30,
                    圆角山羊 : 10,
                    石甲巨鹰 : 20,
                },
                elements : {
                    ...terrainElement('水源', [1,3], 5),
                    ...terrainElement('鱼群', [1,2], 3),
                    ...terrainElement('草丛', [1,2], 3),
                    ...terrainElement('树木', [1,2], 3),
                    ...terrainElement('浆果丛', [0,2], 3),
                    ...terrainElement('石块', [0,1], 1),
                    ...terrainElement('石冉树', [1,2], 4),
                },
            },
            '地脉' : {
                monster : {
                    穿山兽 : 50,
                    地钉仓鼠 : 90,
                    厚土毒蝎 : 90,
                    壮硕石元素 : 80,
                },
                elements : {
                    ...terrainElement('石块', [0,1], 1),
                    ...terrainElement('铁矿石', [0,2], 2),
                    ...terrainElement('铜矿石', [0,2], 2),
                    ...terrainElement('金矿石', [0,2], 2),
                    ...terrainElement('魔晶矿脉', [2,4], 1),
                    ...terrainElement('黄晶矿', [1,3], 3),
                    ...terrainElement('岩缝', [1,3], 3),
                },
            },
            '悬崖' : {
                monster : {
                    岩雀 : 80,
                    森蚺 : 50,
                    石甲巨鹰 : 70,
                    山岭巨人 : 5,
                },
                elements : {
                    ...terrainElement('草丛', [0,1], 2),
                    ...terrainElement('树木', [0,1], 2),
                    ...terrainElement('石块', [1,2], 2),
                    ...terrainElement('岩缝', [0,2], 2),
                    ...terrainElement('红色藤蔓', [1,3], 5),
                    ...terrainElement('石冉树', [1,3], 4),
                },
            },
            '孤峰' : {
                monster : {
                    穿山兽 : 80,
                    圆角山羊 : 90,
                    石甲巨鹰 : 80,
                    山岭巨人 : 5,
                },
                elements : {
                    ...terrainElement('草丛', [1,3], 4),
                    ...terrainElement('树木', [1,2], 3),
                    ...terrainElement('浆果丛', [1,2], 3),
                    ...terrainElement('石块', [0,2], 2),
                    ...terrainElement('岩缝', [0,1], 1),
                    ...terrainElement('黄晶矿', [-1,2], 2),
                    ...terrainElement('红色藤蔓', [0,1], 2),
                    ...terrainElement('石冉树', [2,3], 5),
                },
            },
            '山脊' : {
                monster : {
                    穿山兽 : 60,
                    圆角山羊 : 70,
                    厚土毒蝎 : 50,
                    岩雀 : 70,
                    石甲巨鹰 : 90,
                    壮硕石元素 : 30,
                    山岭巨人 : 5,
                },
                elements : {
                    ...terrainElement('草丛', [1,2], 3),
                    ...terrainElement('石块', [0,1], 1),
                    ...terrainElement('岩缝', [0,1], 1),
                    ...terrainElement('石冉树', [0,1], 2),
                },
            },
            '海崖' : {
                monster : {
                    石猴 : 30,
                    岩雀 : 90,
                    石甲巨鹰 : 80,
                    独角海象 : 10,
                },
                elements : {
                    ...terrainElement('草丛', [0,2], 3),
                    ...terrainElement('石块', [0,2], 2),
                    ...terrainElement('红色藤蔓', [1,2], 3),
                },
            },
            '峡谷' : {
                monster : {
                    土狼 : 70,
                    穿山兽 : 90,
                    石猴 : 80,
                    地钉仓鼠 : 30,
                    厚土毒蝎 : 60,
                    壮硕石元素 : 10,
                },
                elements : {
                    ...terrainElement('红色藤蔓', [0,1], 2),
                },
            },
            '盆地' : {
                monster : {
                    土狼 : 80,
                    森蚺 : 90,
                    石猴 : 90,
                    厚土毒蝎 : 80,
                },
                elements : {
                    ...terrainElement('石冉树', [1,2], 3),
                    ...terrainElement('红色藤蔓', [2,3], 5),
                },
            },
            '兽穴' : {
                monster : {
                    土狼 : 90,
                    穿山兽 : 80,
                    森蚺 : 90,
                    石猴 : 70,
                    地穴领主 : 10,
                },
                elements : {
                    ...terrainElement('红色藤蔓', [0,1], 2),
                },
            },
        },
        //神殿配置
        deity : {
            水之女神 : {
                hates : [
                    {name : '土狼', num : 10, godFavor : 30, belief : 30},
                    {name : '森蚺', num : 10, godFavor : 30, belief : 30},
                    {name : '厚土毒蝎', num : 10, godFavor : 40, belief : 40},
                ],
                likes : [
                    {name : '石之核', num : 10, godFavor : 40, belief : 40},
                    {name : '石巨人之眼', num : 3, godFavor : 50, belief : 50},
                    {name : '魔力毛皮', num : 1, godFavor : 50, belief : 50},
                ],
            },
            狩猎之神 : {
                hates : [
                    {name : '土狼', num : 10, godFavor : 30, belief : 30},
                    {name : '穿山兽', num : 10, godFavor : 30, belief : 30},
                    {name : '森蚺', num : 10, godFavor : 30, belief : 30},
                    {name : '岩雀', num : 10, godFavor : 30, belief : 30},
                    {name : '石猴', num : 10, godFavor : 30, belief : 30},
                    {name : '地钉仓鼠', num : 10, godFavor : 40, belief : 40},
                    {name : '圆角山羊', num : 10, godFavor : 40, belief : 40},
                    {name : '厚土毒蝎', num : 10, godFavor : 40, belief : 40},
                    {name : '赤土龙龟', num : 1, godFavor : 60, belief : 60},
                ],
                likes : [
                    {name : '硬狼皮', num : 10, godFavor : 30, belief : 30},
                    {name : '石化尖牙', num : 10, godFavor : 30, belief : 30},
                    {name : '石化鳞片', num : 10, godFavor : 30, belief : 30},
                    {name : '石化利爪', num : 10, godFavor : 30, belief : 30},
                    {name : '石化羽毛', num : 10, godFavor : 30, belief : 30},
                    {name : '石化喙', num : 10, godFavor : 30, belief : 30},
                    {name : '石化毛皮', num : 10, godFavor : 30, belief : 30},
                    {name : '石化颊囊', num : 10, godFavor : 40, belief : 40},
                    {name : '圆角', num : 10, godFavor : 40, belief : 40},
                    {name : '石化甲壳', num : 10, godFavor : 40, belief : 40},
                    {name : '石化钳子', num : 10, godFavor : 40, belief : 40},
                    {name : '土毒蝎尾', num : 10, godFavor : 40, belief : 40},
                    {name : '石化大羽', num : 10, godFavor : 40, belief : 40},
                    {name : '石化皮肤', num : 10, godFavor : 40, belief : 40},
                    {name : '石化巨爪', num : 10, godFavor : 40, belief : 40},
                    {name : '石化重瞳', num : 1, godFavor : 50, belief : 50},
                    {name : '石化猿脑', num : 1, godFavor : 50, belief : 50},
                    {name : '龙龟碎壳', num : 2, godFavor : 60, belief : 60},
                ],
            }
        },
        //装备，这里的装备会自动生成图纸
        equip : {
            '鳞刀' : new Element({onlyOne :true, isWeapon : true, atk : 25, def : 5, weight : 20, endurance : 700, voidDust : 250, level : 20, gold : 800}),
            '齿甲' : new Element({onlyOne :true, isArmor : true, def : 30, weight : 10, endurance : 700, voidDust : 250, level : 20, gold : 800}),
            '狼牙棒' : new Element({onlyOne :true, isWeapon : true, atk : 33, def : 10, weight : 30, endurance : 700, voidDust : 300, level : 23, gold : 1000}),
            '山脉皮甲' : new Element({onlyOne :true, isArmor : true, def : 40, weight : 20, endurance : 700, voidDust : 300, level : 23, gold : 1000}),
            '荆棘毒镰' : new Element({onlyOne :true, isWeapon : true, atk : 40, def : 15, weight : 25, endurance : 700, voidDust : 350, level : 27, gold : 1200}),
            '镶嵌石甲' : new Element({onlyOne :true, isArmor : true, def : 50, weight : 30, endurance : 700, voidDust : 350, level : 27, gold : 1200}),
            '山岭重锤' : new Element({onlyOne :true, isWeapon : true, atkSpd : -2, atk : 100, def : 30, hole : 4, weight : 50, endurance : 1000, level : 30, voidDust : 1500, quality : 3, gold : 7500, myAtk : function(item){
                    return parseInt(item.atk * (data.armor && data.armor.name === '山脉之心' ? 1.3 : 1))
                }, text : '装备的护甲为山脉之心时，攻击力提高30%'}),
            '山脉之心' : new Element({onlyOne :true, isArmor : true, atk : 50, def : 180, hp : 1500, hole : 6, weight : 50, endurance : 2000, level : 40, voidDust : 5000, quality : 4, gold : 25000}),
        },
        //商店配置
        shop : {
            '资源' : ['纤维','木材','树枝','燧石','石头','黄水晶','魔力水晶','黑曜石', '魔晶石', '石冉木'],
            '食物' : ['鱼','肉','水','魔兽肉','浆果'],
            '素材' : ['铁锭','铜锭','金锭','硬狼皮', '石化尖牙', '石化鳞片', '石化利爪', '大蛇牙', '石化羽毛', '石化喙', '石化毛皮', '石化颊囊', '圆角', '石化甲壳', '石化钳子', '土毒蝎尾', '石化大羽', '石化皮肤', '石化巨爪', '石化大喙','虚空粉尘','变异核心'],
            '料理' : ['烤肉','烤鱼','烤魔兽肉','鱼汤'],
            '药品' : ['草药','石血藤','猩红药膏'],
            '稀有物品' : ['地穴领主之爪','地穴领主的壳','海象角', '海象皮', '海象牙','石之核', '元素碎石', '神性结晶', '山岭之心', '石巨人之眼', '魔力毛皮','魔力之源', '石化重瞳', '石化猿脑', '龙龟碎壳', '赤土之源', '大地之心'],
        },
        //锻造配方，同时还需要考虑到：药膏，药剂，盾牌，图2（灵魂追猎，遗忘之魂，次元移动），图3（穿甲箭，强化黑火药，魔兽皮包，弓胚：巨人杀手，紫水晶戒指，神性爆弹，）
        forgeRecipes : {
            '鳞刀' : createForgeRecipesCfg({'硬狼皮' : 5,'石化尖牙' : 5, '石化鳞片' : 10, '石化利爪' : 5}),
            '齿甲' : createForgeRecipesCfg({'硬狼皮' : 5,'石化尖牙' : 5, '石化鳞片' : 10, '大蛇牙' : 5}),
            '狼牙棒' : createForgeRecipesCfg({'石化喙' : 5,'圆角' : 5, '石冉木' : 10, '石化颊囊' : 5}),
            '山脉皮甲' : createForgeRecipesCfg({'石化羽毛' : 5,'石化毛皮' : 5, '黄水晶' : 10, '石化尖牙' : 5}),
            '荆棘毒镰' : createForgeRecipesCfg({'石化巨爪' : 10,'石化大喙' : 5, '土毒蝎尾' : 5, '石化钳子' : 5}),
            '镶嵌石甲' : createForgeRecipesCfg({'石化甲壳' : 5,'石化大羽' : 10, '黄水晶' : 5, '石化鳞片' : 10}),
            '山岭重锤' : createForgeRecipesCfg({'石巨人之眼' : 4,'石化重瞳' : 4, '山岭之心' : 3, '铁锭' : 20}),
            '山脉之心' : createForgeRecipesCfg({'龙龟碎壳' : 15, '赤土之源' : 5, '魔力毛皮' : 5, '石化猿脑' : 5}),
        }
    }
};
