//湿地怪物
const map4ShidiMonsters = {
    '人脸蜈蚣' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 31,
        hp : 1000,
        atk : 90,
        def : 20,
        exp : 1300,
        atkSpd : 3,
        type : null,
        items : [{name : '人脸虫甲',minNum : 0, maxNum : 1},{name : '蜈蚣节肢',minNum : 3, maxNum : 5}],
    },
    '泥浆野猪' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 32,
        hp : 1200,
        atk : 105,
        def : 50,
        exp : 1350,
        atkSpd : 3,
        type : null,
        items : [{name : '污泥猪皮',minNum : 1, maxNum : 2},{name : '污泥猪牙',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 2, maxNum : 3}],
    },
    '绿尾蛇' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 33,
        hp : 1300,
        atk : 100,
        def : 25,
        exp : 1400,
        atkSpd : 2,
        type : null,
        items : [{name : '绿蛇鳞',minNum : 1, maxNum : 3},{name : '中空毒牙',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 1, maxNum : 2},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '水蜘蛛' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 34,
        hp : 1200,
        atk : 110,
        def : 30,
        exp : 1450,
        atkSpd : 3,
        type : null,
        items : [{name : '水纹毒丝',minNum : 1, maxNum : 2},{name : '水纹毒牙',minNum : 1, maxNum : 2}],
    },
    '半龙人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        level : 35,
        hp : 2000,
        atk : 100,
        def : 50,
        exp : 1500,
        atkSpd : 3,
        type : null,
        items : [{name : '半龙爪',minNum : 1, maxNum : 2},{name : '半龙尾',minNum : 1, maxNum : 1}],
    },
    '恐鳄' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 36,
        hp : 1700,
        atk : 120,
        def : 60,
        exp : 1600,
        atkSpd : 3,
        type : null,
        items : [{name : '鳄鱼皮',minNum : 1, maxNum : 2},{name : '重鄂',minNum : 1, maxNum : 1}],
    },
    '食脑蚊' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 37,
        hp : 1000,
        atk : 200,
        def : 10,
        exp : 1700,
        atkSpd : 3,
        type : null,
        items : [{name : '长针管',minNum : 1, maxNum : 1},{name : '浓缩脑液',minNum : 1, maxNum : 1}],
    },
    '三角河马' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 38,
        hp : 2300,
        atk : 140,
        def : 70,
        exp : 1800,
        atkSpd : 3,
        type : null,
        items : [{name : '异角',minNum : 1, maxNum : 3},{name : '河马皮',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 2, maxNum : 3}],
    },
    '幼年泰坦蜥' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 39,
        hp : 2100,
        atk : 150,
        def : 50,
        exp : 1900,
        atkSpd : 3,
        type : null,
        items : [{name : '泰坦硬皮',minNum : 1, maxNum : 2},{name : '泰坦菌牙',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 2, maxNum : 3}],
    },
    '黑泥蛞蝓' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 40,
        hp : 2500,
        atk : 130,
        def : 10,
        exp : 2000,
        atkSpd : 1,
        type : null,
        items : [{name : '病毒粘液',minNum : 1, maxNum : 3},{name : '病毒脑核',minNum : 1, maxNum : 1}],
    },
    '暴水獭' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 0,
        level : 40,
        hp : 8000,
        atk : 180,
        def : 50,
        exp : 5000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '红纹毛皮',minNum : 1, maxNum : 2},{name : '红纹大尾',minNum : 1, maxNum : 1},{name : '狂暴内胆',minNum : 1, maxNum : 1}],
    },
    '龙人活尸' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 16000,
        atk : 180,
        def : 100,
        exp : 8000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '龙人残魂',minNum : 1, maxNum : 1},{name : '腐朽龙尾',minNum : 1, maxNum : 1}],
    },
    '龙人祖灵' : {
        tags : ['人型生物','不死族','幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 20000,
        atk : 320,
        def : 50,
        exp : 10000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：荒芜大地',minNum : 1, maxNum : 5},{name : '神性结晶',minNum : 2, maxNum : 3},{name : '龙人神魂',minNum : 1, maxNum : 1},{name : '信仰结晶',minNum : 1, maxNum : 1}],
    },
    '龙人尸山' : {
        tags : ['污染','巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 30000,
        atk : 350,
        def : 40,
        exp : 12000,
        atkSpd : 1,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 100, maxNum : 1},{name : '变异核心',minNum : 500, maxNum : 500}],
    },
    '泰坦蜥' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 80000,
        atk : 150,
        def : 80,
        exp : 50000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '40级武器打孔石',minNum : 1, maxNum : 3},{name : '40级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：8点',minNum : 1, maxNum : 1}],
    },
};

//地图信息
const map4Shidi = {
    index : 3,
    name : '湿地',
    level : [31,40],
    worldBoss : '龙人活尸',
    mythMonster : ['龙人祖灵','绿龙幼崽','龙人尸山'],
    finalBoss : '泰坦蜥',

    //配置
    confs : {
        //地形列表
        terrainArray : [
            '泥潭','土丘','林沼','腐地','死水','河道','密林',//新地形
            '苔洞','遗迹',//本就有但是和原本的同等级地图无重叠的地形
        ],
        //地形可以和哪些其他地形相邻
        terrainJoinTerrain : {
            '泥潭' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '土丘' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '林沼' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '腐地' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '死水' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '河道' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
            '密林' : ['泥潭','土丘','林沼','腐地','死水','河道','密林','苔洞','遗迹'],
        },
        //地形可以和哪些其他地形相邻，这里面的配置会追加到当前已有的地形中
        terrainJoinTerrainAppend : {
            '苔洞' : ['泥潭','土丘','林沼','腐地','死水','河道','密林'],
            '遗迹' : ['泥潭','土丘','林沼','腐地','死水','河道','密林'],
        },
        //每个地形对应的颜色
        terrainColor : {
            '泥潭' : '#a90000',
            '土丘' : '#b3806d',
            '林沼' : '#0007d4',
            '腐地' : '#9c27b0',
            '死水' : '#2196f3',
            '河道' : '#89ccdb',
            '密林' : '#9e9e9e',
        },
        //怪物列表
        monsters : map4ShidiMonsters,
        //采集元素
        elements : {
            //地图上生成的可采集资源
            '毒沼花丛' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 3,getItem : [{name : '毒沼花',minNum : 1, maxNum : 2}]}),
            '泥石' : new Element({canGather :true, mopUp : true, time : 30, num : 1, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '石头',minNum : 1, maxNum : 2},{name : '毒晶',minNum : 0, maxNum : 1}]}),

            //本地图的元素，例如：药剂，药膏，背包，盾牌，装备，坐骑，投掷品，弓胚
            '毒沼花' : new Element({voidDust : 10, gold : 50, elemental : {土 : 5}}),
            '毒晶' : new Element({canUse : true, hp : 3, voidDust : 6, gold : 30, elemental : {木 : 1}}),

            '狂暴心脉精华' : new Element({battleUse : true, voidDust : 30, gold : 250, func(){
                    if(hasStatus(data, '狂暴') || hasStatus(data, '虚弱')){
                        winMsg(`没有狂暴和虚弱状态时才能使用`, false, false)
                        return false;
                    }

                    addStatus(data, getStatus('狂暴'))
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    const text = `使用了狂暴心脉精华，恢复${battleAddHp(data, addHp)}HP，获得狂暴状态`;
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let add = parseInt(data.maxHp * 0.15);
                    if(add < 200){
                        add = 200;
                    }
                    return add;
                }, text : '没有狂暴和虚弱状态时才能使用，恢复15%血量，最少200点，给自己附加狂暴状态，增加100攻击，持续10回合。狂暴状态消失时，提供的100攻击力消失，并给自己附加虚弱状态，降低自身150攻击力和50防御力，持续5回合'}),
            '病毒吹箭' : new Element({isThrow : true, atk : 100, weight : 5, endurance : 1, voidDust : 200, gold : 1000, throwFunc(){
                    addStatus(data.battleMonster, getStatus('中毒', {harm : 300, num : 3}))
                }, text : '给怪物附加中毒状态，每回合造成300伤害，持续3回合'}),
        },
        //地形下的怪物和资源，如果是已有的地形，则会在原本的基础上追加，否则会新建，要注意得有上个地图的守关BOSS
        terrainElements : {
            '泥潭' : {
                monster : {
                    人脸蜈蚣 : 60,
                    泥浆野猪 : 80,
                    水蜘蛛 : 30,
                    恐鳄 : 70,
                    三角河马 : 90,
                },
                elements : {
                    ...terrainElement('水源', [2,3], 5),
                    ...terrainElement('泥石', [1,3], 3),
                }
            },
            '土丘' : {
                monster : {
                    泥浆野猪 : 40,
                    恐鳄 : 30,
                    半龙人 : 80,
                    幼年泰坦蜥 : 70,
                    兽人酋长 : 10,
                },
                elements : {
                    ...terrainElement('浆果丛', [0,1], 2),
                    ...terrainElement('草丛', [1,2], 3),
                    ...terrainElement('草药丛', [0,1], 2),
                    ...terrainElement('树木', [1,2], 3),
                }
            },
            '林沼' : {
                monster : {
                    人脸蜈蚣 : 80,
                    绿尾蛇 : 90,
                    水蜘蛛 : 60,
                    恐鳄 : 80,
                    暴水獭 : 5,
                },
                elements : {
                    ...terrainElement('水源', [2,3], 5),
                    ...terrainElement('鱼群', [0,1], 2),
                    ...terrainElement('芦苇从', [1,2], 3),
                    ...terrainElement('毒沼花丛', [1,2], 3),
                    ...terrainElement('树木', [2,3], 5),
                    ...terrainElement('泥石', [1,3], 3),
                }
            },
            '腐地' : {
                monster : {
                    人脸蜈蚣 : 60,
                    绿尾蛇 : 90,
                    黑泥蛞蝓 : 90,
                },
                elements : {
                    ...terrainElement('草药丛', [0,1], 2),
                    ...terrainElement('毒沼花丛', [0,1], 2),
                    ...terrainElement('树木', [2,3], 4),
                }
            },
            '死水' : {
                monster : {
                    绿尾蛇 : 70,
                    水蜘蛛 : 90,
                    食脑蚊 : 90,
                    幼年泰坦蜥 : 80,
                    暴水獭 : 5,
                },
                elements : {
                    ...terrainElement('水源', [2,3], 5),
                    ...terrainElement('草药丛', [0,1], 2),
                    ...terrainElement('毒沼花丛', [0,1], 2),
                    ...terrainElement('树木', [2,3], 4),
                }
            },
            '河道' : {
                monster : {
                    绿尾蛇 : 90,
                    水蜘蛛 : 80,
                    恐鳄 : 70,
                    三角河马 : 90,
                    暴水獭 : 5,
                },
                elements : {
                    ...terrainElement('水源', [2,3], 5),
                    ...terrainElement('鱼群', [2,3], 5),
                }
            },
            '密林' : {
                monster : {
                    人脸蜈蚣 : 60,
                    泥浆野猪 : 20,
                    绿尾蛇 : 80,
                    半龙人 : 50,
                    幼年泰坦蜥 : 90,
                    黑泥蛞蝓 : 70,
                    重瞳魔猿 : 10,
                },
                elements : {
                    ...terrainElement('浆果丛', [1,2], 3),
                    ...terrainElement('草丛', [2,3], 4),
                    ...terrainElement('草药丛', [1,3], 4),
                    ...terrainElement('树木', [2,4], 5),
                }
            },
            '苔洞' : {
                monster : {
                    人脸蜈蚣 : 90,
                    绿尾蛇 : 80,
                    食脑蚊 : 50,
                    黑泥蛞蝓 : 90,
                },
                elements : {

                }
            },
            '遗迹' : {
                monster : {
                    人脸蜈蚣 : 50,
                    半龙人 : 90,
                    幼年泰坦蜥 : 70,
                },
                elements : {

                }
            },
        },
        //怪物掉落物品
        monsterItems : {
            '人脸虫甲' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {金 : 3, 木 : 2}}),
            '蜈蚣节肢' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {金 : 2, 木 : 1}}),
            '污泥猪皮' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {木 : 4, 土 : 2}}),
            '污泥猪牙' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {金 : 5, 木 : 1}}),
            '绿蛇鳞' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 4, 木 : 1}}),
            '中空毒牙' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 2, 木 : 5}}),
            '水纹毒丝' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {木 : 3, 水 : 2}}),
            '水纹毒牙' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 2, 水 : 6}}),
            '半龙爪' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 1, 木 : 5}}),
            '半龙尾' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 1, 木 : 6}}),
            '鳄鱼皮' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 4, 土 : 6}}),
            '重鄂' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 6, 木 : 3}}),
            '长针管' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 2, 木 : 5}}),
            '浓缩脑液' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 6, 水 : 3}}),
            '异角' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 7, 木 : 2}}),
            '河马皮' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 5, 土 : 4}}),
            '泰坦硬皮' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {木 : 4, 土 : 6}}),
            '泰坦菌牙' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {木 : 7, 土 : 3}}),
            '病毒粘液' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {木 : 2, 水 : 7}}),
            '病毒脑核' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {木 : 4, 土 : 5}}),
            '红纹毛皮' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {水 : 10, 极 : 10}}),
            '红纹大尾' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {水 : 10, 极 : 10}}),
            '狂暴内胆' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {木 : 10, 极 : 10}}),
            '龙人残魂' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {极 : 15}}),
            '腐朽龙尾' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {木 : 10, 土 : 5}}),
            '龙人神魂' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {极 : 20}}),
            '信仰结晶' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {极 : 20}}),
        },
        //芦苇，毒沼花，毒晶，石头，
        /**
         * --'人脸蜈蚣',{name : '人脸虫甲',minNum : 0, maxNum : 1},{name : '蜈蚣节肢',minNum : 3, maxNum : 5}
         * --'泥浆野猪',{name : '污泥猪皮',minNum : 1, maxNum : 2},{name : '污泥猪牙',minNum : 1, maxNum : 2}
         * --'绿尾蛇',{name : '绿蛇鳞',minNum : 1, maxNum : 3},{name : '中空毒牙',minNum : 1, maxNum : 2}
         * --'水蜘蛛',{name : '水纹毒丝',minNum : 1, maxNum : 2},{name : '水纹毒牙',minNum : 1, maxNum : 2}
         * --'半龙人',{name : '半龙爪',minNum : 1, maxNum : 2},{name : '半龙尾',minNum : 1, maxNum : 1}
         * --'恐鳄',{name : '鳄鱼皮',minNum : 1, maxNum : 2},{name : '重鄂',minNum : 1, maxNum : 1}
         * --'食脑蚊',{name : '长针管',minNum : 1, maxNum : 1},{name : '浓缩脑液',minNum : 1, maxNum : 1}
         * --'三角河马',{name : '异角',minNum : 1, maxNum : 3},{name : '河马皮',minNum : 1, maxNum : 2}
         * --'幼年泰坦蜥',{name : '泰坦硬皮',minNum : 1, maxNum : 2},{name : '泰坦菌牙',minNum : 1, maxNum : 2}
         * --'黑泥蛞蝓',{name : '病毒粘液',minNum : 1, maxNum : 3},{name : '病毒脑核',minNum : 1, maxNum : 1}
         * '暴水獭',{name : '红纹毛皮',minNum : 1, maxNum : 2},{name : '红纹大尾',minNum : 1, maxNum : 1},{name : '狂暴内胆',minNum : 1, maxNum : 1}
         * '龙人活尸',{name : '龙人残魂',minNum : 1, maxNum : 1},{name : '腐朽龙尾',minNum : 1, maxNum : 1}
         * '龙人祖灵',{name : '龙人神魂',minNum : 1, maxNum : 1},{name : '信仰结晶',minNum : 1, maxNum : 1}
         */
        //怪物技能
        monsterSkill : {
            人脸蜈蚣 : ['毒牙'],
            绿尾蛇 : ['毒牙'],
            水蜘蛛 : ['毒牙'],
            暴水獭 : [{
                name : '狂抓',
                extend : '二连斩'
            }],
            龙人活尸 : [{
                name : '尸毒爪',
                type : 'atk',
                normalAtk : true,
                text : '代替普通攻击使用，造成1倍伤害，当玩家有尸毒状态时，20%几率造成2倍伤害。并给玩家附加尸毒状态，每回合造成怪物攻击力20%的伤害，持续3回合',
                check : function(){return true},
                getStatus : function(){
                    return getStatus('尸毒', {num : 3, harm : parseInt(data.battleMonster.atk * 0.2)})
                },
                getNum : function(){return hasStatus(data, '尸毒') ? data.battleMonster.atk * (randomNum() <= 20 ? 2 : 1) : data.battleMonster.atk},
            }],
            龙人祖灵 : [{
                name : '灵魂威压',
                type : 'atk',
                text : '百分之10%几率使用，造成0.5倍伤害，无视防御，并使玩家陷入僵直状态，无法行动，持续2回合',
                check : function(){
                    return randomNum(1,100) <= 10;
                },
                getStatus : function(){
                    return getStatus('僵直', {num : 2})
                },
                getNum : function(){return parseInt(data.battleMonster.atk * 0.5) + data.def},
            },{
                name : '灵魂撕咬',
                type : 'atk',
                normalAtk : true,
                text : '代替普通攻击使用，造成1倍伤害，无视防御',
                check : function(){return true},
                getStatus : function(){
                    return null
                },
                getNum : function(){return data.battleMonster.atk + data.def},
            }],
            龙人尸山 : ['血肉转移'],
            泰坦蜥 : [{
                name : '碾压',
                type : 'atk',
                normalAtk : true,
                text : '代替普通攻击使用，造成攻击力+玩家生命上限的5%的伤害，无视防御。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
                check : function(){return true},
                getStatus : function(){
                    worldBossAddAttr();
                    return null
                },
                getNum : function(){return data.battleMonster.atk + parseInt(data.maxHp * 0.05)},
            },'世界之力'],
        },
        //神殿配置
        deity : {
            水之女神 : {
                hates : [
                    {name : '人脸蜈蚣', num : 10, godFavor : 40, belief : 40},
                    {name : '绿尾蛇', num : 10, godFavor : 40, belief : 40},
                    {name : '水蜘蛛', num : 10, godFavor : 40, belief : 40},
                    {name : '食脑蚊', num : 10, godFavor : 50, belief : 50},
                    {name : '黑泥蛞蝓', num : 10, godFavor : 50, belief : 50},
                    {name : '龙人活尸', num : 1, godFavor : 80, belief : 80},
                ],
                likes : [
                    {name : '信仰结晶', num : 1, godFavor : 80, belief : 80},
                ],
            },
            狩猎之神 : {
                hates : [
                    {name : '人脸蜈蚣', num : 10, godFavor : 40, belief : 40},
                    {name : '泥浆野猪', num : 10, godFavor : 40, belief : 40},
                    {name : '绿尾蛇', num : 10, godFavor : 40, belief : 40},
                    {name : '恐鳄', num : 10, godFavor : 50, belief : 50},
                    {name : '三角河马', num : 10, godFavor : 50, belief : 50},
                    {name : '幼年泰坦蜥', num : 10, godFavor : 50, belief : 50},
                    {name : '暴水獭', num : 1, godFavor : 70, belief : 70},
                ],
                likes : [
                    {name : '人脸虫甲', num : 10, godFavor : 40, belief : 40},
                    {name : '蜈蚣节肢', num : 10, godFavor : 40, belief : 40},
                    {name : '污泥猪皮', num : 10, godFavor : 40, belief : 40},
                    {name : '污泥猪牙', num : 10, godFavor : 40, belief : 40},
                    {name : '绿蛇鳞', num : 10, godFavor : 40, belief : 40},
                    {name : '水纹毒丝', num : 10, godFavor : 40, belief : 40},
                    {name : '水纹毒牙', num : 10, godFavor : 40, belief : 40},
                    {name : '鳄鱼皮', num : 10, godFavor : 50, belief : 50},
                    {name : '重鄂', num : 10, godFavor : 50, belief : 50},
                    {name : '异角', num : 10, godFavor : 50, belief : 50},
                    {name : '河马皮', num : 10, godFavor : 50, belief : 50},
                    {name : '泰坦硬皮', num : 10, godFavor : 50, belief : 50},
                    {name : '泰坦菌牙', num : 10, godFavor : 50, belief : 50},
                    {name : '红纹毛皮', num : 1, godFavor : 70, belief : 70},
                    {name : '红纹大尾', num : 1, godFavor : 70, belief : 70},
                    {name : '狂暴内胆', num : 1, godFavor : 70, belief : 70},
                ],
            }
        },
        //装备，这里的装备会自动生成图纸
        equip : {
            '荆棘毒鞭' : new Element({onlyOne :true, isWeapon : true, atk : 65, weight : 10, endurance : 600, voidDust : 400, level : 33, gold : 2000, skills : {
                    '毒击': createRecipesCfg({'纤维': 1}),
                }}),
            '污泥鳞甲' : new Element({onlyOne :true, isArmor : true, def : 75, weight : 10, endurance : 500, voidDust : 400, level : 33, gold : 2000}),
            '水纹钉耙' : new Element({onlyOne :true, isWeapon : true, atk : 75, weight : 15, endurance : 600, voidDust : 500, level : 37, gold : 2500, skills : {
                    '毒击': createRecipesCfg({'纤维': 1}),
                }}),
            '野兽皮肤' : new Element({onlyOne :true, isArmor : true, def : 90, weight : 20, endurance : 500, voidDust : 500, level : 37, gold : 2500}),
            '病菌手爪' : new Element({onlyOne :true, isWeapon : true, atk : 85, weight : 15, endurance : 600, voidDust : 600, level : 40, gold : 3000, skills : {
                    '毒击': createRecipesCfg({'纤维': 1}),
                }}),
            '病菌皮甲' : new Element({onlyOne :true, isArmor : true, def : 105, weight : 30, endurance : 500, voidDust : 600, level : 40, gold : 3000}),
            '红纹骨鞭' : new Element({onlyOne :true, isWeapon : true, atkSpd : 2, atk : 120, weight : 20, hole : 4, endurance : 1000, voidDust : 2000, level : 40, quality : 3, gold : 10000, myAtk : function(item){
                    return parseInt(data.battleMonster && data.battleMonster.level > data.level ? item.atk * 2 : item.atk)
                }, skills : {
                    '毒击': createRecipesCfg({'纤维': 1}),
                }}),
            '龙人咆哮' : new Element({onlyOne :true, isArmor : true, atk : 50, def : 200, hp : 1000, hole : 6, weight : 30, endurance : 2000, level : 50, voidDust : 20000, quality : 4, gold : 100000, fixNeedDust: 2, onStartBattle(){
                addStatus(data, getStatus('毒素免疫'))
                }, text : '进入战斗时获得“毒素免疫”状态，不会被附加其他名字带有“毒”的状态，该状态不会自动消失'}),
        },
        //商店配置
        shop : {
            '资源' : ['纤维','木材','树枝','石头','芦苇', '魔晶石','毒沼花','毒晶'],
            '食物' : ['鱼','水','魔兽肉','浆果','蘑菇'],
            '素材' : ['人脸虫甲', '蜈蚣节肢', '污泥猪皮', '污泥猪牙', '绿蛇鳞', '中空毒牙', '水纹毒丝', '水纹毒牙', '半龙爪', '半龙尾', '鳄鱼皮', '重鄂', '长针管', '浓缩脑液', '异角', '河马皮', '泰坦硬皮','泰坦菌牙','病毒粘液','病毒脑核','兽人之牙','兽人之心'],
            '料理' : ['烤肉','烤魔兽肉','鱼汤'],
            '药品' : ['草药','微光蘑菇'],
            '稀有物品' : ['红纹毛皮','红纹大尾','狂暴内胆','龙人残魂', '腐朽龙尾', '龙人神魂','信仰结晶', '神性结晶','疯狂之血','疯狂的心','魔力毛皮','石化重瞳','石化猿脑','幼龙鳞','幼龙皮'],
        },
        //锻造配方，同时还需要考虑到：药膏，药剂，盾牌，投掷品，怪物物品DLC
        // 图2（灵魂追猎，遗忘之魂，次元移动），
        // 图3（穿甲箭，强化黑火药，魔兽皮包，弓胚：巨人杀手，紫水晶戒指，神性爆弹，）
        // 图4（魔蛟心脉精华，巨龙幼崽，骨刺炸药，珍贵皮包）
        forgeRecipes : {
            '荆棘毒鞭' : createForgeRecipesCfg({'蜈蚣节肢' : 20,'污泥猪牙' : 5, '中空毒牙' : 5, '污泥猪皮' : 5}),
            '污泥鳞甲' : createForgeRecipesCfg({'人脸虫甲' : 5,'污泥猪皮' : 5, '绿蛇鳞' : 10, '蜈蚣节肢' : 20}),
            '水纹钉耙' : createForgeRecipesCfg({'水纹毒丝' : 5,'水纹毒牙' : 5, '半龙爪' : 5, '长针管' : 5}),
            '野兽皮肤' : createForgeRecipesCfg({'水纹毒丝' : 5,'半龙尾' : 5, '鳄鱼皮' : 5, '重鄂' : 5, '浓缩脑液' : 5}),
            '病菌手爪' : createForgeRecipesCfg({'异角' : 10,'泰坦菌牙' : 5, '病毒粘液' : 10, '病毒脑核' : 5, '毒晶' : 5}),
            '病菌皮甲' : createForgeRecipesCfg({'河马皮' : 5,'泰坦硬皮' : 5, '病毒粘液' : 10, '病毒脑核' : 5, '毒晶' : 5}),
            '红纹骨鞭' : createForgeRecipesCfg({'红纹毛皮' : 5,'红纹大尾' : 3, '腐朽龙尾' : 3, '病毒脑核' : 5}),
            '龙人咆哮' : createForgeRecipesCfg({'龙人残魂' : 5, '龙人神魂' : 5, '信仰结晶' : 5}),
        }
    }
};
